--megafunction wizard: %Altera SOPC Builder%
--GENERATION: STANDARD
--VERSION: WM1.0


--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity DM9000A_avalon_slave_arbitrator is 
        port (
              -- inputs:
                 signal DM9000A_avalon_slave_irq : IN STD_LOGIC;
                 signal DM9000A_avalon_slave_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal DM9000A_avalon_slave_address : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_chipselect_n : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_irq_from_sa : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_read_n : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal DM9000A_avalon_slave_reset_n : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_wait_counter_eq_1 : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_write_n : OUT STD_LOGIC;
                 signal DM9000A_avalon_slave_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_data_master_granted_DM9000A_avalon_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_DM9000A_avalon_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_DM9000A_avalon_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_DM9000A_avalon_slave : OUT STD_LOGIC;
                 signal d1_DM9000A_avalon_slave_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of DM9000A_avalon_slave_arbitrator : entity is FALSE;
end entity DM9000A_avalon_slave_arbitrator;


architecture europa of DM9000A_avalon_slave_arbitrator is
                signal DM9000A_avalon_slave_allgrants :  STD_LOGIC;
                signal DM9000A_avalon_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal DM9000A_avalon_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal DM9000A_avalon_slave_any_continuerequest :  STD_LOGIC;
                signal DM9000A_avalon_slave_arb_counter_enable :  STD_LOGIC;
                signal DM9000A_avalon_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal DM9000A_avalon_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal DM9000A_avalon_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal DM9000A_avalon_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal DM9000A_avalon_slave_begins_xfer :  STD_LOGIC;
                signal DM9000A_avalon_slave_counter_load_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal DM9000A_avalon_slave_end_xfer :  STD_LOGIC;
                signal DM9000A_avalon_slave_firsttransfer :  STD_LOGIC;
                signal DM9000A_avalon_slave_grant_vector :  STD_LOGIC;
                signal DM9000A_avalon_slave_in_a_read_cycle :  STD_LOGIC;
                signal DM9000A_avalon_slave_in_a_write_cycle :  STD_LOGIC;
                signal DM9000A_avalon_slave_master_qreq_vector :  STD_LOGIC;
                signal DM9000A_avalon_slave_non_bursting_master_requests :  STD_LOGIC;
                signal DM9000A_avalon_slave_reg_firsttransfer :  STD_LOGIC;
                signal DM9000A_avalon_slave_slavearbiterlockenable :  STD_LOGIC;
                signal DM9000A_avalon_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal DM9000A_avalon_slave_unreg_firsttransfer :  STD_LOGIC;
                signal DM9000A_avalon_slave_wait_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal DM9000A_avalon_slave_waits_for_read :  STD_LOGIC;
                signal DM9000A_avalon_slave_waits_for_write :  STD_LOGIC;
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_DM9000A_avalon_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_DM9000A_avalon_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_DM9000A_avalon_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_DM9000A_avalon_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_DM9000A_avalon_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_DM9000A_avalon_slave :  STD_LOGIC;
                signal shifted_address_to_DM9000A_avalon_slave_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_DM9000A_avalon_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT DM9000A_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  DM9000A_avalon_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_DM9000A_avalon_slave);
  --assign DM9000A_avalon_slave_readdata_from_sa = DM9000A_avalon_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  DM9000A_avalon_slave_readdata_from_sa <= DM9000A_avalon_slave_readdata;
  internal_cpu_data_master_requests_DM9000A_avalon_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("10001000000000111100010100000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --DM9000A_avalon_slave_arb_share_counter set values, which is an e_mux
  DM9000A_avalon_slave_arb_share_set_values <= std_logic_vector'("001");
  --DM9000A_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  DM9000A_avalon_slave_non_bursting_master_requests <= internal_cpu_data_master_requests_DM9000A_avalon_slave;
  --DM9000A_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  DM9000A_avalon_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --DM9000A_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  DM9000A_avalon_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(DM9000A_avalon_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (DM9000A_avalon_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(DM9000A_avalon_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (DM9000A_avalon_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --DM9000A_avalon_slave_allgrants all slave grants, which is an e_mux
  DM9000A_avalon_slave_allgrants <= DM9000A_avalon_slave_grant_vector;
  --DM9000A_avalon_slave_end_xfer assignment, which is an e_assign
  DM9000A_avalon_slave_end_xfer <= NOT ((DM9000A_avalon_slave_waits_for_read OR DM9000A_avalon_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_DM9000A_avalon_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_DM9000A_avalon_slave <= DM9000A_avalon_slave_end_xfer AND (((NOT DM9000A_avalon_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --DM9000A_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  DM9000A_avalon_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_DM9000A_avalon_slave AND DM9000A_avalon_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_DM9000A_avalon_slave AND NOT DM9000A_avalon_slave_non_bursting_master_requests));
  --DM9000A_avalon_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      DM9000A_avalon_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(DM9000A_avalon_slave_arb_counter_enable) = '1' then 
        DM9000A_avalon_slave_arb_share_counter <= DM9000A_avalon_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --DM9000A_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      DM9000A_avalon_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((DM9000A_avalon_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_DM9000A_avalon_slave)) OR ((end_xfer_arb_share_counter_term_DM9000A_avalon_slave AND NOT DM9000A_avalon_slave_non_bursting_master_requests)))) = '1' then 
        DM9000A_avalon_slave_slavearbiterlockenable <= or_reduce(DM9000A_avalon_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master DM9000A/avalon_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= DM9000A_avalon_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --DM9000A_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  DM9000A_avalon_slave_slavearbiterlockenable2 <= or_reduce(DM9000A_avalon_slave_arb_share_counter_next_value);
  --cpu/data_master DM9000A/avalon_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= DM9000A_avalon_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --DM9000A_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  DM9000A_avalon_slave_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_DM9000A_avalon_slave <= internal_cpu_data_master_requests_DM9000A_avalon_slave;
  --DM9000A_avalon_slave_writedata mux, which is an e_mux
  DM9000A_avalon_slave_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_DM9000A_avalon_slave <= internal_cpu_data_master_qualified_request_DM9000A_avalon_slave;
  --cpu/data_master saved-grant DM9000A/avalon_slave, which is an e_assign
  cpu_data_master_saved_grant_DM9000A_avalon_slave <= internal_cpu_data_master_requests_DM9000A_avalon_slave;
  --allow new arb cycle for DM9000A/avalon_slave, which is an e_assign
  DM9000A_avalon_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  DM9000A_avalon_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  DM9000A_avalon_slave_master_qreq_vector <= std_logic'('1');
  --DM9000A_avalon_slave_reset_n assignment, which is an e_assign
  DM9000A_avalon_slave_reset_n <= reset_n;
  DM9000A_avalon_slave_chipselect_n <= NOT internal_cpu_data_master_granted_DM9000A_avalon_slave;
  --DM9000A_avalon_slave_firsttransfer first transaction, which is an e_assign
  DM9000A_avalon_slave_firsttransfer <= A_WE_StdLogic((std_logic'(DM9000A_avalon_slave_begins_xfer) = '1'), DM9000A_avalon_slave_unreg_firsttransfer, DM9000A_avalon_slave_reg_firsttransfer);
  --DM9000A_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  DM9000A_avalon_slave_unreg_firsttransfer <= NOT ((DM9000A_avalon_slave_slavearbiterlockenable AND DM9000A_avalon_slave_any_continuerequest));
  --DM9000A_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      DM9000A_avalon_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(DM9000A_avalon_slave_begins_xfer) = '1' then 
        DM9000A_avalon_slave_reg_firsttransfer <= DM9000A_avalon_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --DM9000A_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  DM9000A_avalon_slave_beginbursttransfer_internal <= DM9000A_avalon_slave_begins_xfer;
  --~DM9000A_avalon_slave_read_n assignment, which is an e_mux
  DM9000A_avalon_slave_read_n <= NOT ((((internal_cpu_data_master_granted_DM9000A_avalon_slave AND cpu_data_master_read)) AND NOT DM9000A_avalon_slave_begins_xfer));
  --~DM9000A_avalon_slave_write_n assignment, which is an e_mux
  DM9000A_avalon_slave_write_n <= NOT (((((internal_cpu_data_master_granted_DM9000A_avalon_slave AND cpu_data_master_write)) AND NOT DM9000A_avalon_slave_begins_xfer) AND to_std_logic((((std_logic_vector'("00000000000000000000000000000") & (DM9000A_avalon_slave_wait_counter))>=std_logic_vector'("00000000000000000000000000000001"))))));
  shifted_address_to_DM9000A_avalon_slave_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --DM9000A_avalon_slave_address mux, which is an e_mux
  DM9000A_avalon_slave_address <= Vector_To_Std_Logic(A_SRL(shifted_address_to_DM9000A_avalon_slave_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")));
  --d1_DM9000A_avalon_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_DM9000A_avalon_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_DM9000A_avalon_slave_end_xfer <= DM9000A_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  --DM9000A_avalon_slave_wait_counter_eq_1 assignment, which is an e_assign
  DM9000A_avalon_slave_wait_counter_eq_1 <= to_std_logic(((std_logic_vector'("00000000000000000000000000000") & (DM9000A_avalon_slave_wait_counter)) = std_logic_vector'("00000000000000000000000000000001")));
  --DM9000A_avalon_slave_waits_for_read in a cycle, which is an e_mux
  DM9000A_avalon_slave_waits_for_read <= DM9000A_avalon_slave_in_a_read_cycle AND wait_for_DM9000A_avalon_slave_counter;
  --DM9000A_avalon_slave_in_a_read_cycle assignment, which is an e_assign
  DM9000A_avalon_slave_in_a_read_cycle <= internal_cpu_data_master_granted_DM9000A_avalon_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= DM9000A_avalon_slave_in_a_read_cycle;
  --DM9000A_avalon_slave_waits_for_write in a cycle, which is an e_mux
  DM9000A_avalon_slave_waits_for_write <= DM9000A_avalon_slave_in_a_write_cycle AND wait_for_DM9000A_avalon_slave_counter;
  --DM9000A_avalon_slave_in_a_write_cycle assignment, which is an e_assign
  DM9000A_avalon_slave_in_a_write_cycle <= internal_cpu_data_master_granted_DM9000A_avalon_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= DM9000A_avalon_slave_in_a_write_cycle;
  internal_DM9000A_avalon_slave_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("00000000000000000000000000000") & (DM9000A_avalon_slave_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      DM9000A_avalon_slave_wait_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        DM9000A_avalon_slave_wait_counter <= DM9000A_avalon_slave_counter_load_value;
      end if;
    end if;

  end process;

  DM9000A_avalon_slave_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((DM9000A_avalon_slave_in_a_read_cycle AND DM9000A_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000000101"), A_WE_StdLogicVector((std_logic'(((DM9000A_avalon_slave_in_a_write_cycle AND DM9000A_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000000110"), A_WE_StdLogicVector((std_logic'((NOT internal_DM9000A_avalon_slave_wait_counter_eq_0)) = '1'), ((std_logic_vector'("000000000000000000000000000000") & (DM9000A_avalon_slave_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 3);
  wait_for_DM9000A_avalon_slave_counter <= DM9000A_avalon_slave_begins_xfer OR NOT internal_DM9000A_avalon_slave_wait_counter_eq_0;
  --assign DM9000A_avalon_slave_irq_from_sa = DM9000A_avalon_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  DM9000A_avalon_slave_irq_from_sa <= DM9000A_avalon_slave_irq;
  --vhdl renameroo for output signals
  DM9000A_avalon_slave_wait_counter_eq_0 <= internal_DM9000A_avalon_slave_wait_counter_eq_0;
  --vhdl renameroo for output signals
  cpu_data_master_granted_DM9000A_avalon_slave <= internal_cpu_data_master_granted_DM9000A_avalon_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_DM9000A_avalon_slave <= internal_cpu_data_master_qualified_request_DM9000A_avalon_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_DM9000A_avalon_slave <= internal_cpu_data_master_requests_DM9000A_avalon_slave;
--synthesis translate_off
    --DM9000A/avalon_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_jtag_debug_module_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC;
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                 signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_jtag_debug_module_arbitrator : entity is FALSE;
end entity cpu_jtag_debug_module_arbitrator;


architecture europa of cpu_jtag_debug_module_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock :  STD_LOGIC;
                signal cpu_instruction_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_instruction_master_continuerequest :  STD_LOGIC;
                signal cpu_instruction_master_saved_grant_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_jtag_debug_module_allgrants :  STD_LOGIC;
                signal cpu_jtag_debug_module_allow_new_arb_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_any_bursting_master_saved_grant :  STD_LOGIC;
                signal cpu_jtag_debug_module_any_continuerequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_addend :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_counter_enable :  STD_LOGIC;
                signal cpu_jtag_debug_module_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal cpu_jtag_debug_module_arb_winner :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_arbitration_holdoff_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_beginbursttransfer_internal :  STD_LOGIC;
                signal cpu_jtag_debug_module_begins_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_chosen_master_double_vector :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chosen_master_rot_left :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_grant_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_in_a_read_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_in_a_write_cycle :  STD_LOGIC;
                signal cpu_jtag_debug_module_master_qreq_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_non_bursting_master_requests :  STD_LOGIC;
                signal cpu_jtag_debug_module_reg_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_saved_chosen_master_vector :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_jtag_debug_module_slavearbiterlockenable :  STD_LOGIC;
                signal cpu_jtag_debug_module_slavearbiterlockenable2 :  STD_LOGIC;
                signal cpu_jtag_debug_module_unreg_firsttransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_read :  STD_LOGIC;
                signal cpu_jtag_debug_module_waits_for_write :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_cpu_jtag_debug_module :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal internal_cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module :  STD_LOGIC;
                signal shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_cpu_jtag_debug_module_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begins_xfer <= NOT d1_reasons_to_wait AND ((internal_cpu_data_master_qualified_request_cpu_jtag_debug_module OR internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module));
  --assign cpu_jtag_debug_module_readdata_from_sa = cpu_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_readdata_from_sa <= cpu_jtag_debug_module_readdata;
  internal_cpu_data_master_requests_cpu_jtag_debug_module <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("10001000000000110100000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --cpu_jtag_debug_module_arb_share_counter set values, which is an e_mux
  cpu_jtag_debug_module_arb_share_set_values <= std_logic_vector'("001");
  --cpu_jtag_debug_module_non_bursting_master_requests mux, which is an e_mux
  cpu_jtag_debug_module_non_bursting_master_requests <= ((internal_cpu_data_master_requests_cpu_jtag_debug_module OR internal_cpu_instruction_master_requests_cpu_jtag_debug_module) OR internal_cpu_data_master_requests_cpu_jtag_debug_module) OR internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_any_bursting_master_saved_grant mux, which is an e_mux
  cpu_jtag_debug_module_any_bursting_master_saved_grant <= std_logic'('0');
  --cpu_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  cpu_jtag_debug_module_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (cpu_jtag_debug_module_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --cpu_jtag_debug_module_allgrants all slave grants, which is an e_mux
  cpu_jtag_debug_module_allgrants <= ((or_reduce(cpu_jtag_debug_module_grant_vector) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector)) OR or_reduce(cpu_jtag_debug_module_grant_vector);
  --cpu_jtag_debug_module_end_xfer assignment, which is an e_assign
  cpu_jtag_debug_module_end_xfer <= NOT ((cpu_jtag_debug_module_waits_for_read OR cpu_jtag_debug_module_waits_for_write));
  --end_xfer_arb_share_counter_term_cpu_jtag_debug_module arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_cpu_jtag_debug_module <= cpu_jtag_debug_module_end_xfer AND (((NOT cpu_jtag_debug_module_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --cpu_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  cpu_jtag_debug_module_arb_counter_enable <= ((end_xfer_arb_share_counter_term_cpu_jtag_debug_module AND cpu_jtag_debug_module_allgrants)) OR ((end_xfer_arb_share_counter_term_cpu_jtag_debug_module AND NOT cpu_jtag_debug_module_non_bursting_master_requests));
  --cpu_jtag_debug_module_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_arb_counter_enable) = '1' then 
        cpu_jtag_debug_module_arb_share_counter <= cpu_jtag_debug_module_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((or_reduce(cpu_jtag_debug_module_master_qreq_vector) AND end_xfer_arb_share_counter_term_cpu_jtag_debug_module)) OR ((end_xfer_arb_share_counter_term_cpu_jtag_debug_module AND NOT cpu_jtag_debug_module_non_bursting_master_requests)))) = '1' then 
        cpu_jtag_debug_module_slavearbiterlockenable <= or_reduce(cpu_jtag_debug_module_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --cpu_jtag_debug_module_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  cpu_jtag_debug_module_slavearbiterlockenable2 <= or_reduce(cpu_jtag_debug_module_arb_share_counter_next_value);
  --cpu/data_master cpu/jtag_debug_module arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= cpu_jtag_debug_module_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --cpu/instruction_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  cpu_instruction_master_arbiterlock <= cpu_jtag_debug_module_slavearbiterlockenable AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master cpu/jtag_debug_module arbiterlock2, which is an e_assign
  cpu_instruction_master_arbiterlock2 <= cpu_jtag_debug_module_slavearbiterlockenable2 AND cpu_instruction_master_continuerequest;
  --cpu/instruction_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_instruction_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_instruction_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_instruction_master_continuerequest continued request, which is an e_mux
  cpu_instruction_master_continuerequest <= last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  cpu_jtag_debug_module_any_continuerequest <= cpu_instruction_master_continuerequest OR cpu_data_master_continuerequest;
  internal_cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module AND NOT (((((NOT cpu_data_master_waitrequest) AND cpu_data_master_write)) OR cpu_instruction_master_arbiterlock));
  --cpu_jtag_debug_module_writedata mux, which is an e_mux
  cpu_jtag_debug_module_writedata <= cpu_data_master_writedata;
  --mux cpu_jtag_debug_module_debugaccess, which is an e_mux
  cpu_jtag_debug_module_debugaccess <= cpu_data_master_debugaccess;
  internal_cpu_instruction_master_requests_cpu_jtag_debug_module <= ((to_std_logic(((Std_Logic_Vector'(cpu_instruction_master_address_to_slave(28 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("10001000000000110100000000000")))) AND (cpu_instruction_master_read))) AND cpu_instruction_master_read;
  --cpu/data_master granted cpu/jtag_debug_module last time, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(cpu_data_master_saved_grant_cpu_jtag_debug_module) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_arbitration_holdoff_internal OR NOT internal_cpu_data_master_requests_cpu_jtag_debug_module))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module))))));
      end if;
    end if;

  end process;

  --cpu_data_master_continuerequest continued request, which is an e_mux
  cpu_data_master_continuerequest <= last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module AND NOT ((((cpu_instruction_master_read AND to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_latency_counter))) /= std_logic_vector'("00000000000000000000000000000000")))))) OR cpu_data_master_arbiterlock));
  --local readdatavalid cpu_instruction_master_read_data_valid_cpu_jtag_debug_module, which is an e_mux
  cpu_instruction_master_read_data_valid_cpu_jtag_debug_module <= (internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read) AND NOT cpu_jtag_debug_module_waits_for_read;
  --allow new arb cycle for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_allow_new_arb_cycle <= NOT cpu_data_master_arbiterlock AND NOT cpu_instruction_master_arbiterlock;
  --cpu/instruction_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(0) <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --cpu/instruction_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_instruction_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(0);
  --cpu/instruction_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_instruction_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(0) AND internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --cpu/data_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  cpu_jtag_debug_module_master_qreq_vector(1) <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --cpu/data_master grant cpu/jtag_debug_module, which is an e_assign
  internal_cpu_data_master_granted_cpu_jtag_debug_module <= cpu_jtag_debug_module_grant_vector(1);
  --cpu/data_master saved-grant cpu/jtag_debug_module, which is an e_assign
  cpu_data_master_saved_grant_cpu_jtag_debug_module <= cpu_jtag_debug_module_arb_winner(1) AND internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --cpu/jtag_debug_module chosen-master double-vector, which is an e_assign
  cpu_jtag_debug_module_chosen_master_double_vector <= A_EXT (((std_logic_vector'("0") & ((cpu_jtag_debug_module_master_qreq_vector & cpu_jtag_debug_module_master_qreq_vector))) AND (((std_logic_vector'("0") & (Std_Logic_Vector'(NOT cpu_jtag_debug_module_master_qreq_vector & NOT cpu_jtag_debug_module_master_qreq_vector))) + (std_logic_vector'("000") & (cpu_jtag_debug_module_arb_addend))))), 4);
  --stable onehot encoding of arb winner
  cpu_jtag_debug_module_arb_winner <= A_WE_StdLogicVector((std_logic'(((cpu_jtag_debug_module_allow_new_arb_cycle AND or_reduce(cpu_jtag_debug_module_grant_vector)))) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
  --saved cpu_jtag_debug_module_grant_vector, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_saved_chosen_master_vector <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_allow_new_arb_cycle) = '1' then 
        cpu_jtag_debug_module_saved_chosen_master_vector <= A_WE_StdLogicVector((std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1'), cpu_jtag_debug_module_grant_vector, cpu_jtag_debug_module_saved_chosen_master_vector);
      end if;
    end if;

  end process;

  --onehot encoding of chosen master
  cpu_jtag_debug_module_grant_vector <= Std_Logic_Vector'(A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(1) OR cpu_jtag_debug_module_chosen_master_double_vector(3)))) & A_ToStdLogicVector(((cpu_jtag_debug_module_chosen_master_double_vector(0) OR cpu_jtag_debug_module_chosen_master_double_vector(2)))));
  --cpu/jtag_debug_module chosen master rotated left, which is an e_assign
  cpu_jtag_debug_module_chosen_master_rot_left <= A_EXT (A_WE_StdLogicVector((((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001")))) /= std_logic_vector'("00")), (std_logic_vector'("000000000000000000000000000000") & ((A_SLL(cpu_jtag_debug_module_arb_winner,std_logic_vector'("00000000000000000000000000000001"))))), std_logic_vector'("00000000000000000000000000000001")), 2);
  --cpu/jtag_debug_module's addend for next-master-grant
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_arb_addend <= std_logic_vector'("01");
    elsif clk'event and clk = '1' then
      if std_logic'(or_reduce(cpu_jtag_debug_module_grant_vector)) = '1' then 
        cpu_jtag_debug_module_arb_addend <= A_WE_StdLogicVector((std_logic'(cpu_jtag_debug_module_end_xfer) = '1'), cpu_jtag_debug_module_chosen_master_rot_left, cpu_jtag_debug_module_grant_vector);
      end if;
    end if;

  end process;

  cpu_jtag_debug_module_begintransfer <= cpu_jtag_debug_module_begins_xfer;
  --assign lhs ~cpu_jtag_debug_module_reset of type reset_n to cpu_jtag_debug_module_reset_n, which is an e_assign
  cpu_jtag_debug_module_reset <= NOT internal_cpu_jtag_debug_module_reset_n;
  --cpu_jtag_debug_module_reset_n assignment, which is an e_assign
  internal_cpu_jtag_debug_module_reset_n <= reset_n;
  --assign cpu_jtag_debug_module_resetrequest_from_sa = cpu_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  cpu_jtag_debug_module_resetrequest_from_sa <= cpu_jtag_debug_module_resetrequest;
  cpu_jtag_debug_module_chipselect <= internal_cpu_data_master_granted_cpu_jtag_debug_module OR internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --cpu_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  cpu_jtag_debug_module_firsttransfer <= A_WE_StdLogic((std_logic'(cpu_jtag_debug_module_begins_xfer) = '1'), cpu_jtag_debug_module_unreg_firsttransfer, cpu_jtag_debug_module_reg_firsttransfer);
  --cpu_jtag_debug_module_unreg_firsttransfer first transaction, which is an e_assign
  cpu_jtag_debug_module_unreg_firsttransfer <= NOT ((cpu_jtag_debug_module_slavearbiterlockenable AND cpu_jtag_debug_module_any_continuerequest));
  --cpu_jtag_debug_module_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_jtag_debug_module_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(cpu_jtag_debug_module_begins_xfer) = '1' then 
        cpu_jtag_debug_module_reg_firsttransfer <= cpu_jtag_debug_module_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  cpu_jtag_debug_module_beginbursttransfer_internal <= cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  cpu_jtag_debug_module_arbitration_holdoff_internal <= cpu_jtag_debug_module_begins_xfer AND cpu_jtag_debug_module_firsttransfer;
  --cpu_jtag_debug_module_write assignment, which is an e_mux
  cpu_jtag_debug_module_write <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --cpu_jtag_debug_module_address mux, which is an e_mux
  cpu_jtag_debug_module_address <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (A_SRL(shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010"))), (A_SRL(shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master,std_logic_vector'("00000000000000000000000000000010")))), 9);
  shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master <= cpu_instruction_master_address_to_slave;
  --d1_cpu_jtag_debug_module_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_cpu_jtag_debug_module_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_cpu_jtag_debug_module_end_xfer <= cpu_jtag_debug_module_end_xfer;
      end if;
    end if;

  end process;

  --cpu_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_read <= cpu_jtag_debug_module_in_a_read_cycle AND cpu_jtag_debug_module_begins_xfer;
  --cpu_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_read_cycle <= ((internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_cpu_jtag_debug_module AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= cpu_jtag_debug_module_in_a_read_cycle;
  --cpu_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  cpu_jtag_debug_module_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --cpu_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  cpu_jtag_debug_module_in_a_write_cycle <= internal_cpu_data_master_granted_cpu_jtag_debug_module AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= cpu_jtag_debug_module_in_a_write_cycle;
  wait_for_cpu_jtag_debug_module_counter <= std_logic'('0');
  --cpu_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  cpu_jtag_debug_module_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_cpu_jtag_debug_module)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_cpu_jtag_debug_module <= internal_cpu_data_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_data_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_data_master_requests_cpu_jtag_debug_module <= internal_cpu_data_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_cpu_jtag_debug_module <= internal_cpu_instruction_master_granted_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_cpu_jtag_debug_module <= internal_cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_cpu_jtag_debug_module <= internal_cpu_instruction_master_requests_cpu_jtag_debug_module;
  --vhdl renameroo for output signals
  cpu_jtag_debug_module_reset_n <= internal_cpu_jtag_debug_module_reset_n;
--synthesis translate_off
    --cpu/jtag_debug_module enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

    --grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_granted_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_granted_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line, now);
          write(write_line, string'(": "));
          write(write_line, string'("> 1 of grant signals are active simultaneously"));
          write(output, write_line.all);
          deallocate (write_line);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

    --saved_grant signals are active simultaneously, which is an e_process
    process (clk)
    VARIABLE write_line1 : line;
    begin
      if clk'event and clk = '1' then
        if (std_logic_vector'("000000000000000000000000000000") & (((std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_data_master_saved_grant_cpu_jtag_debug_module))) + (std_logic_vector'("0") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_saved_grant_cpu_jtag_debug_module))))))>std_logic_vector'("00000000000000000000000000000001") then 
          write(write_line1, now);
          write(write_line1, string'(": "));
          write(write_line1, string'("> 1 of saved_grant signals are active simultaneously"));
          write(output, write_line1.all);
          deallocate (write_line1);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity cpu_data_master_arbitrator is 
        port (
              -- inputs:
                 signal DM9000A_avalon_slave_irq_from_sa : IN STD_LOGIC;
                 signal DM9000A_avalon_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal DM9000A_avalon_slave_wait_counter_eq_0 : IN STD_LOGIC;
                 signal DM9000A_avalon_slave_wait_counter_eq_1 : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_byteenable_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_debugaccess : IN STD_LOGIC;
                 signal cpu_data_master_granted_DM9000A_avalon_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_granted_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_leds_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_onchip_memory_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_pio_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_pio_1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_pio_2_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_pio_3_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_pio_4_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_pio_5_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_granted_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                 signal cpu_data_master_granted_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_DM9000A_avalon_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_leds_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_memory_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_2_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_3_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_4_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_5_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_DM9000A_avalon_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_leds_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_memory_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_2_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_3_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_4_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_5_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_DM9000A_avalon_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_data_master_requests_flash_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_leds_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_onchip_memory_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_pio_0_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_pio_1_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_pio_2_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_pio_3_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_pio_4_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_pio_5_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_sdram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                 signal cpu_data_master_requests_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                 signal cpu_data_master_requests_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_DM9000A_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal d1_jtag_uart_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                 signal d1_leds_s1_end_xfer : IN STD_LOGIC;
                 signal d1_onchip_memory_s1_end_xfer : IN STD_LOGIC;
                 signal d1_pio_0_s1_end_xfer : IN STD_LOGIC;
                 signal d1_pio_1_s1_end_xfer : IN STD_LOGIC;
                 signal d1_pio_2_s1_end_xfer : IN STD_LOGIC;
                 signal d1_pio_3_s1_end_xfer : IN STD_LOGIC;
                 signal d1_pio_4_s1_end_xfer : IN STD_LOGIC;
                 signal d1_pio_5_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                 signal d1_tightly_coupled_instruction_memory_s2_end_xfer : IN STD_LOGIC;
                 signal d1_timer_s1_end_xfer : IN STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                 signal flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                 signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                 signal onchip_memory_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_onchip_memory_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (63 DOWNTO 0);
                 signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tightly_coupled_instruction_memory_s2_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal timer_s1_irq_from_sa : IN STD_LOGIC;
                 signal timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                 signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_data_master_arbitrator : entity is FALSE;
end entity cpu_data_master_arbitrator;


architecture europa of cpu_data_master_arbitrator is
                signal cpu_data_master_dbs_increment :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_run :  STD_LOGIC;
                signal dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal dbs_count_enable :  STD_LOGIC;
                signal dbs_counter_overflow :  STD_LOGIC;
                signal internal_cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal internal_cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal internal_cpu_data_master_waitrequest :  STD_LOGIC;
                signal last_dbs_term_and_run :  STD_LOGIC;
                signal next_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_dbs_8_reg_segment_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_dbs_8_reg_segment_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pre_dbs_count_enable :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;
                signal r_1 :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;
                signal r_3 :  STD_LOGIC;
                signal registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sdram_s1_readdata_from_sa_part_selected_by_negative_dbs :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_DM9000A_avalon_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(DM9000A_avalon_slave_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_DM9000A_avalon_slave OR NOT cpu_data_master_write)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(DM9000A_avalon_slave_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_granted_cpu_jtag_debug_module OR NOT cpu_data_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave OR NOT cpu_data_master_requests_jtag_uart_avalon_jtag_slave)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT jtag_uart_avalon_jtag_slave_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_leds_s1 OR NOT cpu_data_master_requests_leds_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_leds_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_leds_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_onchip_memory_s1 OR registered_cpu_data_master_read_data_valid_onchip_memory_s1) OR NOT cpu_data_master_requests_onchip_memory_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_onchip_memory_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_onchip_memory_s1 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_onchip_memory_s1 OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_data_master_run <= ((r_0 AND r_1) AND r_2) AND r_3;
  --r_1 master_run cascaded wait assignment, which is an e_assign
  r_1 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_pio_0_s1 OR NOT cpu_data_master_requests_pio_0_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_0_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_0_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_pio_1_s1 OR NOT cpu_data_master_requests_pio_1_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_1_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_1_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_pio_2_s1 OR NOT cpu_data_master_requests_pio_2_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_2_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_2_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_pio_3_s1 OR NOT cpu_data_master_requests_pio_3_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_3_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_3_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_pio_4_s1 OR NOT cpu_data_master_requests_pio_4_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_4_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_4_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))));
  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic((((((((((((((((((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_pio_5_s1 OR NOT cpu_data_master_requests_pio_5_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_5_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_pio_5_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_sdram_s1 OR cpu_data_master_read_data_valid_sdram_s1) OR NOT cpu_data_master_requests_sdram_s1)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_sdram_s1 OR NOT cpu_data_master_read) OR ((cpu_data_master_read_data_valid_sdram_s1 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sdram_s1 OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT sdram_s1_waitrequest_from_sa)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_sysid_control_slave OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 OR registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2) OR NOT cpu_data_master_requests_tightly_coupled_instruction_memory_s2)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((NOT cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 OR NOT ((cpu_data_master_read OR cpu_data_master_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_read OR cpu_data_master_write)))))))))) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_qualified_request_timer_s1 OR NOT cpu_data_master_requests_timer_s1)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_timer_s1 OR NOT cpu_data_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_timer_s1 OR NOT cpu_data_master_write)))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))) AND std_logic_vector'("00000000000000000000000000000001")));
  --r_3 master_run cascaded wait assignment, which is an e_assign
  r_3 <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((((((cpu_data_master_qualified_request_flash_s1 OR (((registered_cpu_data_master_read_data_valid_flash_s1 AND internal_cpu_data_master_dbs_address(1)) AND internal_cpu_data_master_dbs_address(0)))) OR ((((cpu_data_master_write AND NOT(cpu_data_master_byteenable_flash_s1)) AND internal_cpu_data_master_dbs_address(1)) AND internal_cpu_data_master_dbs_address(0)))) OR NOT cpu_data_master_requests_flash_s1)) AND (((NOT cpu_data_master_qualified_request_flash_s1 OR NOT cpu_data_master_read) OR (((registered_cpu_data_master_read_data_valid_flash_s1 AND ((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0)))) AND cpu_data_master_read)))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_data_master_qualified_request_flash_s1 OR NOT cpu_data_master_write)))) OR ((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(flash_s1_wait_counter_eq_1)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((internal_cpu_data_master_dbs_address(1) AND internal_cpu_data_master_dbs_address(0))))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_write)))))))));
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_data_master_address_to_slave <= cpu_data_master_address(28 DOWNTO 0);
  --cpu/data_master readdata mux, which is an e_mux
  cpu_data_master_readdata <= (((((((((A_REP(NOT cpu_data_master_requests_DM9000A_avalon_slave, 32) OR (std_logic_vector'("0000000000000000") & (DM9000A_avalon_slave_readdata_from_sa)))) AND ((A_REP(NOT cpu_data_master_requests_cpu_jtag_debug_module, 32) OR cpu_jtag_debug_module_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_jtag_uart_avalon_jtag_slave, 32) OR registered_cpu_data_master_readdata))) AND ((A_REP(NOT cpu_data_master_requests_onchip_memory_s1, 32) OR onchip_memory_s1_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_sdram_s1, 32) OR registered_cpu_data_master_readdata))) AND ((A_REP(NOT cpu_data_master_requests_sysid_control_slave, 32) OR sysid_control_slave_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_tightly_coupled_instruction_memory_s2, 32) OR tightly_coupled_instruction_memory_s2_readdata_from_sa))) AND ((A_REP(NOT cpu_data_master_requests_timer_s1, 32) OR (std_logic_vector'("0000000000000000") & (timer_s1_readdata_from_sa))))) AND ((A_REP(NOT cpu_data_master_requests_flash_s1, 32) OR Std_Logic_Vector'(incoming_tri_state_bridge_data_with_Xs_converted_to_0(7 DOWNTO 0) & dbs_8_reg_segment_2 & dbs_8_reg_segment_1 & dbs_8_reg_segment_0)));
  --actual waitrequest port, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_waitrequest <= Vector_To_Std_Logic(NOT (A_WE_StdLogicVector((std_logic'((NOT ((cpu_data_master_read OR cpu_data_master_write)))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_data_master_run AND internal_cpu_data_master_waitrequest))))))));
      end if;
    end if;

  end process;

  --irq assign, which is an e_assign
  cpu_data_master_irq <= Std_Logic_Vector'(A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(std_logic'('0')) & A_ToStdLogicVector(DM9000A_avalon_slave_irq_from_sa) & A_ToStdLogicVector(timer_s1_irq_from_sa) & A_ToStdLogicVector(jtag_uart_avalon_jtag_slave_irq_from_sa));
  --unpredictable registered wait state incoming data, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      registered_cpu_data_master_readdata <= std_logic_vector'("00000000000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        registered_cpu_data_master_readdata <= p1_registered_cpu_data_master_readdata;
      end if;
    end if;

  end process;

  --registered readdata mux, which is an e_mux
  p1_registered_cpu_data_master_readdata <= ((A_REP(NOT cpu_data_master_requests_jtag_uart_avalon_jtag_slave, 32) OR jtag_uart_avalon_jtag_slave_readdata_from_sa)) AND ((A_REP(NOT cpu_data_master_requests_sdram_s1, 32) OR sdram_s1_readdata_from_sa_part_selected_by_negative_dbs));
  --Negative Dynamic Bus-sizing mux.
  --this mux selects the correct half of the 
  --wide data coming from the slave sdram/s1 
  sdram_s1_readdata_from_sa_part_selected_by_negative_dbs <= A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_address_to_slave(2)))) = std_logic_vector'("00000000000000000000000000000000"))), sdram_s1_readdata_from_sa(31 DOWNTO 0), sdram_s1_readdata_from_sa(63 DOWNTO 32));
  --no_byte_enables_and_last_term, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_no_byte_enables_and_last_term <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_data_master_no_byte_enables_and_last_term <= last_dbs_term_and_run;
      end if;
    end if;

  end process;

  --compute the last dbs term, which is an e_mux
  last_dbs_term_and_run <= (to_std_logic(((internal_cpu_data_master_dbs_address = std_logic_vector'("11")))) AND cpu_data_master_write) AND NOT(cpu_data_master_byteenable_flash_s1);
  --pre dbs count enable, which is an e_mux
  pre_dbs_count_enable <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((((((NOT internal_cpu_data_master_no_byte_enables_and_last_term) AND cpu_data_master_requests_flash_s1) AND cpu_data_master_write) AND NOT(cpu_data_master_byteenable_flash_s1))) OR cpu_data_master_read_data_valid_flash_s1)))) OR (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_data_master_granted_flash_s1 AND cpu_data_master_write)))) AND std_logic_vector'("00000000000000000000000000000001")) AND std_logic_vector'("00000000000000000000000000000001")) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((flash_s1_wait_counter_eq_0 AND NOT d1_tri_state_bridge_avalon_slave_end_xfer)))))))));
  --input to dbs-8 stored 0, which is an e_mux
  p1_dbs_8_reg_segment_0 <= incoming_tri_state_bridge_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_0 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000000")))))) = '1' then 
        dbs_8_reg_segment_0 <= p1_dbs_8_reg_segment_0;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 1, which is an e_mux
  p1_dbs_8_reg_segment_1 <= incoming_tri_state_bridge_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_1 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000001")))))) = '1' then 
        dbs_8_reg_segment_1 <= p1_dbs_8_reg_segment_1;
      end if;
    end if;

  end process;

  --input to dbs-8 stored 2, which is an e_mux
  p1_dbs_8_reg_segment_2 <= incoming_tri_state_bridge_data_with_Xs_converted_to_0;
  --dbs register for dbs-8 segment 2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      dbs_8_reg_segment_2 <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if std_logic'((dbs_count_enable AND to_std_logic((((std_logic_vector'("000000000000000000000000000000") & ((internal_cpu_data_master_dbs_address(1 DOWNTO 0)))) = std_logic_vector'("00000000000000000000000000000010")))))) = '1' then 
        dbs_8_reg_segment_2 <= p1_dbs_8_reg_segment_2;
      end if;
    end if;

  end process;

  --mux write dbs 2, which is an e_mux
  cpu_data_master_dbs_write_8 <= A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_writedata(7 DOWNTO 0), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_writedata(15 DOWNTO 8), A_WE_StdLogicVector((((std_logic_vector'("000000000000000000000000000000") & (internal_cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_writedata(23 DOWNTO 16), cpu_data_master_writedata(31 DOWNTO 24))));
  --dbs count increment, which is an e_mux
  cpu_data_master_dbs_increment <= A_EXT (A_WE_StdLogicVector((std_logic'((cpu_data_master_requests_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")), 2);
  --dbs counter overflow, which is an e_assign
  dbs_counter_overflow <= internal_cpu_data_master_dbs_address(1) AND NOT((next_dbs_address(1)));
  --next master address, which is an e_assign
  next_dbs_address <= A_EXT (((std_logic_vector'("0") & (internal_cpu_data_master_dbs_address)) + (std_logic_vector'("0") & (cpu_data_master_dbs_increment))), 2);
  --dbs count enable, which is an e_mux
  dbs_count_enable <= pre_dbs_count_enable;
  --dbs counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_data_master_dbs_address <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if std_logic'(dbs_count_enable) = '1' then 
        internal_cpu_data_master_dbs_address <= next_dbs_address;
      end if;
    end if;

  end process;

  --vhdl renameroo for output signals
  cpu_data_master_address_to_slave <= internal_cpu_data_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_data_master_dbs_address <= internal_cpu_data_master_dbs_address;
  --vhdl renameroo for output signals
  cpu_data_master_no_byte_enables_and_last_term <= internal_cpu_data_master_no_byte_enables_and_last_term;
  --vhdl renameroo for output signals
  cpu_data_master_waitrequest <= internal_cpu_data_master_waitrequest;

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                 signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : OUT STD_LOGIC;
                 signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                 signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_instruction_master_arbitrator : entity is FALSE;
end entity cpu_instruction_master_arbitrator;


architecture europa of cpu_instruction_master_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_instruction_master_address_last_time :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_instruction_master_is_granted_some_slave :  STD_LOGIC;
                signal cpu_instruction_master_read_but_no_slave_selected :  STD_LOGIC;
                signal cpu_instruction_master_read_last_time :  STD_LOGIC;
                signal cpu_instruction_master_run :  STD_LOGIC;
                signal internal_cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal internal_cpu_instruction_master_latency_counter :  STD_LOGIC;
                signal internal_cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal latency_load_value :  STD_LOGIC;
                signal p1_cpu_instruction_master_latency_counter :  STD_LOGIC;
                signal pre_flush_cpu_instruction_master_readdatavalid :  STD_LOGIC;
                signal r_0 :  STD_LOGIC;

begin

  --r_0 master_run cascaded wait assignment, which is an e_assign
  r_0 <= Vector_To_Std_Logic((((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_requests_cpu_jtag_debug_module)))))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_instruction_master_granted_cpu_jtag_debug_module OR NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module)))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_instruction_master_qualified_request_cpu_jtag_debug_module OR NOT cpu_instruction_master_read)))) OR (((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT d1_cpu_jtag_debug_module_end_xfer)))) AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_instruction_master_read)))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_instruction_master_run <= r_0;
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_instruction_master_address_to_slave <= Std_Logic_Vector'(std_logic_vector'("100010000000001101") & cpu_instruction_master_address(10 DOWNTO 0));
  --cpu_instruction_master_read_but_no_slave_selected assignment, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_instruction_master_read_but_no_slave_selected <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_instruction_master_read_but_no_slave_selected <= (cpu_instruction_master_read AND cpu_instruction_master_run) AND NOT cpu_instruction_master_is_granted_some_slave;
      end if;
    end if;

  end process;

  --some slave is getting selected, which is an e_mux
  cpu_instruction_master_is_granted_some_slave <= cpu_instruction_master_granted_cpu_jtag_debug_module;
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_instruction_master_readdatavalid <= std_logic'('0');
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_instruction_master_readdatavalid <= (cpu_instruction_master_read_but_no_slave_selected OR pre_flush_cpu_instruction_master_readdatavalid) OR cpu_instruction_master_read_data_valid_cpu_jtag_debug_module;
  --cpu/instruction_master readdata mux, which is an e_mux
  cpu_instruction_master_readdata <= cpu_jtag_debug_module_readdata_from_sa;
  --actual waitrequest port, which is an e_assign
  internal_cpu_instruction_master_waitrequest <= NOT cpu_instruction_master_run;
  --latent max counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      internal_cpu_instruction_master_latency_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_cpu_instruction_master_latency_counter <= p1_cpu_instruction_master_latency_counter;
      end if;
    end if;

  end process;

  --latency counter load mux, which is an e_mux
  p1_cpu_instruction_master_latency_counter <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(((cpu_instruction_master_run AND cpu_instruction_master_read))) = '1'), (std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(latency_load_value))), A_WE_StdLogicVector((std_logic'((internal_cpu_instruction_master_latency_counter)) = '1'), ((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_instruction_master_latency_counter))) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000"))));
  --read latency load values, which is an e_mux
  latency_load_value <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_instruction_master_address_to_slave <= internal_cpu_instruction_master_address_to_slave;
  --vhdl renameroo for output signals
  cpu_instruction_master_latency_counter <= internal_cpu_instruction_master_latency_counter;
  --vhdl renameroo for output signals
  cpu_instruction_master_waitrequest <= internal_cpu_instruction_master_waitrequest;
--synthesis translate_off
    --cpu_instruction_master_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_address_last_time <= std_logic_vector'("00000000000000000000000000000");
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_address_last_time <= cpu_instruction_master_address;
        end if;
      end if;

    end process;

    --cpu/instruction_master waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          active_and_waiting_last_time <= internal_cpu_instruction_master_waitrequest AND (cpu_instruction_master_read);
        end if;
      end if;

    end process;

    --cpu_instruction_master_address matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_address, cpu_instruction_master_address_last_time)
    VARIABLE write_line2 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_instruction_master_address /= cpu_instruction_master_address_last_time))))) = '1' then 
          write(write_line2, now);
          write(write_line2, string'(": "));
          write(write_line2, string'("cpu_instruction_master_address did not heed wait!!!"));
          write(output, write_line2.all);
          deallocate (write_line2);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_instruction_master_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_instruction_master_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_instruction_master_read_last_time <= cpu_instruction_master_read;
        end if;
      end if;

    end process;

    --cpu_instruction_master_read matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_instruction_master_read, cpu_instruction_master_read_last_time)
    VARIABLE write_line3 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_instruction_master_read) /= std_logic'(cpu_instruction_master_read_last_time)))))) = '1' then 
          write(write_line3, now);
          write(write_line3, string'(": "));
          write(write_line3, string'("cpu_instruction_master_read did not heed wait!!!"));
          write(output, write_line3.all);
          deallocate (write_line3);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_tightly_coupled_data_master_0_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_tightly_coupled_data_master_0_clken : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_read : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_write : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d1_tightly_coupled_data_memory_s1_end_xfer : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal tightly_coupled_data_memory_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_tightly_coupled_data_master_0_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_tightly_coupled_data_master_0_latency_counter : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_tightly_coupled_data_master_0_readdatavalid : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_tightly_coupled_data_master_0_arbitrator : entity is FALSE;
end entity cpu_tightly_coupled_data_master_0_arbitrator;


architecture europa of cpu_tightly_coupled_data_master_0_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_address_last_time :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_tightly_coupled_data_master_0_read_last_time :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_run :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_write_last_time :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_writedata_last_time :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_cpu_tightly_coupled_data_master_0_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal internal_cpu_tightly_coupled_data_master_0_waitrequest :  STD_LOGIC;
                signal pre_flush_cpu_tightly_coupled_data_master_0_readdatavalid :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;

begin

  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic(((std_logic_vector'("00000000000000000000000000000001") AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 OR NOT ((cpu_tightly_coupled_data_master_0_read OR cpu_tightly_coupled_data_master_0_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_tightly_coupled_data_master_0_read OR cpu_tightly_coupled_data_master_0_write)))))))))) AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 OR NOT ((cpu_tightly_coupled_data_master_0_read OR cpu_tightly_coupled_data_master_0_write)))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((cpu_tightly_coupled_data_master_0_read OR cpu_tightly_coupled_data_master_0_write)))))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_tightly_coupled_data_master_0_run <= r_2;
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_tightly_coupled_data_master_0_address_to_slave <= Std_Logic_Vector'(std_logic_vector'("100010000000001110") & cpu_tightly_coupled_data_master_0_address(10 DOWNTO 0));
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_tightly_coupled_data_master_0_readdatavalid <= cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1;
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_tightly_coupled_data_master_0_readdatavalid <= Vector_To_Std_Logic((std_logic_vector'("00000000000000000000000000000000") OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pre_flush_cpu_tightly_coupled_data_master_0_readdatavalid)))));
  --cpu/tightly_coupled_data_master_0 readdata mux, which is an e_mux
  cpu_tightly_coupled_data_master_0_readdata <= tightly_coupled_data_memory_s1_readdata_from_sa;
  --actual waitrequest port, which is an e_assign
  internal_cpu_tightly_coupled_data_master_0_waitrequest <= NOT cpu_tightly_coupled_data_master_0_run;
  --latent max counter, which is an e_assign
  cpu_tightly_coupled_data_master_0_latency_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_tightly_coupled_data_master_0_address_to_slave <= internal_cpu_tightly_coupled_data_master_0_address_to_slave;
  --vhdl renameroo for output signals
  cpu_tightly_coupled_data_master_0_waitrequest <= internal_cpu_tightly_coupled_data_master_0_waitrequest;
--synthesis translate_off
    --cpu_tightly_coupled_data_master_0_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_tightly_coupled_data_master_0_address_last_time <= std_logic_vector'("00000000000000000000000000000");
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_tightly_coupled_data_master_0_address_last_time <= cpu_tightly_coupled_data_master_0_address;
        end if;
      end if;

    end process;

    --cpu/tightly_coupled_data_master_0 waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          active_and_waiting_last_time <= internal_cpu_tightly_coupled_data_master_0_waitrequest AND ((cpu_tightly_coupled_data_master_0_read OR cpu_tightly_coupled_data_master_0_write));
        end if;
      end if;

    end process;

    --cpu_tightly_coupled_data_master_0_address matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_tightly_coupled_data_master_0_address, cpu_tightly_coupled_data_master_0_address_last_time)
    VARIABLE write_line4 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_tightly_coupled_data_master_0_address /= cpu_tightly_coupled_data_master_0_address_last_time))))) = '1' then 
          write(write_line4, now);
          write(write_line4, string'(": "));
          write(write_line4, string'("cpu_tightly_coupled_data_master_0_address did not heed wait!!!"));
          write(output, write_line4.all);
          deallocate (write_line4);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_tightly_coupled_data_master_0_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_tightly_coupled_data_master_0_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_tightly_coupled_data_master_0_read_last_time <= cpu_tightly_coupled_data_master_0_read;
        end if;
      end if;

    end process;

    --cpu_tightly_coupled_data_master_0_read matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_tightly_coupled_data_master_0_read, cpu_tightly_coupled_data_master_0_read_last_time)
    VARIABLE write_line5 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_tightly_coupled_data_master_0_read) /= std_logic'(cpu_tightly_coupled_data_master_0_read_last_time)))))) = '1' then 
          write(write_line5, now);
          write(write_line5, string'(": "));
          write(write_line5, string'("cpu_tightly_coupled_data_master_0_read did not heed wait!!!"));
          write(output, write_line5.all);
          deallocate (write_line5);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_tightly_coupled_data_master_0_write check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_tightly_coupled_data_master_0_write_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_tightly_coupled_data_master_0_write_last_time <= cpu_tightly_coupled_data_master_0_write;
        end if;
      end if;

    end process;

    --cpu_tightly_coupled_data_master_0_write matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_tightly_coupled_data_master_0_write, cpu_tightly_coupled_data_master_0_write_last_time)
    VARIABLE write_line6 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_tightly_coupled_data_master_0_write) /= std_logic'(cpu_tightly_coupled_data_master_0_write_last_time)))))) = '1' then 
          write(write_line6, now);
          write(write_line6, string'(": "));
          write(write_line6, string'("cpu_tightly_coupled_data_master_0_write did not heed wait!!!"));
          write(output, write_line6.all);
          deallocate (write_line6);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_tightly_coupled_data_master_0_writedata check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_tightly_coupled_data_master_0_writedata_last_time <= std_logic_vector'("00000000000000000000000000000000");
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_tightly_coupled_data_master_0_writedata_last_time <= cpu_tightly_coupled_data_master_0_writedata;
        end if;
      end if;

    end process;

    --cpu_tightly_coupled_data_master_0_writedata matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_tightly_coupled_data_master_0_write, cpu_tightly_coupled_data_master_0_writedata, cpu_tightly_coupled_data_master_0_writedata_last_time)
    VARIABLE write_line7 : line;
    begin
        if std_logic'(((active_and_waiting_last_time AND to_std_logic(((cpu_tightly_coupled_data_master_0_writedata /= cpu_tightly_coupled_data_master_0_writedata_last_time)))) AND cpu_tightly_coupled_data_master_0_write)) = '1' then 
          write(write_line7, now);
          write(write_line7, string'(": "));
          write(write_line7, string'("cpu_tightly_coupled_data_master_0_writedata did not heed wait!!!"));
          write(output, write_line7.all);
          deallocate (write_line7);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity cpu_tightly_coupled_instruction_master_0_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_tightly_coupled_instruction_master_0_clken : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_read : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                 signal d1_tightly_coupled_instruction_memory_s1_end_xfer : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_tightly_coupled_instruction_master_0_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_tightly_coupled_instruction_master_0_latency_counter : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_tightly_coupled_instruction_master_0_readdatavalid : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_waitrequest : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of cpu_tightly_coupled_instruction_master_0_arbitrator : entity is FALSE;
end entity cpu_tightly_coupled_instruction_master_0_arbitrator;


architecture europa of cpu_tightly_coupled_instruction_master_0_arbitrator is
                signal active_and_waiting_last_time :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_address_last_time :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_tightly_coupled_instruction_master_0_read_last_time :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_run :  STD_LOGIC;
                signal internal_cpu_tightly_coupled_instruction_master_0_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal internal_cpu_tightly_coupled_instruction_master_0_waitrequest :  STD_LOGIC;
                signal pre_flush_cpu_tightly_coupled_instruction_master_0_readdatavalid :  STD_LOGIC;
                signal r_2 :  STD_LOGIC;

begin

  --r_2 master_run cascaded wait assignment, which is an e_assign
  r_2 <= Vector_To_Std_Logic((std_logic_vector'("00000000000000000000000000000001") AND (((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((NOT cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 OR NOT (cpu_tightly_coupled_instruction_master_0_read))))) OR ((std_logic_vector'("00000000000000000000000000000001") AND (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR((cpu_tightly_coupled_instruction_master_0_read))))))))));
  --cascaded wait assignment, which is an e_assign
  cpu_tightly_coupled_instruction_master_0_run <= r_2;
  --optimize select-logic by passing only those address bits which matter.
  internal_cpu_tightly_coupled_instruction_master_0_address_to_slave <= Std_Logic_Vector'(std_logic_vector'("100010000000000") & cpu_tightly_coupled_instruction_master_0_address(13 DOWNTO 0));
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_tightly_coupled_instruction_master_0_readdatavalid <= cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1;
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_tightly_coupled_instruction_master_0_readdatavalid <= Vector_To_Std_Logic((std_logic_vector'("00000000000000000000000000000000") OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pre_flush_cpu_tightly_coupled_instruction_master_0_readdatavalid)))));
  --cpu/tightly_coupled_instruction_master_0 readdata mux, which is an e_mux
  cpu_tightly_coupled_instruction_master_0_readdata <= tightly_coupled_instruction_memory_s1_readdata_from_sa;
  --actual waitrequest port, which is an e_assign
  internal_cpu_tightly_coupled_instruction_master_0_waitrequest <= NOT cpu_tightly_coupled_instruction_master_0_run;
  --latent max counter, which is an e_assign
  cpu_tightly_coupled_instruction_master_0_latency_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_tightly_coupled_instruction_master_0_address_to_slave <= internal_cpu_tightly_coupled_instruction_master_0_address_to_slave;
  --vhdl renameroo for output signals
  cpu_tightly_coupled_instruction_master_0_waitrequest <= internal_cpu_tightly_coupled_instruction_master_0_waitrequest;
--synthesis translate_off
    --cpu_tightly_coupled_instruction_master_0_address check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_tightly_coupled_instruction_master_0_address_last_time <= std_logic_vector'("00000000000000000000000000000");
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_tightly_coupled_instruction_master_0_address_last_time <= cpu_tightly_coupled_instruction_master_0_address;
        end if;
      end if;

    end process;

    --cpu/tightly_coupled_instruction_master_0 waited last time, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        active_and_waiting_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          active_and_waiting_last_time <= internal_cpu_tightly_coupled_instruction_master_0_waitrequest AND (cpu_tightly_coupled_instruction_master_0_read);
        end if;
      end if;

    end process;

    --cpu_tightly_coupled_instruction_master_0_address matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_tightly_coupled_instruction_master_0_address, cpu_tightly_coupled_instruction_master_0_address_last_time)
    VARIABLE write_line8 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((cpu_tightly_coupled_instruction_master_0_address /= cpu_tightly_coupled_instruction_master_0_address_last_time))))) = '1' then 
          write(write_line8, now);
          write(write_line8, string'(": "));
          write(write_line8, string'("cpu_tightly_coupled_instruction_master_0_address did not heed wait!!!"));
          write(output, write_line8.all);
          deallocate (write_line8);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

    --cpu_tightly_coupled_instruction_master_0_read check against wait, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        cpu_tightly_coupled_instruction_master_0_read_last_time <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          cpu_tightly_coupled_instruction_master_0_read_last_time <= cpu_tightly_coupled_instruction_master_0_read;
        end if;
      end if;

    end process;

    --cpu_tightly_coupled_instruction_master_0_read matches last port_name, which is an e_process
    process (active_and_waiting_last_time, cpu_tightly_coupled_instruction_master_0_read, cpu_tightly_coupled_instruction_master_0_read_last_time)
    VARIABLE write_line9 : line;
    begin
        if std_logic'((active_and_waiting_last_time AND to_std_logic(((std_logic'(cpu_tightly_coupled_instruction_master_0_read) /= std_logic'(cpu_tightly_coupled_instruction_master_0_read_last_time)))))) = '1' then 
          write(write_line9, now);
          write(write_line9, string'(": "));
          write(write_line9, string'("cpu_tightly_coupled_instruction_master_0_read did not heed wait!!!"));
          write(output, write_line9.all);
          deallocate (write_line9);
          assert false report "VHDL STOP" severity failure;
        end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity jtag_uart_avalon_jtag_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_irq : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                 signal d1_jtag_uart_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_address : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                 signal jtag_uart_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of jtag_uart_avalon_jtag_slave_arbitrator : entity is FALSE;
end entity jtag_uart_avalon_jtag_slave_arbitrator;


architecture europa of jtag_uart_avalon_jtag_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_allgrants :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_any_continuerequest :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_arb_counter_enable :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_begins_xfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_firsttransfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_grant_vector :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_in_a_read_cycle :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_in_a_write_cycle :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_master_qreq_vector :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_non_bursting_master_requests :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_reg_firsttransfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_slavearbiterlockenable :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_unreg_firsttransfer :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waits_for_read :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_jtag_uart_avalon_jtag_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT jtag_uart_avalon_jtag_slave_end_xfer;
      end if;
    end if;

  end process;

  jtag_uart_avalon_jtag_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave);
  --assign jtag_uart_avalon_jtag_slave_readdata_from_sa = jtag_uart_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_readdata_from_sa <= jtag_uart_avalon_jtag_slave_readdata;
  internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("10001000000000111100010010000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign jtag_uart_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_dataavailable_from_sa <= jtag_uart_avalon_jtag_slave_dataavailable;
  --assign jtag_uart_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_readyfordata_from_sa <= jtag_uart_avalon_jtag_slave_readyfordata;
  --assign jtag_uart_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa <= jtag_uart_avalon_jtag_slave_waitrequest;
  --jtag_uart_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  jtag_uart_avalon_jtag_slave_arb_share_set_values <= std_logic_vector'("001");
  --jtag_uart_avalon_jtag_slave_non_bursting_master_requests mux, which is an e_mux
  jtag_uart_avalon_jtag_slave_non_bursting_master_requests <= internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  --jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant mux, which is an e_mux
  jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --jtag_uart_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(jtag_uart_avalon_jtag_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_uart_avalon_jtag_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(jtag_uart_avalon_jtag_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (jtag_uart_avalon_jtag_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --jtag_uart_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  jtag_uart_avalon_jtag_slave_allgrants <= jtag_uart_avalon_jtag_slave_grant_vector;
  --jtag_uart_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_end_xfer <= NOT ((jtag_uart_avalon_jtag_slave_waits_for_read OR jtag_uart_avalon_jtag_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave <= jtag_uart_avalon_jtag_slave_end_xfer AND (((NOT jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --jtag_uart_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  jtag_uart_avalon_jtag_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave AND jtag_uart_avalon_jtag_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave AND NOT jtag_uart_avalon_jtag_slave_non_bursting_master_requests));
  --jtag_uart_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_avalon_jtag_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_uart_avalon_jtag_slave_arb_counter_enable) = '1' then 
        jtag_uart_avalon_jtag_slave_arb_share_counter <= jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --jtag_uart_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((jtag_uart_avalon_jtag_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave)) OR ((end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave AND NOT jtag_uart_avalon_jtag_slave_non_bursting_master_requests)))) = '1' then 
        jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= or_reduce(jtag_uart_avalon_jtag_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master jtag_uart/avalon_jtag_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= jtag_uart_avalon_jtag_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 <= or_reduce(jtag_uart_avalon_jtag_slave_arb_share_counter_next_value);
  --cpu/data_master jtag_uart/avalon_jtag_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --jtag_uart_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  jtag_uart_avalon_jtag_slave_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave AND NOT ((((cpu_data_master_read AND (NOT cpu_data_master_waitrequest))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --jtag_uart_avalon_jtag_slave_writedata mux, which is an e_mux
  jtag_uart_avalon_jtag_slave_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  --cpu/data_master saved-grant jtag_uart/avalon_jtag_slave, which is an e_assign
  cpu_data_master_saved_grant_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  --allow new arb cycle for jtag_uart/avalon_jtag_slave, which is an e_assign
  jtag_uart_avalon_jtag_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  jtag_uart_avalon_jtag_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  jtag_uart_avalon_jtag_slave_master_qreq_vector <= std_logic'('1');
  --jtag_uart_avalon_jtag_slave_reset_n assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_reset_n <= reset_n;
  jtag_uart_avalon_jtag_slave_chipselect <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  --jtag_uart_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  jtag_uart_avalon_jtag_slave_firsttransfer <= A_WE_StdLogic((std_logic'(jtag_uart_avalon_jtag_slave_begins_xfer) = '1'), jtag_uart_avalon_jtag_slave_unreg_firsttransfer, jtag_uart_avalon_jtag_slave_reg_firsttransfer);
  --jtag_uart_avalon_jtag_slave_unreg_firsttransfer first transaction, which is an e_assign
  jtag_uart_avalon_jtag_slave_unreg_firsttransfer <= NOT ((jtag_uart_avalon_jtag_slave_slavearbiterlockenable AND jtag_uart_avalon_jtag_slave_any_continuerequest));
  --jtag_uart_avalon_jtag_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      jtag_uart_avalon_jtag_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(jtag_uart_avalon_jtag_slave_begins_xfer) = '1' then 
        jtag_uart_avalon_jtag_slave_reg_firsttransfer <= jtag_uart_avalon_jtag_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --jtag_uart_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  jtag_uart_avalon_jtag_slave_beginbursttransfer_internal <= jtag_uart_avalon_jtag_slave_begins_xfer;
  --~jtag_uart_avalon_jtag_slave_read_n assignment, which is an e_mux
  jtag_uart_avalon_jtag_slave_read_n <= NOT ((internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_read));
  --~jtag_uart_avalon_jtag_slave_write_n assignment, which is an e_mux
  jtag_uart_avalon_jtag_slave_write_n <= NOT ((internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_write));
  shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --jtag_uart_avalon_jtag_slave_address mux, which is an e_mux
  jtag_uart_avalon_jtag_slave_address <= Vector_To_Std_Logic(A_SRL(shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")));
  --d1_jtag_uart_avalon_jtag_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_jtag_uart_avalon_jtag_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_jtag_uart_avalon_jtag_slave_end_xfer <= jtag_uart_avalon_jtag_slave_end_xfer;
      end if;
    end if;

  end process;

  --jtag_uart_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  jtag_uart_avalon_jtag_slave_waits_for_read <= jtag_uart_avalon_jtag_slave_in_a_read_cycle AND internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_in_a_read_cycle <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= jtag_uart_avalon_jtag_slave_in_a_read_cycle;
  --jtag_uart_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  jtag_uart_avalon_jtag_slave_waits_for_write <= jtag_uart_avalon_jtag_slave_in_a_write_cycle AND internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  --jtag_uart_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  jtag_uart_avalon_jtag_slave_in_a_write_cycle <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= jtag_uart_avalon_jtag_slave_in_a_write_cycle;
  wait_for_jtag_uart_avalon_jtag_slave_counter <= std_logic'('0');
  --assign jtag_uart_avalon_jtag_slave_irq_from_sa = jtag_uart_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  jtag_uart_avalon_jtag_slave_irq_from_sa <= jtag_uart_avalon_jtag_slave_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_jtag_uart_avalon_jtag_slave <= internal_cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  --vhdl renameroo for output signals
  jtag_uart_avalon_jtag_slave_waitrequest_from_sa <= internal_jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
--synthesis translate_off
    --jtag_uart/avalon_jtag_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity leds_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_leds_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_leds_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_leds_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_leds_s1 : OUT STD_LOGIC;
                 signal d1_leds_s1_end_xfer : OUT STD_LOGIC;
                 signal leds_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal leds_s1_chipselect : OUT STD_LOGIC;
                 signal leds_s1_reset_n : OUT STD_LOGIC;
                 signal leds_s1_write_n : OUT STD_LOGIC;
                 signal leds_s1_writedata : OUT STD_LOGIC_VECTOR (2 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of leds_s1_arbitrator : entity is FALSE;
end entity leds_s1_arbitrator;


architecture europa of leds_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_leds_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_leds_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_leds_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_leds_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_leds_s1 :  STD_LOGIC;
                signal leds_s1_allgrants :  STD_LOGIC;
                signal leds_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal leds_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal leds_s1_any_continuerequest :  STD_LOGIC;
                signal leds_s1_arb_counter_enable :  STD_LOGIC;
                signal leds_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal leds_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal leds_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal leds_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal leds_s1_begins_xfer :  STD_LOGIC;
                signal leds_s1_end_xfer :  STD_LOGIC;
                signal leds_s1_firsttransfer :  STD_LOGIC;
                signal leds_s1_grant_vector :  STD_LOGIC;
                signal leds_s1_in_a_read_cycle :  STD_LOGIC;
                signal leds_s1_in_a_write_cycle :  STD_LOGIC;
                signal leds_s1_master_qreq_vector :  STD_LOGIC;
                signal leds_s1_non_bursting_master_requests :  STD_LOGIC;
                signal leds_s1_reg_firsttransfer :  STD_LOGIC;
                signal leds_s1_slavearbiterlockenable :  STD_LOGIC;
                signal leds_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal leds_s1_unreg_firsttransfer :  STD_LOGIC;
                signal leds_s1_waits_for_read :  STD_LOGIC;
                signal leds_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_leds_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_leds_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT leds_s1_end_xfer;
      end if;
    end if;

  end process;

  leds_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_leds_s1);
  internal_cpu_data_master_requests_leds_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000000000111100010000000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --leds_s1_arb_share_counter set values, which is an e_mux
  leds_s1_arb_share_set_values <= std_logic_vector'("001");
  --leds_s1_non_bursting_master_requests mux, which is an e_mux
  leds_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_leds_s1;
  --leds_s1_any_bursting_master_saved_grant mux, which is an e_mux
  leds_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --leds_s1_arb_share_counter_next_value assignment, which is an e_assign
  leds_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(leds_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (leds_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(leds_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (leds_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --leds_s1_allgrants all slave grants, which is an e_mux
  leds_s1_allgrants <= leds_s1_grant_vector;
  --leds_s1_end_xfer assignment, which is an e_assign
  leds_s1_end_xfer <= NOT ((leds_s1_waits_for_read OR leds_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_leds_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_leds_s1 <= leds_s1_end_xfer AND (((NOT leds_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --leds_s1_arb_share_counter arbitration counter enable, which is an e_assign
  leds_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_leds_s1 AND leds_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_leds_s1 AND NOT leds_s1_non_bursting_master_requests));
  --leds_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      leds_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(leds_s1_arb_counter_enable) = '1' then 
        leds_s1_arb_share_counter <= leds_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --leds_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      leds_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((leds_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_leds_s1)) OR ((end_xfer_arb_share_counter_term_leds_s1 AND NOT leds_s1_non_bursting_master_requests)))) = '1' then 
        leds_s1_slavearbiterlockenable <= or_reduce(leds_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master leds/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= leds_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --leds_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  leds_s1_slavearbiterlockenable2 <= or_reduce(leds_s1_arb_share_counter_next_value);
  --cpu/data_master leds/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= leds_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --leds_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  leds_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_leds_s1 <= internal_cpu_data_master_requests_leds_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --leds_s1_writedata mux, which is an e_mux
  leds_s1_writedata <= cpu_data_master_writedata (2 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_leds_s1 <= internal_cpu_data_master_qualified_request_leds_s1;
  --cpu/data_master saved-grant leds/s1, which is an e_assign
  cpu_data_master_saved_grant_leds_s1 <= internal_cpu_data_master_requests_leds_s1;
  --allow new arb cycle for leds/s1, which is an e_assign
  leds_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  leds_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  leds_s1_master_qreq_vector <= std_logic'('1');
  --leds_s1_reset_n assignment, which is an e_assign
  leds_s1_reset_n <= reset_n;
  leds_s1_chipselect <= internal_cpu_data_master_granted_leds_s1;
  --leds_s1_firsttransfer first transaction, which is an e_assign
  leds_s1_firsttransfer <= A_WE_StdLogic((std_logic'(leds_s1_begins_xfer) = '1'), leds_s1_unreg_firsttransfer, leds_s1_reg_firsttransfer);
  --leds_s1_unreg_firsttransfer first transaction, which is an e_assign
  leds_s1_unreg_firsttransfer <= NOT ((leds_s1_slavearbiterlockenable AND leds_s1_any_continuerequest));
  --leds_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      leds_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(leds_s1_begins_xfer) = '1' then 
        leds_s1_reg_firsttransfer <= leds_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --leds_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  leds_s1_beginbursttransfer_internal <= leds_s1_begins_xfer;
  --~leds_s1_write_n assignment, which is an e_mux
  leds_s1_write_n <= NOT ((internal_cpu_data_master_granted_leds_s1 AND cpu_data_master_write));
  shifted_address_to_leds_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --leds_s1_address mux, which is an e_mux
  leds_s1_address <= A_EXT (A_SRL(shifted_address_to_leds_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_leds_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_leds_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_leds_s1_end_xfer <= leds_s1_end_xfer;
      end if;
    end if;

  end process;

  --leds_s1_waits_for_read in a cycle, which is an e_mux
  leds_s1_waits_for_read <= leds_s1_in_a_read_cycle AND leds_s1_begins_xfer;
  --leds_s1_in_a_read_cycle assignment, which is an e_assign
  leds_s1_in_a_read_cycle <= internal_cpu_data_master_granted_leds_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= leds_s1_in_a_read_cycle;
  --leds_s1_waits_for_write in a cycle, which is an e_mux
  leds_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(leds_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --leds_s1_in_a_write_cycle assignment, which is an e_assign
  leds_s1_in_a_write_cycle <= internal_cpu_data_master_granted_leds_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= leds_s1_in_a_write_cycle;
  wait_for_leds_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_leds_s1 <= internal_cpu_data_master_granted_leds_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_leds_s1 <= internal_cpu_data_master_qualified_request_leds_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_leds_s1 <= internal_cpu_data_master_requests_leds_s1;
--synthesis translate_off
    --leds/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity onchip_memory_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_memory_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_onchip_memory_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_onchip_memory_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_onchip_memory_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_onchip_memory_s1 : OUT STD_LOGIC;
                 signal d1_onchip_memory_s1_end_xfer : OUT STD_LOGIC;
                 signal onchip_memory_s1_address : OUT STD_LOGIC_VECTOR (10 DOWNTO 0);
                 signal onchip_memory_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal onchip_memory_s1_chipselect : OUT STD_LOGIC;
                 signal onchip_memory_s1_clken : OUT STD_LOGIC;
                 signal onchip_memory_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal onchip_memory_s1_write : OUT STD_LOGIC;
                 signal onchip_memory_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_onchip_memory_s1 : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of onchip_memory_s1_arbitrator : entity is FALSE;
end entity onchip_memory_s1_arbitrator;


architecture europa of onchip_memory_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_memory_s1_shift_register :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_memory_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_onchip_memory_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_onchip_memory_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_onchip_memory_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_onchip_memory_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_onchip_memory_s1 :  STD_LOGIC;
                signal onchip_memory_s1_allgrants :  STD_LOGIC;
                signal onchip_memory_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal onchip_memory_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal onchip_memory_s1_any_continuerequest :  STD_LOGIC;
                signal onchip_memory_s1_arb_counter_enable :  STD_LOGIC;
                signal onchip_memory_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_memory_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_memory_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal onchip_memory_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal onchip_memory_s1_begins_xfer :  STD_LOGIC;
                signal onchip_memory_s1_end_xfer :  STD_LOGIC;
                signal onchip_memory_s1_firsttransfer :  STD_LOGIC;
                signal onchip_memory_s1_grant_vector :  STD_LOGIC;
                signal onchip_memory_s1_in_a_read_cycle :  STD_LOGIC;
                signal onchip_memory_s1_in_a_write_cycle :  STD_LOGIC;
                signal onchip_memory_s1_master_qreq_vector :  STD_LOGIC;
                signal onchip_memory_s1_non_bursting_master_requests :  STD_LOGIC;
                signal onchip_memory_s1_reg_firsttransfer :  STD_LOGIC;
                signal onchip_memory_s1_slavearbiterlockenable :  STD_LOGIC;
                signal onchip_memory_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal onchip_memory_s1_unreg_firsttransfer :  STD_LOGIC;
                signal onchip_memory_s1_waits_for_read :  STD_LOGIC;
                signal onchip_memory_s1_waits_for_write :  STD_LOGIC;
                signal p1_cpu_data_master_read_data_valid_onchip_memory_s1_shift_register :  STD_LOGIC;
                signal shifted_address_to_onchip_memory_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_onchip_memory_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT onchip_memory_s1_end_xfer;
      end if;
    end if;

  end process;

  onchip_memory_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_onchip_memory_s1);
  --assign onchip_memory_s1_readdata_from_sa = onchip_memory_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  onchip_memory_s1_readdata_from_sa <= onchip_memory_s1_readdata;
  internal_cpu_data_master_requests_onchip_memory_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 13) & std_logic_vector'("0000000000000")) = std_logic_vector'("10001000000000100000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_onchip_memory_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_onchip_memory_s1 <= cpu_data_master_read_data_valid_onchip_memory_s1_shift_register_in;
  --onchip_memory_s1_arb_share_counter set values, which is an e_mux
  onchip_memory_s1_arb_share_set_values <= std_logic_vector'("001");
  --onchip_memory_s1_non_bursting_master_requests mux, which is an e_mux
  onchip_memory_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_onchip_memory_s1;
  --onchip_memory_s1_any_bursting_master_saved_grant mux, which is an e_mux
  onchip_memory_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --onchip_memory_s1_arb_share_counter_next_value assignment, which is an e_assign
  onchip_memory_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(onchip_memory_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (onchip_memory_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(onchip_memory_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (onchip_memory_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --onchip_memory_s1_allgrants all slave grants, which is an e_mux
  onchip_memory_s1_allgrants <= onchip_memory_s1_grant_vector;
  --onchip_memory_s1_end_xfer assignment, which is an e_assign
  onchip_memory_s1_end_xfer <= NOT ((onchip_memory_s1_waits_for_read OR onchip_memory_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_onchip_memory_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_onchip_memory_s1 <= onchip_memory_s1_end_xfer AND (((NOT onchip_memory_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --onchip_memory_s1_arb_share_counter arbitration counter enable, which is an e_assign
  onchip_memory_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_onchip_memory_s1 AND onchip_memory_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_onchip_memory_s1 AND NOT onchip_memory_s1_non_bursting_master_requests));
  --onchip_memory_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory_s1_arb_counter_enable) = '1' then 
        onchip_memory_s1_arb_share_counter <= onchip_memory_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --onchip_memory_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((onchip_memory_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_onchip_memory_s1)) OR ((end_xfer_arb_share_counter_term_onchip_memory_s1 AND NOT onchip_memory_s1_non_bursting_master_requests)))) = '1' then 
        onchip_memory_s1_slavearbiterlockenable <= or_reduce(onchip_memory_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master onchip_memory/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= onchip_memory_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --onchip_memory_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  onchip_memory_s1_slavearbiterlockenable2 <= or_reduce(onchip_memory_s1_arb_share_counter_next_value);
  --cpu/data_master onchip_memory/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= onchip_memory_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --onchip_memory_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  onchip_memory_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_onchip_memory_s1 <= internal_cpu_data_master_requests_onchip_memory_s1 AND NOT ((((cpu_data_master_read AND (cpu_data_master_read_data_valid_onchip_memory_s1_shift_register))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --cpu_data_master_read_data_valid_onchip_memory_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_onchip_memory_s1_shift_register_in <= ((internal_cpu_data_master_granted_onchip_memory_s1 AND cpu_data_master_read) AND NOT onchip_memory_s1_waits_for_read) AND NOT (cpu_data_master_read_data_valid_onchip_memory_s1_shift_register);
  --shift register p1 cpu_data_master_read_data_valid_onchip_memory_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_onchip_memory_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_memory_s1_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_onchip_memory_s1_shift_register_in)));
  --cpu_data_master_read_data_valid_onchip_memory_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_onchip_memory_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_onchip_memory_s1_shift_register <= p1_cpu_data_master_read_data_valid_onchip_memory_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_onchip_memory_s1, which is an e_mux
  cpu_data_master_read_data_valid_onchip_memory_s1 <= cpu_data_master_read_data_valid_onchip_memory_s1_shift_register;
  --onchip_memory_s1_writedata mux, which is an e_mux
  onchip_memory_s1_writedata <= cpu_data_master_writedata;
  --mux onchip_memory_s1_clken, which is an e_mux
  onchip_memory_s1_clken <= std_logic'('1');
  --master is always granted when requested
  internal_cpu_data_master_granted_onchip_memory_s1 <= internal_cpu_data_master_qualified_request_onchip_memory_s1;
  --cpu/data_master saved-grant onchip_memory/s1, which is an e_assign
  cpu_data_master_saved_grant_onchip_memory_s1 <= internal_cpu_data_master_requests_onchip_memory_s1;
  --allow new arb cycle for onchip_memory/s1, which is an e_assign
  onchip_memory_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  onchip_memory_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  onchip_memory_s1_master_qreq_vector <= std_logic'('1');
  onchip_memory_s1_chipselect <= internal_cpu_data_master_granted_onchip_memory_s1;
  --onchip_memory_s1_firsttransfer first transaction, which is an e_assign
  onchip_memory_s1_firsttransfer <= A_WE_StdLogic((std_logic'(onchip_memory_s1_begins_xfer) = '1'), onchip_memory_s1_unreg_firsttransfer, onchip_memory_s1_reg_firsttransfer);
  --onchip_memory_s1_unreg_firsttransfer first transaction, which is an e_assign
  onchip_memory_s1_unreg_firsttransfer <= NOT ((onchip_memory_s1_slavearbiterlockenable AND onchip_memory_s1_any_continuerequest));
  --onchip_memory_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      onchip_memory_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(onchip_memory_s1_begins_xfer) = '1' then 
        onchip_memory_s1_reg_firsttransfer <= onchip_memory_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --onchip_memory_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  onchip_memory_s1_beginbursttransfer_internal <= onchip_memory_s1_begins_xfer;
  --onchip_memory_s1_write assignment, which is an e_mux
  onchip_memory_s1_write <= internal_cpu_data_master_granted_onchip_memory_s1 AND cpu_data_master_write;
  shifted_address_to_onchip_memory_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --onchip_memory_s1_address mux, which is an e_mux
  onchip_memory_s1_address <= A_EXT (A_SRL(shifted_address_to_onchip_memory_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 11);
  --d1_onchip_memory_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_onchip_memory_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_onchip_memory_s1_end_xfer <= onchip_memory_s1_end_xfer;
      end if;
    end if;

  end process;

  --onchip_memory_s1_waits_for_read in a cycle, which is an e_mux
  onchip_memory_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_memory_s1_in_a_read_cycle assignment, which is an e_assign
  onchip_memory_s1_in_a_read_cycle <= internal_cpu_data_master_granted_onchip_memory_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= onchip_memory_s1_in_a_read_cycle;
  --onchip_memory_s1_waits_for_write in a cycle, which is an e_mux
  onchip_memory_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(onchip_memory_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --onchip_memory_s1_in_a_write_cycle assignment, which is an e_assign
  onchip_memory_s1_in_a_write_cycle <= internal_cpu_data_master_granted_onchip_memory_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= onchip_memory_s1_in_a_write_cycle;
  wait_for_onchip_memory_s1_counter <= std_logic'('0');
  --onchip_memory_s1_byteenable byte enable port mux, which is an e_mux
  onchip_memory_s1_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_onchip_memory_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_onchip_memory_s1 <= internal_cpu_data_master_granted_onchip_memory_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_onchip_memory_s1 <= internal_cpu_data_master_qualified_request_onchip_memory_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_onchip_memory_s1 <= internal_cpu_data_master_requests_onchip_memory_s1;
--synthesis translate_off
    --onchip_memory/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity pio_0_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_pio_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_0_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_pio_0_s1 : OUT STD_LOGIC;
                 signal d1_pio_0_s1_end_xfer : OUT STD_LOGIC;
                 signal pio_0_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal pio_0_s1_chipselect : OUT STD_LOGIC;
                 signal pio_0_s1_reset_n : OUT STD_LOGIC;
                 signal pio_0_s1_write_n : OUT STD_LOGIC;
                 signal pio_0_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of pio_0_s1_arbitrator : entity is FALSE;
end entity pio_0_s1_arbitrator;


architecture europa of pio_0_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_pio_0_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_pio_0_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_pio_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_pio_0_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_pio_0_s1 :  STD_LOGIC;
                signal pio_0_s1_allgrants :  STD_LOGIC;
                signal pio_0_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal pio_0_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal pio_0_s1_any_continuerequest :  STD_LOGIC;
                signal pio_0_s1_arb_counter_enable :  STD_LOGIC;
                signal pio_0_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_0_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_0_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_0_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal pio_0_s1_begins_xfer :  STD_LOGIC;
                signal pio_0_s1_end_xfer :  STD_LOGIC;
                signal pio_0_s1_firsttransfer :  STD_LOGIC;
                signal pio_0_s1_grant_vector :  STD_LOGIC;
                signal pio_0_s1_in_a_read_cycle :  STD_LOGIC;
                signal pio_0_s1_in_a_write_cycle :  STD_LOGIC;
                signal pio_0_s1_master_qreq_vector :  STD_LOGIC;
                signal pio_0_s1_non_bursting_master_requests :  STD_LOGIC;
                signal pio_0_s1_reg_firsttransfer :  STD_LOGIC;
                signal pio_0_s1_slavearbiterlockenable :  STD_LOGIC;
                signal pio_0_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal pio_0_s1_unreg_firsttransfer :  STD_LOGIC;
                signal pio_0_s1_waits_for_read :  STD_LOGIC;
                signal pio_0_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_pio_0_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_pio_0_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT pio_0_s1_end_xfer;
      end if;
    end if;

  end process;

  pio_0_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_pio_0_s1);
  internal_cpu_data_master_requests_pio_0_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000000000111100000100000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --pio_0_s1_arb_share_counter set values, which is an e_mux
  pio_0_s1_arb_share_set_values <= std_logic_vector'("001");
  --pio_0_s1_non_bursting_master_requests mux, which is an e_mux
  pio_0_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_pio_0_s1;
  --pio_0_s1_any_bursting_master_saved_grant mux, which is an e_mux
  pio_0_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --pio_0_s1_arb_share_counter_next_value assignment, which is an e_assign
  pio_0_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(pio_0_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_0_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(pio_0_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_0_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --pio_0_s1_allgrants all slave grants, which is an e_mux
  pio_0_s1_allgrants <= pio_0_s1_grant_vector;
  --pio_0_s1_end_xfer assignment, which is an e_assign
  pio_0_s1_end_xfer <= NOT ((pio_0_s1_waits_for_read OR pio_0_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_pio_0_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_pio_0_s1 <= pio_0_s1_end_xfer AND (((NOT pio_0_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --pio_0_s1_arb_share_counter arbitration counter enable, which is an e_assign
  pio_0_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_pio_0_s1 AND pio_0_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_pio_0_s1 AND NOT pio_0_s1_non_bursting_master_requests));
  --pio_0_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_0_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(pio_0_s1_arb_counter_enable) = '1' then 
        pio_0_s1_arb_share_counter <= pio_0_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --pio_0_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_0_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((pio_0_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_pio_0_s1)) OR ((end_xfer_arb_share_counter_term_pio_0_s1 AND NOT pio_0_s1_non_bursting_master_requests)))) = '1' then 
        pio_0_s1_slavearbiterlockenable <= or_reduce(pio_0_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master pio_0/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= pio_0_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --pio_0_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  pio_0_s1_slavearbiterlockenable2 <= or_reduce(pio_0_s1_arb_share_counter_next_value);
  --cpu/data_master pio_0/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= pio_0_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --pio_0_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  pio_0_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_pio_0_s1 <= internal_cpu_data_master_requests_pio_0_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --pio_0_s1_writedata mux, which is an e_mux
  pio_0_s1_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_pio_0_s1 <= internal_cpu_data_master_qualified_request_pio_0_s1;
  --cpu/data_master saved-grant pio_0/s1, which is an e_assign
  cpu_data_master_saved_grant_pio_0_s1 <= internal_cpu_data_master_requests_pio_0_s1;
  --allow new arb cycle for pio_0/s1, which is an e_assign
  pio_0_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  pio_0_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  pio_0_s1_master_qreq_vector <= std_logic'('1');
  --pio_0_s1_reset_n assignment, which is an e_assign
  pio_0_s1_reset_n <= reset_n;
  pio_0_s1_chipselect <= internal_cpu_data_master_granted_pio_0_s1;
  --pio_0_s1_firsttransfer first transaction, which is an e_assign
  pio_0_s1_firsttransfer <= A_WE_StdLogic((std_logic'(pio_0_s1_begins_xfer) = '1'), pio_0_s1_unreg_firsttransfer, pio_0_s1_reg_firsttransfer);
  --pio_0_s1_unreg_firsttransfer first transaction, which is an e_assign
  pio_0_s1_unreg_firsttransfer <= NOT ((pio_0_s1_slavearbiterlockenable AND pio_0_s1_any_continuerequest));
  --pio_0_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_0_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(pio_0_s1_begins_xfer) = '1' then 
        pio_0_s1_reg_firsttransfer <= pio_0_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --pio_0_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  pio_0_s1_beginbursttransfer_internal <= pio_0_s1_begins_xfer;
  --~pio_0_s1_write_n assignment, which is an e_mux
  pio_0_s1_write_n <= NOT ((internal_cpu_data_master_granted_pio_0_s1 AND cpu_data_master_write));
  shifted_address_to_pio_0_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --pio_0_s1_address mux, which is an e_mux
  pio_0_s1_address <= A_EXT (A_SRL(shifted_address_to_pio_0_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_pio_0_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_pio_0_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_pio_0_s1_end_xfer <= pio_0_s1_end_xfer;
      end if;
    end if;

  end process;

  --pio_0_s1_waits_for_read in a cycle, which is an e_mux
  pio_0_s1_waits_for_read <= pio_0_s1_in_a_read_cycle AND pio_0_s1_begins_xfer;
  --pio_0_s1_in_a_read_cycle assignment, which is an e_assign
  pio_0_s1_in_a_read_cycle <= internal_cpu_data_master_granted_pio_0_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= pio_0_s1_in_a_read_cycle;
  --pio_0_s1_waits_for_write in a cycle, which is an e_mux
  pio_0_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pio_0_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --pio_0_s1_in_a_write_cycle assignment, which is an e_assign
  pio_0_s1_in_a_write_cycle <= internal_cpu_data_master_granted_pio_0_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= pio_0_s1_in_a_write_cycle;
  wait_for_pio_0_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_pio_0_s1 <= internal_cpu_data_master_granted_pio_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_pio_0_s1 <= internal_cpu_data_master_qualified_request_pio_0_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_pio_0_s1 <= internal_cpu_data_master_requests_pio_0_s1;
--synthesis translate_off
    --pio_0/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity pio_1_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_pio_1_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_1_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_1_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_pio_1_s1 : OUT STD_LOGIC;
                 signal d1_pio_1_s1_end_xfer : OUT STD_LOGIC;
                 signal pio_1_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal pio_1_s1_chipselect : OUT STD_LOGIC;
                 signal pio_1_s1_reset_n : OUT STD_LOGIC;
                 signal pio_1_s1_write_n : OUT STD_LOGIC;
                 signal pio_1_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of pio_1_s1_arbitrator : entity is FALSE;
end entity pio_1_s1_arbitrator;


architecture europa of pio_1_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_pio_1_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_pio_1_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_pio_1_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_pio_1_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_pio_1_s1 :  STD_LOGIC;
                signal pio_1_s1_allgrants :  STD_LOGIC;
                signal pio_1_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal pio_1_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal pio_1_s1_any_continuerequest :  STD_LOGIC;
                signal pio_1_s1_arb_counter_enable :  STD_LOGIC;
                signal pio_1_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_1_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_1_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_1_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal pio_1_s1_begins_xfer :  STD_LOGIC;
                signal pio_1_s1_end_xfer :  STD_LOGIC;
                signal pio_1_s1_firsttransfer :  STD_LOGIC;
                signal pio_1_s1_grant_vector :  STD_LOGIC;
                signal pio_1_s1_in_a_read_cycle :  STD_LOGIC;
                signal pio_1_s1_in_a_write_cycle :  STD_LOGIC;
                signal pio_1_s1_master_qreq_vector :  STD_LOGIC;
                signal pio_1_s1_non_bursting_master_requests :  STD_LOGIC;
                signal pio_1_s1_reg_firsttransfer :  STD_LOGIC;
                signal pio_1_s1_slavearbiterlockenable :  STD_LOGIC;
                signal pio_1_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal pio_1_s1_unreg_firsttransfer :  STD_LOGIC;
                signal pio_1_s1_waits_for_read :  STD_LOGIC;
                signal pio_1_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_pio_1_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_pio_1_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT pio_1_s1_end_xfer;
      end if;
    end if;

  end process;

  pio_1_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_pio_1_s1);
  internal_cpu_data_master_requests_pio_1_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000000000111100000110000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --pio_1_s1_arb_share_counter set values, which is an e_mux
  pio_1_s1_arb_share_set_values <= std_logic_vector'("001");
  --pio_1_s1_non_bursting_master_requests mux, which is an e_mux
  pio_1_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_pio_1_s1;
  --pio_1_s1_any_bursting_master_saved_grant mux, which is an e_mux
  pio_1_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --pio_1_s1_arb_share_counter_next_value assignment, which is an e_assign
  pio_1_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(pio_1_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_1_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(pio_1_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_1_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --pio_1_s1_allgrants all slave grants, which is an e_mux
  pio_1_s1_allgrants <= pio_1_s1_grant_vector;
  --pio_1_s1_end_xfer assignment, which is an e_assign
  pio_1_s1_end_xfer <= NOT ((pio_1_s1_waits_for_read OR pio_1_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_pio_1_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_pio_1_s1 <= pio_1_s1_end_xfer AND (((NOT pio_1_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --pio_1_s1_arb_share_counter arbitration counter enable, which is an e_assign
  pio_1_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_pio_1_s1 AND pio_1_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_pio_1_s1 AND NOT pio_1_s1_non_bursting_master_requests));
  --pio_1_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_1_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(pio_1_s1_arb_counter_enable) = '1' then 
        pio_1_s1_arb_share_counter <= pio_1_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --pio_1_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_1_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((pio_1_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_pio_1_s1)) OR ((end_xfer_arb_share_counter_term_pio_1_s1 AND NOT pio_1_s1_non_bursting_master_requests)))) = '1' then 
        pio_1_s1_slavearbiterlockenable <= or_reduce(pio_1_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master pio_1/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= pio_1_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --pio_1_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  pio_1_s1_slavearbiterlockenable2 <= or_reduce(pio_1_s1_arb_share_counter_next_value);
  --cpu/data_master pio_1/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= pio_1_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --pio_1_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  pio_1_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_pio_1_s1 <= internal_cpu_data_master_requests_pio_1_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --pio_1_s1_writedata mux, which is an e_mux
  pio_1_s1_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_pio_1_s1 <= internal_cpu_data_master_qualified_request_pio_1_s1;
  --cpu/data_master saved-grant pio_1/s1, which is an e_assign
  cpu_data_master_saved_grant_pio_1_s1 <= internal_cpu_data_master_requests_pio_1_s1;
  --allow new arb cycle for pio_1/s1, which is an e_assign
  pio_1_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  pio_1_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  pio_1_s1_master_qreq_vector <= std_logic'('1');
  --pio_1_s1_reset_n assignment, which is an e_assign
  pio_1_s1_reset_n <= reset_n;
  pio_1_s1_chipselect <= internal_cpu_data_master_granted_pio_1_s1;
  --pio_1_s1_firsttransfer first transaction, which is an e_assign
  pio_1_s1_firsttransfer <= A_WE_StdLogic((std_logic'(pio_1_s1_begins_xfer) = '1'), pio_1_s1_unreg_firsttransfer, pio_1_s1_reg_firsttransfer);
  --pio_1_s1_unreg_firsttransfer first transaction, which is an e_assign
  pio_1_s1_unreg_firsttransfer <= NOT ((pio_1_s1_slavearbiterlockenable AND pio_1_s1_any_continuerequest));
  --pio_1_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_1_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(pio_1_s1_begins_xfer) = '1' then 
        pio_1_s1_reg_firsttransfer <= pio_1_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --pio_1_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  pio_1_s1_beginbursttransfer_internal <= pio_1_s1_begins_xfer;
  --~pio_1_s1_write_n assignment, which is an e_mux
  pio_1_s1_write_n <= NOT ((internal_cpu_data_master_granted_pio_1_s1 AND cpu_data_master_write));
  shifted_address_to_pio_1_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --pio_1_s1_address mux, which is an e_mux
  pio_1_s1_address <= A_EXT (A_SRL(shifted_address_to_pio_1_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_pio_1_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_pio_1_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_pio_1_s1_end_xfer <= pio_1_s1_end_xfer;
      end if;
    end if;

  end process;

  --pio_1_s1_waits_for_read in a cycle, which is an e_mux
  pio_1_s1_waits_for_read <= pio_1_s1_in_a_read_cycle AND pio_1_s1_begins_xfer;
  --pio_1_s1_in_a_read_cycle assignment, which is an e_assign
  pio_1_s1_in_a_read_cycle <= internal_cpu_data_master_granted_pio_1_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= pio_1_s1_in_a_read_cycle;
  --pio_1_s1_waits_for_write in a cycle, which is an e_mux
  pio_1_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pio_1_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --pio_1_s1_in_a_write_cycle assignment, which is an e_assign
  pio_1_s1_in_a_write_cycle <= internal_cpu_data_master_granted_pio_1_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= pio_1_s1_in_a_write_cycle;
  wait_for_pio_1_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_pio_1_s1 <= internal_cpu_data_master_granted_pio_1_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_pio_1_s1 <= internal_cpu_data_master_qualified_request_pio_1_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_pio_1_s1 <= internal_cpu_data_master_requests_pio_1_s1;
--synthesis translate_off
    --pio_1/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity pio_2_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_pio_2_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_2_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_2_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_pio_2_s1 : OUT STD_LOGIC;
                 signal d1_pio_2_s1_end_xfer : OUT STD_LOGIC;
                 signal pio_2_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal pio_2_s1_chipselect : OUT STD_LOGIC;
                 signal pio_2_s1_reset_n : OUT STD_LOGIC;
                 signal pio_2_s1_write_n : OUT STD_LOGIC;
                 signal pio_2_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of pio_2_s1_arbitrator : entity is FALSE;
end entity pio_2_s1_arbitrator;


architecture europa of pio_2_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_pio_2_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_pio_2_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_pio_2_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_pio_2_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_pio_2_s1 :  STD_LOGIC;
                signal pio_2_s1_allgrants :  STD_LOGIC;
                signal pio_2_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal pio_2_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal pio_2_s1_any_continuerequest :  STD_LOGIC;
                signal pio_2_s1_arb_counter_enable :  STD_LOGIC;
                signal pio_2_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_2_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_2_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_2_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal pio_2_s1_begins_xfer :  STD_LOGIC;
                signal pio_2_s1_end_xfer :  STD_LOGIC;
                signal pio_2_s1_firsttransfer :  STD_LOGIC;
                signal pio_2_s1_grant_vector :  STD_LOGIC;
                signal pio_2_s1_in_a_read_cycle :  STD_LOGIC;
                signal pio_2_s1_in_a_write_cycle :  STD_LOGIC;
                signal pio_2_s1_master_qreq_vector :  STD_LOGIC;
                signal pio_2_s1_non_bursting_master_requests :  STD_LOGIC;
                signal pio_2_s1_reg_firsttransfer :  STD_LOGIC;
                signal pio_2_s1_slavearbiterlockenable :  STD_LOGIC;
                signal pio_2_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal pio_2_s1_unreg_firsttransfer :  STD_LOGIC;
                signal pio_2_s1_waits_for_read :  STD_LOGIC;
                signal pio_2_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_pio_2_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_pio_2_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT pio_2_s1_end_xfer;
      end if;
    end if;

  end process;

  pio_2_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_pio_2_s1);
  internal_cpu_data_master_requests_pio_2_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000000000111100001000000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --pio_2_s1_arb_share_counter set values, which is an e_mux
  pio_2_s1_arb_share_set_values <= std_logic_vector'("001");
  --pio_2_s1_non_bursting_master_requests mux, which is an e_mux
  pio_2_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_pio_2_s1;
  --pio_2_s1_any_bursting_master_saved_grant mux, which is an e_mux
  pio_2_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --pio_2_s1_arb_share_counter_next_value assignment, which is an e_assign
  pio_2_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(pio_2_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_2_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(pio_2_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_2_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --pio_2_s1_allgrants all slave grants, which is an e_mux
  pio_2_s1_allgrants <= pio_2_s1_grant_vector;
  --pio_2_s1_end_xfer assignment, which is an e_assign
  pio_2_s1_end_xfer <= NOT ((pio_2_s1_waits_for_read OR pio_2_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_pio_2_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_pio_2_s1 <= pio_2_s1_end_xfer AND (((NOT pio_2_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --pio_2_s1_arb_share_counter arbitration counter enable, which is an e_assign
  pio_2_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_pio_2_s1 AND pio_2_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_pio_2_s1 AND NOT pio_2_s1_non_bursting_master_requests));
  --pio_2_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_2_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(pio_2_s1_arb_counter_enable) = '1' then 
        pio_2_s1_arb_share_counter <= pio_2_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --pio_2_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_2_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((pio_2_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_pio_2_s1)) OR ((end_xfer_arb_share_counter_term_pio_2_s1 AND NOT pio_2_s1_non_bursting_master_requests)))) = '1' then 
        pio_2_s1_slavearbiterlockenable <= or_reduce(pio_2_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master pio_2/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= pio_2_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --pio_2_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  pio_2_s1_slavearbiterlockenable2 <= or_reduce(pio_2_s1_arb_share_counter_next_value);
  --cpu/data_master pio_2/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= pio_2_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --pio_2_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  pio_2_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_pio_2_s1 <= internal_cpu_data_master_requests_pio_2_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --pio_2_s1_writedata mux, which is an e_mux
  pio_2_s1_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_pio_2_s1 <= internal_cpu_data_master_qualified_request_pio_2_s1;
  --cpu/data_master saved-grant pio_2/s1, which is an e_assign
  cpu_data_master_saved_grant_pio_2_s1 <= internal_cpu_data_master_requests_pio_2_s1;
  --allow new arb cycle for pio_2/s1, which is an e_assign
  pio_2_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  pio_2_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  pio_2_s1_master_qreq_vector <= std_logic'('1');
  --pio_2_s1_reset_n assignment, which is an e_assign
  pio_2_s1_reset_n <= reset_n;
  pio_2_s1_chipselect <= internal_cpu_data_master_granted_pio_2_s1;
  --pio_2_s1_firsttransfer first transaction, which is an e_assign
  pio_2_s1_firsttransfer <= A_WE_StdLogic((std_logic'(pio_2_s1_begins_xfer) = '1'), pio_2_s1_unreg_firsttransfer, pio_2_s1_reg_firsttransfer);
  --pio_2_s1_unreg_firsttransfer first transaction, which is an e_assign
  pio_2_s1_unreg_firsttransfer <= NOT ((pio_2_s1_slavearbiterlockenable AND pio_2_s1_any_continuerequest));
  --pio_2_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_2_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(pio_2_s1_begins_xfer) = '1' then 
        pio_2_s1_reg_firsttransfer <= pio_2_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --pio_2_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  pio_2_s1_beginbursttransfer_internal <= pio_2_s1_begins_xfer;
  --~pio_2_s1_write_n assignment, which is an e_mux
  pio_2_s1_write_n <= NOT ((internal_cpu_data_master_granted_pio_2_s1 AND cpu_data_master_write));
  shifted_address_to_pio_2_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --pio_2_s1_address mux, which is an e_mux
  pio_2_s1_address <= A_EXT (A_SRL(shifted_address_to_pio_2_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_pio_2_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_pio_2_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_pio_2_s1_end_xfer <= pio_2_s1_end_xfer;
      end if;
    end if;

  end process;

  --pio_2_s1_waits_for_read in a cycle, which is an e_mux
  pio_2_s1_waits_for_read <= pio_2_s1_in_a_read_cycle AND pio_2_s1_begins_xfer;
  --pio_2_s1_in_a_read_cycle assignment, which is an e_assign
  pio_2_s1_in_a_read_cycle <= internal_cpu_data_master_granted_pio_2_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= pio_2_s1_in_a_read_cycle;
  --pio_2_s1_waits_for_write in a cycle, which is an e_mux
  pio_2_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pio_2_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --pio_2_s1_in_a_write_cycle assignment, which is an e_assign
  pio_2_s1_in_a_write_cycle <= internal_cpu_data_master_granted_pio_2_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= pio_2_s1_in_a_write_cycle;
  wait_for_pio_2_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_pio_2_s1 <= internal_cpu_data_master_granted_pio_2_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_pio_2_s1 <= internal_cpu_data_master_qualified_request_pio_2_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_pio_2_s1 <= internal_cpu_data_master_requests_pio_2_s1;
--synthesis translate_off
    --pio_2/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity pio_3_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_pio_3_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_3_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_3_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_pio_3_s1 : OUT STD_LOGIC;
                 signal d1_pio_3_s1_end_xfer : OUT STD_LOGIC;
                 signal pio_3_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal pio_3_s1_chipselect : OUT STD_LOGIC;
                 signal pio_3_s1_reset_n : OUT STD_LOGIC;
                 signal pio_3_s1_write_n : OUT STD_LOGIC;
                 signal pio_3_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of pio_3_s1_arbitrator : entity is FALSE;
end entity pio_3_s1_arbitrator;


architecture europa of pio_3_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_pio_3_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_pio_3_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_pio_3_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_pio_3_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_pio_3_s1 :  STD_LOGIC;
                signal pio_3_s1_allgrants :  STD_LOGIC;
                signal pio_3_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal pio_3_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal pio_3_s1_any_continuerequest :  STD_LOGIC;
                signal pio_3_s1_arb_counter_enable :  STD_LOGIC;
                signal pio_3_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_3_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_3_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_3_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal pio_3_s1_begins_xfer :  STD_LOGIC;
                signal pio_3_s1_end_xfer :  STD_LOGIC;
                signal pio_3_s1_firsttransfer :  STD_LOGIC;
                signal pio_3_s1_grant_vector :  STD_LOGIC;
                signal pio_3_s1_in_a_read_cycle :  STD_LOGIC;
                signal pio_3_s1_in_a_write_cycle :  STD_LOGIC;
                signal pio_3_s1_master_qreq_vector :  STD_LOGIC;
                signal pio_3_s1_non_bursting_master_requests :  STD_LOGIC;
                signal pio_3_s1_reg_firsttransfer :  STD_LOGIC;
                signal pio_3_s1_slavearbiterlockenable :  STD_LOGIC;
                signal pio_3_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal pio_3_s1_unreg_firsttransfer :  STD_LOGIC;
                signal pio_3_s1_waits_for_read :  STD_LOGIC;
                signal pio_3_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_pio_3_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_pio_3_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT pio_3_s1_end_xfer;
      end if;
    end if;

  end process;

  pio_3_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_pio_3_s1);
  internal_cpu_data_master_requests_pio_3_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000000000111100001010000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --pio_3_s1_arb_share_counter set values, which is an e_mux
  pio_3_s1_arb_share_set_values <= std_logic_vector'("001");
  --pio_3_s1_non_bursting_master_requests mux, which is an e_mux
  pio_3_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_pio_3_s1;
  --pio_3_s1_any_bursting_master_saved_grant mux, which is an e_mux
  pio_3_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --pio_3_s1_arb_share_counter_next_value assignment, which is an e_assign
  pio_3_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(pio_3_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_3_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(pio_3_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_3_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --pio_3_s1_allgrants all slave grants, which is an e_mux
  pio_3_s1_allgrants <= pio_3_s1_grant_vector;
  --pio_3_s1_end_xfer assignment, which is an e_assign
  pio_3_s1_end_xfer <= NOT ((pio_3_s1_waits_for_read OR pio_3_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_pio_3_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_pio_3_s1 <= pio_3_s1_end_xfer AND (((NOT pio_3_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --pio_3_s1_arb_share_counter arbitration counter enable, which is an e_assign
  pio_3_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_pio_3_s1 AND pio_3_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_pio_3_s1 AND NOT pio_3_s1_non_bursting_master_requests));
  --pio_3_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_3_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(pio_3_s1_arb_counter_enable) = '1' then 
        pio_3_s1_arb_share_counter <= pio_3_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --pio_3_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_3_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((pio_3_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_pio_3_s1)) OR ((end_xfer_arb_share_counter_term_pio_3_s1 AND NOT pio_3_s1_non_bursting_master_requests)))) = '1' then 
        pio_3_s1_slavearbiterlockenable <= or_reduce(pio_3_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master pio_3/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= pio_3_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --pio_3_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  pio_3_s1_slavearbiterlockenable2 <= or_reduce(pio_3_s1_arb_share_counter_next_value);
  --cpu/data_master pio_3/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= pio_3_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --pio_3_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  pio_3_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_pio_3_s1 <= internal_cpu_data_master_requests_pio_3_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --pio_3_s1_writedata mux, which is an e_mux
  pio_3_s1_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_pio_3_s1 <= internal_cpu_data_master_qualified_request_pio_3_s1;
  --cpu/data_master saved-grant pio_3/s1, which is an e_assign
  cpu_data_master_saved_grant_pio_3_s1 <= internal_cpu_data_master_requests_pio_3_s1;
  --allow new arb cycle for pio_3/s1, which is an e_assign
  pio_3_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  pio_3_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  pio_3_s1_master_qreq_vector <= std_logic'('1');
  --pio_3_s1_reset_n assignment, which is an e_assign
  pio_3_s1_reset_n <= reset_n;
  pio_3_s1_chipselect <= internal_cpu_data_master_granted_pio_3_s1;
  --pio_3_s1_firsttransfer first transaction, which is an e_assign
  pio_3_s1_firsttransfer <= A_WE_StdLogic((std_logic'(pio_3_s1_begins_xfer) = '1'), pio_3_s1_unreg_firsttransfer, pio_3_s1_reg_firsttransfer);
  --pio_3_s1_unreg_firsttransfer first transaction, which is an e_assign
  pio_3_s1_unreg_firsttransfer <= NOT ((pio_3_s1_slavearbiterlockenable AND pio_3_s1_any_continuerequest));
  --pio_3_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_3_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(pio_3_s1_begins_xfer) = '1' then 
        pio_3_s1_reg_firsttransfer <= pio_3_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --pio_3_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  pio_3_s1_beginbursttransfer_internal <= pio_3_s1_begins_xfer;
  --~pio_3_s1_write_n assignment, which is an e_mux
  pio_3_s1_write_n <= NOT ((internal_cpu_data_master_granted_pio_3_s1 AND cpu_data_master_write));
  shifted_address_to_pio_3_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --pio_3_s1_address mux, which is an e_mux
  pio_3_s1_address <= A_EXT (A_SRL(shifted_address_to_pio_3_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_pio_3_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_pio_3_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_pio_3_s1_end_xfer <= pio_3_s1_end_xfer;
      end if;
    end if;

  end process;

  --pio_3_s1_waits_for_read in a cycle, which is an e_mux
  pio_3_s1_waits_for_read <= pio_3_s1_in_a_read_cycle AND pio_3_s1_begins_xfer;
  --pio_3_s1_in_a_read_cycle assignment, which is an e_assign
  pio_3_s1_in_a_read_cycle <= internal_cpu_data_master_granted_pio_3_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= pio_3_s1_in_a_read_cycle;
  --pio_3_s1_waits_for_write in a cycle, which is an e_mux
  pio_3_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pio_3_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --pio_3_s1_in_a_write_cycle assignment, which is an e_assign
  pio_3_s1_in_a_write_cycle <= internal_cpu_data_master_granted_pio_3_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= pio_3_s1_in_a_write_cycle;
  wait_for_pio_3_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_pio_3_s1 <= internal_cpu_data_master_granted_pio_3_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_pio_3_s1 <= internal_cpu_data_master_qualified_request_pio_3_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_pio_3_s1 <= internal_cpu_data_master_requests_pio_3_s1;
--synthesis translate_off
    --pio_3/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity pio_4_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_pio_4_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_4_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_4_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_pio_4_s1 : OUT STD_LOGIC;
                 signal d1_pio_4_s1_end_xfer : OUT STD_LOGIC;
                 signal pio_4_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal pio_4_s1_chipselect : OUT STD_LOGIC;
                 signal pio_4_s1_reset_n : OUT STD_LOGIC;
                 signal pio_4_s1_write_n : OUT STD_LOGIC;
                 signal pio_4_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of pio_4_s1_arbitrator : entity is FALSE;
end entity pio_4_s1_arbitrator;


architecture europa of pio_4_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_pio_4_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_pio_4_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_pio_4_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_pio_4_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_pio_4_s1 :  STD_LOGIC;
                signal pio_4_s1_allgrants :  STD_LOGIC;
                signal pio_4_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal pio_4_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal pio_4_s1_any_continuerequest :  STD_LOGIC;
                signal pio_4_s1_arb_counter_enable :  STD_LOGIC;
                signal pio_4_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_4_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_4_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_4_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal pio_4_s1_begins_xfer :  STD_LOGIC;
                signal pio_4_s1_end_xfer :  STD_LOGIC;
                signal pio_4_s1_firsttransfer :  STD_LOGIC;
                signal pio_4_s1_grant_vector :  STD_LOGIC;
                signal pio_4_s1_in_a_read_cycle :  STD_LOGIC;
                signal pio_4_s1_in_a_write_cycle :  STD_LOGIC;
                signal pio_4_s1_master_qreq_vector :  STD_LOGIC;
                signal pio_4_s1_non_bursting_master_requests :  STD_LOGIC;
                signal pio_4_s1_reg_firsttransfer :  STD_LOGIC;
                signal pio_4_s1_slavearbiterlockenable :  STD_LOGIC;
                signal pio_4_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal pio_4_s1_unreg_firsttransfer :  STD_LOGIC;
                signal pio_4_s1_waits_for_read :  STD_LOGIC;
                signal pio_4_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_pio_4_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_pio_4_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT pio_4_s1_end_xfer;
      end if;
    end if;

  end process;

  pio_4_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_pio_4_s1);
  internal_cpu_data_master_requests_pio_4_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000000000111100001100000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --pio_4_s1_arb_share_counter set values, which is an e_mux
  pio_4_s1_arb_share_set_values <= std_logic_vector'("001");
  --pio_4_s1_non_bursting_master_requests mux, which is an e_mux
  pio_4_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_pio_4_s1;
  --pio_4_s1_any_bursting_master_saved_grant mux, which is an e_mux
  pio_4_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --pio_4_s1_arb_share_counter_next_value assignment, which is an e_assign
  pio_4_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(pio_4_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_4_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(pio_4_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_4_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --pio_4_s1_allgrants all slave grants, which is an e_mux
  pio_4_s1_allgrants <= pio_4_s1_grant_vector;
  --pio_4_s1_end_xfer assignment, which is an e_assign
  pio_4_s1_end_xfer <= NOT ((pio_4_s1_waits_for_read OR pio_4_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_pio_4_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_pio_4_s1 <= pio_4_s1_end_xfer AND (((NOT pio_4_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --pio_4_s1_arb_share_counter arbitration counter enable, which is an e_assign
  pio_4_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_pio_4_s1 AND pio_4_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_pio_4_s1 AND NOT pio_4_s1_non_bursting_master_requests));
  --pio_4_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_4_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(pio_4_s1_arb_counter_enable) = '1' then 
        pio_4_s1_arb_share_counter <= pio_4_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --pio_4_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_4_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((pio_4_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_pio_4_s1)) OR ((end_xfer_arb_share_counter_term_pio_4_s1 AND NOT pio_4_s1_non_bursting_master_requests)))) = '1' then 
        pio_4_s1_slavearbiterlockenable <= or_reduce(pio_4_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master pio_4/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= pio_4_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --pio_4_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  pio_4_s1_slavearbiterlockenable2 <= or_reduce(pio_4_s1_arb_share_counter_next_value);
  --cpu/data_master pio_4/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= pio_4_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --pio_4_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  pio_4_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_pio_4_s1 <= internal_cpu_data_master_requests_pio_4_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --pio_4_s1_writedata mux, which is an e_mux
  pio_4_s1_writedata <= cpu_data_master_writedata;
  --master is always granted when requested
  internal_cpu_data_master_granted_pio_4_s1 <= internal_cpu_data_master_qualified_request_pio_4_s1;
  --cpu/data_master saved-grant pio_4/s1, which is an e_assign
  cpu_data_master_saved_grant_pio_4_s1 <= internal_cpu_data_master_requests_pio_4_s1;
  --allow new arb cycle for pio_4/s1, which is an e_assign
  pio_4_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  pio_4_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  pio_4_s1_master_qreq_vector <= std_logic'('1');
  --pio_4_s1_reset_n assignment, which is an e_assign
  pio_4_s1_reset_n <= reset_n;
  pio_4_s1_chipselect <= internal_cpu_data_master_granted_pio_4_s1;
  --pio_4_s1_firsttransfer first transaction, which is an e_assign
  pio_4_s1_firsttransfer <= A_WE_StdLogic((std_logic'(pio_4_s1_begins_xfer) = '1'), pio_4_s1_unreg_firsttransfer, pio_4_s1_reg_firsttransfer);
  --pio_4_s1_unreg_firsttransfer first transaction, which is an e_assign
  pio_4_s1_unreg_firsttransfer <= NOT ((pio_4_s1_slavearbiterlockenable AND pio_4_s1_any_continuerequest));
  --pio_4_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_4_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(pio_4_s1_begins_xfer) = '1' then 
        pio_4_s1_reg_firsttransfer <= pio_4_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --pio_4_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  pio_4_s1_beginbursttransfer_internal <= pio_4_s1_begins_xfer;
  --~pio_4_s1_write_n assignment, which is an e_mux
  pio_4_s1_write_n <= NOT ((internal_cpu_data_master_granted_pio_4_s1 AND cpu_data_master_write));
  shifted_address_to_pio_4_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --pio_4_s1_address mux, which is an e_mux
  pio_4_s1_address <= A_EXT (A_SRL(shifted_address_to_pio_4_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_pio_4_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_pio_4_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_pio_4_s1_end_xfer <= pio_4_s1_end_xfer;
      end if;
    end if;

  end process;

  --pio_4_s1_waits_for_read in a cycle, which is an e_mux
  pio_4_s1_waits_for_read <= pio_4_s1_in_a_read_cycle AND pio_4_s1_begins_xfer;
  --pio_4_s1_in_a_read_cycle assignment, which is an e_assign
  pio_4_s1_in_a_read_cycle <= internal_cpu_data_master_granted_pio_4_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= pio_4_s1_in_a_read_cycle;
  --pio_4_s1_waits_for_write in a cycle, which is an e_mux
  pio_4_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pio_4_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --pio_4_s1_in_a_write_cycle assignment, which is an e_assign
  pio_4_s1_in_a_write_cycle <= internal_cpu_data_master_granted_pio_4_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= pio_4_s1_in_a_write_cycle;
  wait_for_pio_4_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_pio_4_s1 <= internal_cpu_data_master_granted_pio_4_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_pio_4_s1 <= internal_cpu_data_master_qualified_request_pio_4_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_pio_4_s1 <= internal_cpu_data_master_requests_pio_4_s1;
--synthesis translate_off
    --pio_4/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity pio_5_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_pio_5_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_pio_5_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_pio_5_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_pio_5_s1 : OUT STD_LOGIC;
                 signal d1_pio_5_s1_end_xfer : OUT STD_LOGIC;
                 signal pio_5_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal pio_5_s1_chipselect : OUT STD_LOGIC;
                 signal pio_5_s1_reset_n : OUT STD_LOGIC;
                 signal pio_5_s1_write_n : OUT STD_LOGIC;
                 signal pio_5_s1_writedata : OUT STD_LOGIC_VECTOR (6 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of pio_5_s1_arbitrator : entity is FALSE;
end entity pio_5_s1_arbitrator;


architecture europa of pio_5_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_pio_5_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_pio_5_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_pio_5_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_pio_5_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_pio_5_s1 :  STD_LOGIC;
                signal pio_5_s1_allgrants :  STD_LOGIC;
                signal pio_5_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal pio_5_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal pio_5_s1_any_continuerequest :  STD_LOGIC;
                signal pio_5_s1_arb_counter_enable :  STD_LOGIC;
                signal pio_5_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_5_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_5_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal pio_5_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal pio_5_s1_begins_xfer :  STD_LOGIC;
                signal pio_5_s1_end_xfer :  STD_LOGIC;
                signal pio_5_s1_firsttransfer :  STD_LOGIC;
                signal pio_5_s1_grant_vector :  STD_LOGIC;
                signal pio_5_s1_in_a_read_cycle :  STD_LOGIC;
                signal pio_5_s1_in_a_write_cycle :  STD_LOGIC;
                signal pio_5_s1_master_qreq_vector :  STD_LOGIC;
                signal pio_5_s1_non_bursting_master_requests :  STD_LOGIC;
                signal pio_5_s1_reg_firsttransfer :  STD_LOGIC;
                signal pio_5_s1_slavearbiterlockenable :  STD_LOGIC;
                signal pio_5_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal pio_5_s1_unreg_firsttransfer :  STD_LOGIC;
                signal pio_5_s1_waits_for_read :  STD_LOGIC;
                signal pio_5_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_pio_5_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_pio_5_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT pio_5_s1_end_xfer;
      end if;
    end if;

  end process;

  pio_5_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_pio_5_s1);
  internal_cpu_data_master_requests_pio_5_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 4) & std_logic_vector'("0000")) = std_logic_vector'("10001000000000111100001110000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_write;
  --pio_5_s1_arb_share_counter set values, which is an e_mux
  pio_5_s1_arb_share_set_values <= std_logic_vector'("001");
  --pio_5_s1_non_bursting_master_requests mux, which is an e_mux
  pio_5_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_pio_5_s1;
  --pio_5_s1_any_bursting_master_saved_grant mux, which is an e_mux
  pio_5_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --pio_5_s1_arb_share_counter_next_value assignment, which is an e_assign
  pio_5_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(pio_5_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_5_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(pio_5_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (pio_5_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --pio_5_s1_allgrants all slave grants, which is an e_mux
  pio_5_s1_allgrants <= pio_5_s1_grant_vector;
  --pio_5_s1_end_xfer assignment, which is an e_assign
  pio_5_s1_end_xfer <= NOT ((pio_5_s1_waits_for_read OR pio_5_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_pio_5_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_pio_5_s1 <= pio_5_s1_end_xfer AND (((NOT pio_5_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --pio_5_s1_arb_share_counter arbitration counter enable, which is an e_assign
  pio_5_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_pio_5_s1 AND pio_5_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_pio_5_s1 AND NOT pio_5_s1_non_bursting_master_requests));
  --pio_5_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_5_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(pio_5_s1_arb_counter_enable) = '1' then 
        pio_5_s1_arb_share_counter <= pio_5_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --pio_5_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_5_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((pio_5_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_pio_5_s1)) OR ((end_xfer_arb_share_counter_term_pio_5_s1 AND NOT pio_5_s1_non_bursting_master_requests)))) = '1' then 
        pio_5_s1_slavearbiterlockenable <= or_reduce(pio_5_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master pio_5/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= pio_5_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --pio_5_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  pio_5_s1_slavearbiterlockenable2 <= or_reduce(pio_5_s1_arb_share_counter_next_value);
  --cpu/data_master pio_5/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= pio_5_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --pio_5_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  pio_5_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_pio_5_s1 <= internal_cpu_data_master_requests_pio_5_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --pio_5_s1_writedata mux, which is an e_mux
  pio_5_s1_writedata <= cpu_data_master_writedata (6 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_pio_5_s1 <= internal_cpu_data_master_qualified_request_pio_5_s1;
  --cpu/data_master saved-grant pio_5/s1, which is an e_assign
  cpu_data_master_saved_grant_pio_5_s1 <= internal_cpu_data_master_requests_pio_5_s1;
  --allow new arb cycle for pio_5/s1, which is an e_assign
  pio_5_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  pio_5_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  pio_5_s1_master_qreq_vector <= std_logic'('1');
  --pio_5_s1_reset_n assignment, which is an e_assign
  pio_5_s1_reset_n <= reset_n;
  pio_5_s1_chipselect <= internal_cpu_data_master_granted_pio_5_s1;
  --pio_5_s1_firsttransfer first transaction, which is an e_assign
  pio_5_s1_firsttransfer <= A_WE_StdLogic((std_logic'(pio_5_s1_begins_xfer) = '1'), pio_5_s1_unreg_firsttransfer, pio_5_s1_reg_firsttransfer);
  --pio_5_s1_unreg_firsttransfer first transaction, which is an e_assign
  pio_5_s1_unreg_firsttransfer <= NOT ((pio_5_s1_slavearbiterlockenable AND pio_5_s1_any_continuerequest));
  --pio_5_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      pio_5_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(pio_5_s1_begins_xfer) = '1' then 
        pio_5_s1_reg_firsttransfer <= pio_5_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --pio_5_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  pio_5_s1_beginbursttransfer_internal <= pio_5_s1_begins_xfer;
  --~pio_5_s1_write_n assignment, which is an e_mux
  pio_5_s1_write_n <= NOT ((internal_cpu_data_master_granted_pio_5_s1 AND cpu_data_master_write));
  shifted_address_to_pio_5_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --pio_5_s1_address mux, which is an e_mux
  pio_5_s1_address <= A_EXT (A_SRL(shifted_address_to_pio_5_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 2);
  --d1_pio_5_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_pio_5_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_pio_5_s1_end_xfer <= pio_5_s1_end_xfer;
      end if;
    end if;

  end process;

  --pio_5_s1_waits_for_read in a cycle, which is an e_mux
  pio_5_s1_waits_for_read <= pio_5_s1_in_a_read_cycle AND pio_5_s1_begins_xfer;
  --pio_5_s1_in_a_read_cycle assignment, which is an e_assign
  pio_5_s1_in_a_read_cycle <= internal_cpu_data_master_granted_pio_5_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= pio_5_s1_in_a_read_cycle;
  --pio_5_s1_waits_for_write in a cycle, which is an e_mux
  pio_5_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(pio_5_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --pio_5_s1_in_a_write_cycle assignment, which is an e_assign
  pio_5_s1_in_a_write_cycle <= internal_cpu_data_master_granted_pio_5_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= pio_5_s1_in_a_write_cycle;
  wait_for_pio_5_s1_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_pio_5_s1 <= internal_cpu_data_master_granted_pio_5_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_pio_5_s1 <= internal_cpu_data_master_qualified_request_pio_5_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_pio_5_s1 <= internal_cpu_data_master_requests_pio_5_s1;
--synthesis translate_off
    --pio_5/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity rdv_fifo_for_cpu_data_master_to_sdram_s1_module is 
        port (
              -- inputs:
                 signal clear_fifo : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sync_reset : IN STD_LOGIC;
                 signal write : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC;
                 signal empty : OUT STD_LOGIC;
                 signal fifo_contains_ones_n : OUT STD_LOGIC;
                 signal full : OUT STD_LOGIC
              );
end entity rdv_fifo_for_cpu_data_master_to_sdram_s1_module;


architecture europa of rdv_fifo_for_cpu_data_master_to_sdram_s1_module is
                signal full_0 :  STD_LOGIC;
                signal full_1 :  STD_LOGIC;
                signal full_2 :  STD_LOGIC;
                signal full_3 :  STD_LOGIC;
                signal full_4 :  STD_LOGIC;
                signal full_5 :  STD_LOGIC;
                signal full_6 :  STD_LOGIC;
                signal how_many_ones :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal one_count_minus_one :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal one_count_plus_one :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal p0_full_0 :  STD_LOGIC;
                signal p0_stage_0 :  STD_LOGIC;
                signal p1_full_1 :  STD_LOGIC;
                signal p1_stage_1 :  STD_LOGIC;
                signal p2_full_2 :  STD_LOGIC;
                signal p2_stage_2 :  STD_LOGIC;
                signal p3_full_3 :  STD_LOGIC;
                signal p3_stage_3 :  STD_LOGIC;
                signal p4_full_4 :  STD_LOGIC;
                signal p4_stage_4 :  STD_LOGIC;
                signal p5_full_5 :  STD_LOGIC;
                signal p5_stage_5 :  STD_LOGIC;
                signal stage_0 :  STD_LOGIC;
                signal stage_1 :  STD_LOGIC;
                signal stage_2 :  STD_LOGIC;
                signal stage_3 :  STD_LOGIC;
                signal stage_4 :  STD_LOGIC;
                signal stage_5 :  STD_LOGIC;
                signal updated_one_count :  STD_LOGIC_VECTOR (3 DOWNTO 0);

begin

  data_out <= stage_0;
  full <= full_5;
  empty <= NOT(full_0);
  full_6 <= std_logic'('0');
  --data_5, which is an e_mux
  p5_stage_5 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_6 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, data_in);
  --data_reg_5, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_5 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_5))))) = '1' then 
        if std_logic'(((sync_reset AND full_5) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_6))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_5 <= std_logic'('0');
        else
          stage_5 <= p5_stage_5;
        end if;
      end if;
    end if;

  end process;

  --control_5, which is an e_mux
  p5_full_5 <= Vector_To_Std_Logic(A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_4))), std_logic_vector'("00000000000000000000000000000000")));
  --control_reg_5, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_5 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(clear_fifo) = '1' then 
          full_5 <= std_logic'('0');
        else
          full_5 <= p5_full_5;
        end if;
      end if;
    end if;

  end process;

  --data_4, which is an e_mux
  p4_stage_4 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_5 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, stage_5);
  --data_reg_4, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_4 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_4))))) = '1' then 
        if std_logic'(((sync_reset AND full_4) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_5))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_4 <= std_logic'('0');
        else
          stage_4 <= p4_stage_4;
        end if;
      end if;
    end if;

  end process;

  --control_4, which is an e_mux
  p4_full_4 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), full_3, full_5);
  --control_reg_4, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_4 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(clear_fifo) = '1' then 
          full_4 <= std_logic'('0');
        else
          full_4 <= p4_full_4;
        end if;
      end if;
    end if;

  end process;

  --data_3, which is an e_mux
  p3_stage_3 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_4 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, stage_4);
  --data_reg_3, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_3 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_3))))) = '1' then 
        if std_logic'(((sync_reset AND full_3) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_4))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_3 <= std_logic'('0');
        else
          stage_3 <= p3_stage_3;
        end if;
      end if;
    end if;

  end process;

  --control_3, which is an e_mux
  p3_full_3 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), full_2, full_4);
  --control_reg_3, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_3 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(clear_fifo) = '1' then 
          full_3 <= std_logic'('0');
        else
          full_3 <= p3_full_3;
        end if;
      end if;
    end if;

  end process;

  --data_2, which is an e_mux
  p2_stage_2 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_3 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, stage_3);
  --data_reg_2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_2 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_2))))) = '1' then 
        if std_logic'(((sync_reset AND full_2) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_3))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_2 <= std_logic'('0');
        else
          stage_2 <= p2_stage_2;
        end if;
      end if;
    end if;

  end process;

  --control_2, which is an e_mux
  p2_full_2 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), full_1, full_3);
  --control_reg_2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_2 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(clear_fifo) = '1' then 
          full_2 <= std_logic'('0');
        else
          full_2 <= p2_full_2;
        end if;
      end if;
    end if;

  end process;

  --data_1, which is an e_mux
  p1_stage_1 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_2 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, stage_2);
  --data_reg_1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_1))))) = '1' then 
        if std_logic'(((sync_reset AND full_1) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_2))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_1 <= std_logic'('0');
        else
          stage_1 <= p1_stage_1;
        end if;
      end if;
    end if;

  end process;

  --control_1, which is an e_mux
  p1_full_1 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), full_0, full_2);
  --control_reg_1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(clear_fifo) = '1' then 
          full_1 <= std_logic'('0');
        else
          full_1 <= p1_full_1;
        end if;
      end if;
    end if;

  end process;

  --data_0, which is an e_mux
  p0_stage_0 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_1 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, stage_1);
  --data_reg_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(((sync_reset AND full_0) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_1))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_0 <= std_logic'('0');
        else
          stage_0 <= p0_stage_0;
        end if;
      end if;
    end if;

  end process;

  --control_0, which is an e_mux
  p0_full_0 <= Vector_To_Std_Logic(A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), std_logic_vector'("00000000000000000000000000000001"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_1)))));
  --control_reg_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'((clear_fifo AND NOT write)) = '1' then 
          full_0 <= std_logic'('0');
        else
          full_0 <= p0_full_0;
        end if;
      end if;
    end if;

  end process;

  one_count_plus_one <= A_EXT (((std_logic_vector'("00000000000000000000000000000") & (how_many_ones)) + std_logic_vector'("000000000000000000000000000000001")), 4);
  one_count_minus_one <= A_EXT (((std_logic_vector'("00000000000000000000000000000") & (how_many_ones)) - std_logic_vector'("000000000000000000000000000000001")), 4);
  --updated_one_count, which is an e_mux
  updated_one_count <= A_EXT (A_WE_StdLogicVector((std_logic'(((((clear_fifo OR sync_reset)) AND NOT(write)))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("0000000000000000000000000000") & (A_WE_StdLogicVector((std_logic'(((((clear_fifo OR sync_reset)) AND write))) = '1'), (std_logic_vector'("000") & (A_TOSTDLOGICVECTOR(data_in))), A_WE_StdLogicVector((std_logic'(((((read AND (data_in)) AND write) AND (stage_0)))) = '1'), how_many_ones, A_WE_StdLogicVector((std_logic'(((write AND (data_in)))) = '1'), one_count_plus_one, A_WE_StdLogicVector((std_logic'(((read AND (stage_0)))) = '1'), one_count_minus_one, how_many_ones))))))), 4);
  --counts how many ones in the data pipeline, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      how_many_ones <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR write)) = '1' then 
        how_many_ones <= updated_one_count;
      end if;
    end if;

  end process;

  --this fifo contains ones in the data pipeline, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      fifo_contains_ones_n <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR write)) = '1' then 
        fifo_contains_ones_n <= NOT (or_reduce(updated_one_count));
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sdram_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal sdram_s1_readdata : IN STD_LOGIC_VECTOR (63 DOWNTO 0);
                 signal sdram_s1_readdatavalid : IN STD_LOGIC;
                 signal sdram_s1_waitrequest : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sdram_s1 : OUT STD_LOGIC;
                 signal d1_sdram_s1_end_xfer : OUT STD_LOGIC;
                 signal sdram_s1_address : OUT STD_LOGIC_VECTOR (24 DOWNTO 0);
                 signal sdram_s1_byteenable_n : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal sdram_s1_chipselect : OUT STD_LOGIC;
                 signal sdram_s1_read_n : OUT STD_LOGIC;
                 signal sdram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (63 DOWNTO 0);
                 signal sdram_s1_reset_n : OUT STD_LOGIC;
                 signal sdram_s1_waitrequest_from_sa : OUT STD_LOGIC;
                 signal sdram_s1_write_n : OUT STD_LOGIC;
                 signal sdram_s1_writedata : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sdram_s1_arbitrator : entity is FALSE;
end entity sdram_s1_arbitrator;


architecture europa of sdram_s1_arbitrator is
component rdv_fifo_for_cpu_data_master_to_sdram_s1_module is 
           port (
                 -- inputs:
                    signal clear_fifo : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sync_reset : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC;
                    signal empty : OUT STD_LOGIC;
                    signal fifo_contains_ones_n : OUT STD_LOGIC;
                    signal full : OUT STD_LOGIC
                 );
end component rdv_fifo_for_cpu_data_master_to_sdram_s1_module;

                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_byteenable_sdram_s1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_rdv_fifo_empty_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_rdv_fifo_output_from_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_writedata_replicated :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_sdram_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC;
                signal internal_cpu_data_master_requests_sdram_s1 :  STD_LOGIC;
                signal internal_sdram_s1_waitrequest_from_sa :  STD_LOGIC;
                signal module_input :  STD_LOGIC;
                signal module_input1 :  STD_LOGIC;
                signal module_input2 :  STD_LOGIC;
                signal sdram_s1_allgrants :  STD_LOGIC;
                signal sdram_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal sdram_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal sdram_s1_any_continuerequest :  STD_LOGIC;
                signal sdram_s1_arb_counter_enable :  STD_LOGIC;
                signal sdram_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sdram_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal sdram_s1_begins_xfer :  STD_LOGIC;
                signal sdram_s1_end_xfer :  STD_LOGIC;
                signal sdram_s1_firsttransfer :  STD_LOGIC;
                signal sdram_s1_grant_vector :  STD_LOGIC;
                signal sdram_s1_in_a_read_cycle :  STD_LOGIC;
                signal sdram_s1_in_a_write_cycle :  STD_LOGIC;
                signal sdram_s1_master_qreq_vector :  STD_LOGIC;
                signal sdram_s1_move_on_to_next_transaction :  STD_LOGIC;
                signal sdram_s1_non_bursting_master_requests :  STD_LOGIC;
                signal sdram_s1_readdatavalid_from_sa :  STD_LOGIC;
                signal sdram_s1_reg_firsttransfer :  STD_LOGIC;
                signal sdram_s1_slavearbiterlockenable :  STD_LOGIC;
                signal sdram_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal sdram_s1_unreg_firsttransfer :  STD_LOGIC;
                signal sdram_s1_waits_for_read :  STD_LOGIC;
                signal sdram_s1_waits_for_write :  STD_LOGIC;
                signal shifted_address_to_sdram_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal wait_for_sdram_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sdram_s1_end_xfer;
      end if;
    end if;

  end process;

  sdram_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_sdram_s1);
  --assign sdram_s1_readdata_from_sa = sdram_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sdram_s1_readdata_from_sa <= sdram_s1_readdata;
  internal_cpu_data_master_requests_sdram_s1 <= to_std_logic(((Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_address_to_slave(28)) & std_logic_vector'("0000000000000000000000000000")) = std_logic_vector'("00000000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign sdram_s1_waitrequest_from_sa = sdram_s1_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  internal_sdram_s1_waitrequest_from_sa <= sdram_s1_waitrequest;
  --assign sdram_s1_readdatavalid_from_sa = sdram_s1_readdatavalid so that symbol knows where to group signals which may go to master only, which is an e_assign
  sdram_s1_readdatavalid_from_sa <= sdram_s1_readdatavalid;
  --sdram_s1_arb_share_counter set values, which is an e_mux
  sdram_s1_arb_share_set_values <= std_logic_vector'("001");
  --sdram_s1_non_bursting_master_requests mux, which is an e_mux
  sdram_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_sdram_s1;
  --sdram_s1_any_bursting_master_saved_grant mux, which is an e_mux
  sdram_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --sdram_s1_arb_share_counter_next_value assignment, which is an e_assign
  sdram_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sdram_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sdram_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sdram_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sdram_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sdram_s1_allgrants all slave grants, which is an e_mux
  sdram_s1_allgrants <= sdram_s1_grant_vector;
  --sdram_s1_end_xfer assignment, which is an e_assign
  sdram_s1_end_xfer <= NOT ((sdram_s1_waits_for_read OR sdram_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_sdram_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_sdram_s1 <= sdram_s1_end_xfer AND (((NOT sdram_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --sdram_s1_arb_share_counter arbitration counter enable, which is an e_assign
  sdram_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_sdram_s1 AND sdram_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_sdram_s1 AND NOT sdram_s1_non_bursting_master_requests));
  --sdram_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_arb_counter_enable) = '1' then 
        sdram_s1_arb_share_counter <= sdram_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sdram_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((sdram_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_sdram_s1)) OR ((end_xfer_arb_share_counter_term_sdram_s1 AND NOT sdram_s1_non_bursting_master_requests)))) = '1' then 
        sdram_s1_slavearbiterlockenable <= or_reduce(sdram_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sdram/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sdram_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --sdram_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  sdram_s1_slavearbiterlockenable2 <= or_reduce(sdram_s1_arb_share_counter_next_value);
  --cpu/data_master sdram/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= sdram_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --sdram_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  sdram_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_sdram_s1 <= internal_cpu_data_master_requests_sdram_s1 AND NOT ((((cpu_data_master_read AND ((NOT cpu_data_master_waitrequest OR (internal_cpu_data_master_read_data_valid_sdram_s1_shift_register))))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --unique name for sdram_s1_move_on_to_next_transaction, which is an e_assign
  sdram_s1_move_on_to_next_transaction <= sdram_s1_readdatavalid_from_sa;
  --rdv_fifo_for_cpu_data_master_to_sdram_s1, which is an e_fifo_with_registered_outputs
  rdv_fifo_for_cpu_data_master_to_sdram_s1 : rdv_fifo_for_cpu_data_master_to_sdram_s1_module
    port map(
      data_out => cpu_data_master_rdv_fifo_output_from_sdram_s1,
      empty => open,
      fifo_contains_ones_n => cpu_data_master_rdv_fifo_empty_sdram_s1,
      full => open,
      clear_fifo => module_input,
      clk => clk,
      data_in => internal_cpu_data_master_granted_sdram_s1,
      read => sdram_s1_move_on_to_next_transaction,
      reset_n => reset_n,
      sync_reset => module_input1,
      write => module_input2
    );

  module_input <= std_logic'('0');
  module_input1 <= std_logic'('0');
  module_input2 <= in_a_read_cycle AND NOT sdram_s1_waits_for_read;

  internal_cpu_data_master_read_data_valid_sdram_s1_shift_register <= NOT cpu_data_master_rdv_fifo_empty_sdram_s1;
  --local readdatavalid cpu_data_master_read_data_valid_sdram_s1, which is an e_mux
  cpu_data_master_read_data_valid_sdram_s1 <= sdram_s1_readdatavalid_from_sa;
  --replicate narrow data for wide slave
  cpu_data_master_writedata_replicated <= cpu_data_master_writedata & cpu_data_master_writedata;
  --sdram_s1_writedata mux, which is an e_mux
  sdram_s1_writedata <= cpu_data_master_writedata_replicated;
  --master is always granted when requested
  internal_cpu_data_master_granted_sdram_s1 <= internal_cpu_data_master_qualified_request_sdram_s1;
  --cpu/data_master saved-grant sdram/s1, which is an e_assign
  cpu_data_master_saved_grant_sdram_s1 <= internal_cpu_data_master_requests_sdram_s1;
  --allow new arb cycle for sdram/s1, which is an e_assign
  sdram_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  sdram_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  sdram_s1_master_qreq_vector <= std_logic'('1');
  --sdram_s1_reset_n assignment, which is an e_assign
  sdram_s1_reset_n <= reset_n;
  sdram_s1_chipselect <= internal_cpu_data_master_granted_sdram_s1;
  --sdram_s1_firsttransfer first transaction, which is an e_assign
  sdram_s1_firsttransfer <= A_WE_StdLogic((std_logic'(sdram_s1_begins_xfer) = '1'), sdram_s1_unreg_firsttransfer, sdram_s1_reg_firsttransfer);
  --sdram_s1_unreg_firsttransfer first transaction, which is an e_assign
  sdram_s1_unreg_firsttransfer <= NOT ((sdram_s1_slavearbiterlockenable AND sdram_s1_any_continuerequest));
  --sdram_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sdram_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(sdram_s1_begins_xfer) = '1' then 
        sdram_s1_reg_firsttransfer <= sdram_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --sdram_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sdram_s1_beginbursttransfer_internal <= sdram_s1_begins_xfer;
  --~sdram_s1_read_n assignment, which is an e_mux
  sdram_s1_read_n <= NOT ((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read));
  --~sdram_s1_write_n assignment, which is an e_mux
  sdram_s1_write_n <= NOT ((internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_write));
  shifted_address_to_sdram_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --sdram_s1_address mux, which is an e_mux
  sdram_s1_address <= A_EXT (A_SRL(shifted_address_to_sdram_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000011")), 25);
  --d1_sdram_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sdram_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sdram_s1_end_xfer <= sdram_s1_end_xfer;
      end if;
    end if;

  end process;

  --sdram_s1_waits_for_read in a cycle, which is an e_mux
  sdram_s1_waits_for_read <= sdram_s1_in_a_read_cycle AND internal_sdram_s1_waitrequest_from_sa;
  --sdram_s1_in_a_read_cycle assignment, which is an e_assign
  sdram_s1_in_a_read_cycle <= internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sdram_s1_in_a_read_cycle;
  --sdram_s1_waits_for_write in a cycle, which is an e_mux
  sdram_s1_waits_for_write <= sdram_s1_in_a_write_cycle AND internal_sdram_s1_waitrequest_from_sa;
  --sdram_s1_in_a_write_cycle assignment, which is an e_assign
  sdram_s1_in_a_write_cycle <= internal_cpu_data_master_granted_sdram_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sdram_s1_in_a_write_cycle;
  wait_for_sdram_s1_counter <= std_logic'('0');
  --~sdram_s1_byteenable_n byte enable port mux, which is an e_mux
  sdram_s1_byteenable_n <= A_EXT (NOT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_sdram_s1)) = '1'), (std_logic_vector'("000000000000000000000000") & (cpu_data_master_byteenable_sdram_s1)), -SIGNED(std_logic_vector'("00000000000000000000000000000001")))), 8);
  --byte_enable_mux for cpu/data_master and sdram/s1, which is an e_mux
  cpu_data_master_byteenable_sdram_s1 <= A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_data_master_address_to_slave(2)))) = std_logic_vector'("00000000000000000000000000000000"))), (std_logic_vector'("0000") & (cpu_data_master_byteenable)), (cpu_data_master_byteenable & std_logic_vector'("0000")));
  --vhdl renameroo for output signals
  cpu_data_master_granted_sdram_s1 <= internal_cpu_data_master_granted_sdram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sdram_s1 <= internal_cpu_data_master_qualified_request_sdram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_read_data_valid_sdram_s1_shift_register <= internal_cpu_data_master_read_data_valid_sdram_s1_shift_register;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sdram_s1 <= internal_cpu_data_master_requests_sdram_s1;
  --vhdl renameroo for output signals
  sdram_s1_waitrequest_from_sa <= internal_sdram_s1_waitrequest_from_sa;
--synthesis translate_off
    --sdram/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sysid_control_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                 signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                 signal sysid_control_slave_address : OUT STD_LOGIC;
                 signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of sysid_control_slave_arbitrator : entity is FALSE;
end entity sysid_control_slave_arbitrator;


architecture europa of sysid_control_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_sysid_control_slave :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_sysid_control_slave :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal internal_cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal shifted_address_to_sysid_control_slave_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal sysid_control_slave_allgrants :  STD_LOGIC;
                signal sysid_control_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal sysid_control_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal sysid_control_slave_any_continuerequest :  STD_LOGIC;
                signal sysid_control_slave_arb_counter_enable :  STD_LOGIC;
                signal sysid_control_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal sysid_control_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal sysid_control_slave_begins_xfer :  STD_LOGIC;
                signal sysid_control_slave_end_xfer :  STD_LOGIC;
                signal sysid_control_slave_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_grant_vector :  STD_LOGIC;
                signal sysid_control_slave_in_a_read_cycle :  STD_LOGIC;
                signal sysid_control_slave_in_a_write_cycle :  STD_LOGIC;
                signal sysid_control_slave_master_qreq_vector :  STD_LOGIC;
                signal sysid_control_slave_non_bursting_master_requests :  STD_LOGIC;
                signal sysid_control_slave_reg_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable :  STD_LOGIC;
                signal sysid_control_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal sysid_control_slave_unreg_firsttransfer :  STD_LOGIC;
                signal sysid_control_slave_waits_for_read :  STD_LOGIC;
                signal sysid_control_slave_waits_for_write :  STD_LOGIC;
                signal wait_for_sysid_control_slave_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT sysid_control_slave_end_xfer;
      end if;
    end if;

  end process;

  sysid_control_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_sysid_control_slave);
  --assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sysid_control_slave_readdata_from_sa <= sysid_control_slave_readdata;
  internal_cpu_data_master_requests_sysid_control_slave <= ((to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 3) & std_logic_vector'("000")) = std_logic_vector'("10001000000000111100010011000")))) AND ((cpu_data_master_read OR cpu_data_master_write)))) AND cpu_data_master_read;
  --sysid_control_slave_arb_share_counter set values, which is an e_mux
  sysid_control_slave_arb_share_set_values <= std_logic_vector'("001");
  --sysid_control_slave_non_bursting_master_requests mux, which is an e_mux
  sysid_control_slave_non_bursting_master_requests <= internal_cpu_data_master_requests_sysid_control_slave;
  --sysid_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  sysid_control_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --sysid_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  sysid_control_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(sysid_control_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sysid_control_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(sysid_control_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (sysid_control_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --sysid_control_slave_allgrants all slave grants, which is an e_mux
  sysid_control_slave_allgrants <= sysid_control_slave_grant_vector;
  --sysid_control_slave_end_xfer assignment, which is an e_assign
  sysid_control_slave_end_xfer <= NOT ((sysid_control_slave_waits_for_read OR sysid_control_slave_waits_for_write));
  --end_xfer_arb_share_counter_term_sysid_control_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_sysid_control_slave <= sysid_control_slave_end_xfer AND (((NOT sysid_control_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --sysid_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  sysid_control_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_sysid_control_slave AND sysid_control_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_sysid_control_slave AND NOT sysid_control_slave_non_bursting_master_requests));
  --sysid_control_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_arb_counter_enable) = '1' then 
        sysid_control_slave_arb_share_counter <= sysid_control_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --sysid_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((sysid_control_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_sysid_control_slave)) OR ((end_xfer_arb_share_counter_term_sysid_control_slave AND NOT sysid_control_slave_non_bursting_master_requests)))) = '1' then 
        sysid_control_slave_slavearbiterlockenable <= or_reduce(sysid_control_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master sysid/control_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= sysid_control_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --sysid_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  sysid_control_slave_slavearbiterlockenable2 <= or_reduce(sysid_control_slave_arb_share_counter_next_value);
  --cpu/data_master sysid/control_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= sysid_control_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --sysid_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  sysid_control_slave_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
  --master is always granted when requested
  internal_cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --cpu/data_master saved-grant sysid/control_slave, which is an e_assign
  cpu_data_master_saved_grant_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
  --allow new arb cycle for sysid/control_slave, which is an e_assign
  sysid_control_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  sysid_control_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  sysid_control_slave_master_qreq_vector <= std_logic'('1');
  --sysid_control_slave_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_firsttransfer <= A_WE_StdLogic((std_logic'(sysid_control_slave_begins_xfer) = '1'), sysid_control_slave_unreg_firsttransfer, sysid_control_slave_reg_firsttransfer);
  --sysid_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  sysid_control_slave_unreg_firsttransfer <= NOT ((sysid_control_slave_slavearbiterlockenable AND sysid_control_slave_any_continuerequest));
  --sysid_control_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      sysid_control_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(sysid_control_slave_begins_xfer) = '1' then 
        sysid_control_slave_reg_firsttransfer <= sysid_control_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --sysid_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  sysid_control_slave_beginbursttransfer_internal <= sysid_control_slave_begins_xfer;
  shifted_address_to_sysid_control_slave_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --sysid_control_slave_address mux, which is an e_mux
  sysid_control_slave_address <= Vector_To_Std_Logic(A_SRL(shifted_address_to_sysid_control_slave_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")));
  --d1_sysid_control_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_sysid_control_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_sysid_control_slave_end_xfer <= sysid_control_slave_end_xfer;
      end if;
    end if;

  end process;

  --sysid_control_slave_waits_for_read in a cycle, which is an e_mux
  sysid_control_slave_waits_for_read <= sysid_control_slave_in_a_read_cycle AND sysid_control_slave_begins_xfer;
  --sysid_control_slave_in_a_read_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_read_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sysid_control_slave_in_a_read_cycle;
  --sysid_control_slave_waits_for_write in a cycle, which is an e_mux
  sysid_control_slave_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(sysid_control_slave_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --sysid_control_slave_in_a_write_cycle assignment, which is an e_assign
  sysid_control_slave_in_a_write_cycle <= internal_cpu_data_master_granted_sysid_control_slave AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sysid_control_slave_in_a_write_cycle;
  wait_for_sysid_control_slave_counter <= std_logic'('0');
  --vhdl renameroo for output signals
  cpu_data_master_granted_sysid_control_slave <= internal_cpu_data_master_granted_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sysid_control_slave <= internal_cpu_data_master_qualified_request_sysid_control_slave;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sysid_control_slave <= internal_cpu_data_master_requests_sysid_control_slave;
--synthesis translate_off
    --sysid/control_slave enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tightly_coupled_data_memory_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_tightly_coupled_data_master_0_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_tightly_coupled_data_master_0_clken : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_latency_counter : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_read : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_write : IN STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal tightly_coupled_data_memory_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                 signal d1_tightly_coupled_data_memory_s1_end_xfer : OUT STD_LOGIC;
                 signal tightly_coupled_data_memory_s1_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal tightly_coupled_data_memory_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal tightly_coupled_data_memory_s1_chipselect : OUT STD_LOGIC;
                 signal tightly_coupled_data_memory_s1_clken : OUT STD_LOGIC;
                 signal tightly_coupled_data_memory_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tightly_coupled_data_memory_s1_write : OUT STD_LOGIC;
                 signal tightly_coupled_data_memory_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of tightly_coupled_data_memory_s1_arbitrator : entity is FALSE;
end entity tightly_coupled_data_memory_s1_arbitrator;


architecture europa of tightly_coupled_data_memory_s1_arbitrator is
                signal cpu_tightly_coupled_data_master_0_arbiterlock :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_arbiterlock2 :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_continuerequest :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register_in :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_saved_grant_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal internal_cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal internal_cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal p1_cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register :  STD_LOGIC;
                signal shifted_address_to_tightly_coupled_data_memory_s1_from_cpu_tightly_coupled_data_master_0 :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal tightly_coupled_data_memory_s1_allgrants :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_any_continuerequest :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_arb_counter_enable :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_arb_share_counter :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_arb_share_set_values :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_begins_xfer :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_end_xfer :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_grant_vector :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_in_a_read_cycle :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_in_a_write_cycle :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_master_qreq_vector :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_non_bursting_master_requests :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_reg_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_slavearbiterlockenable :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_unreg_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_waits_for_read :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_tightly_coupled_data_memory_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT tightly_coupled_data_memory_s1_end_xfer;
      end if;
    end if;

  end process;

  tightly_coupled_data_memory_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1);
  --assign tightly_coupled_data_memory_s1_readdata_from_sa = tightly_coupled_data_memory_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  tightly_coupled_data_memory_s1_readdata_from_sa <= tightly_coupled_data_memory_s1_readdata;
  internal_cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_tightly_coupled_data_master_0_address_to_slave(28 DOWNTO 11) & std_logic_vector'("00000000000")) = std_logic_vector'("10001000000000111000000000000")))) AND ((cpu_tightly_coupled_data_master_0_read OR cpu_tightly_coupled_data_master_0_write));
  --tightly_coupled_data_memory_s1_arb_share_counter set values, which is an e_mux
  tightly_coupled_data_memory_s1_arb_share_set_values <= std_logic'('1');
  --tightly_coupled_data_memory_s1_non_bursting_master_requests mux, which is an e_mux
  tightly_coupled_data_memory_s1_non_bursting_master_requests <= internal_cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1;
  --tightly_coupled_data_memory_s1_any_bursting_master_saved_grant mux, which is an e_mux
  tightly_coupled_data_memory_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --tightly_coupled_data_memory_s1_arb_share_counter_next_value assignment, which is an e_assign
  tightly_coupled_data_memory_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(tightly_coupled_data_memory_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_data_memory_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(tightly_coupled_data_memory_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_data_memory_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --tightly_coupled_data_memory_s1_allgrants all slave grants, which is an e_mux
  tightly_coupled_data_memory_s1_allgrants <= tightly_coupled_data_memory_s1_grant_vector;
  --tightly_coupled_data_memory_s1_end_xfer assignment, which is an e_assign
  tightly_coupled_data_memory_s1_end_xfer <= NOT ((tightly_coupled_data_memory_s1_waits_for_read OR tightly_coupled_data_memory_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_tightly_coupled_data_memory_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_tightly_coupled_data_memory_s1 <= tightly_coupled_data_memory_s1_end_xfer AND (((NOT tightly_coupled_data_memory_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --tightly_coupled_data_memory_s1_arb_share_counter arbitration counter enable, which is an e_assign
  tightly_coupled_data_memory_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_tightly_coupled_data_memory_s1 AND tightly_coupled_data_memory_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_tightly_coupled_data_memory_s1 AND NOT tightly_coupled_data_memory_s1_non_bursting_master_requests));
  --tightly_coupled_data_memory_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_data_memory_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(tightly_coupled_data_memory_s1_arb_counter_enable) = '1' then 
        tightly_coupled_data_memory_s1_arb_share_counter <= tightly_coupled_data_memory_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --tightly_coupled_data_memory_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_data_memory_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((tightly_coupled_data_memory_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_tightly_coupled_data_memory_s1)) OR ((end_xfer_arb_share_counter_term_tightly_coupled_data_memory_s1 AND NOT tightly_coupled_data_memory_s1_non_bursting_master_requests)))) = '1' then 
        tightly_coupled_data_memory_s1_slavearbiterlockenable <= tightly_coupled_data_memory_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu/tightly_coupled_data_master_0 tightly_coupled_data_memory/s1 arbiterlock, which is an e_assign
  cpu_tightly_coupled_data_master_0_arbiterlock <= tightly_coupled_data_memory_s1_slavearbiterlockenable AND cpu_tightly_coupled_data_master_0_continuerequest;
  --tightly_coupled_data_memory_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  tightly_coupled_data_memory_s1_slavearbiterlockenable2 <= tightly_coupled_data_memory_s1_arb_share_counter_next_value;
  --cpu/tightly_coupled_data_master_0 tightly_coupled_data_memory/s1 arbiterlock2, which is an e_assign
  cpu_tightly_coupled_data_master_0_arbiterlock2 <= tightly_coupled_data_memory_s1_slavearbiterlockenable2 AND cpu_tightly_coupled_data_master_0_continuerequest;
  --tightly_coupled_data_memory_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  tightly_coupled_data_memory_s1_any_continuerequest <= std_logic'('1');
  --cpu_tightly_coupled_data_master_0_continuerequest continued request, which is an e_assign
  cpu_tightly_coupled_data_master_0_continuerequest <= std_logic'('1');
  internal_cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 <= internal_cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1;
  --cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register_in <= (internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 AND cpu_tightly_coupled_data_master_0_read) AND NOT tightly_coupled_data_memory_s1_waits_for_read;
  --shift register p1 cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register) & A_ToStdLogicVector(cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register_in)));
  --cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register <= p1_cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1, which is an e_mux
  cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 <= cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1_shift_register;
  --tightly_coupled_data_memory_s1_writedata mux, which is an e_mux
  tightly_coupled_data_memory_s1_writedata <= cpu_tightly_coupled_data_master_0_writedata;
  --mux tightly_coupled_data_memory_s1_clken, which is an e_mux
  tightly_coupled_data_memory_s1_clken <= A_WE_StdLogic((std_logic'((internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1)) = '1'), cpu_tightly_coupled_data_master_0_clken, std_logic'('1'));
  --master is always granted when requested
  internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 <= internal_cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1;
  --cpu/tightly_coupled_data_master_0 saved-grant tightly_coupled_data_memory/s1, which is an e_assign
  cpu_tightly_coupled_data_master_0_saved_grant_tightly_coupled_data_memory_s1 <= internal_cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1;
  --allow new arb cycle for tightly_coupled_data_memory/s1, which is an e_assign
  tightly_coupled_data_memory_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  tightly_coupled_data_memory_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  tightly_coupled_data_memory_s1_master_qreq_vector <= std_logic'('1');
  tightly_coupled_data_memory_s1_chipselect <= internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1;
  --tightly_coupled_data_memory_s1_firsttransfer first transaction, which is an e_assign
  tightly_coupled_data_memory_s1_firsttransfer <= A_WE_StdLogic((std_logic'(tightly_coupled_data_memory_s1_begins_xfer) = '1'), tightly_coupled_data_memory_s1_unreg_firsttransfer, tightly_coupled_data_memory_s1_reg_firsttransfer);
  --tightly_coupled_data_memory_s1_unreg_firsttransfer first transaction, which is an e_assign
  tightly_coupled_data_memory_s1_unreg_firsttransfer <= NOT ((tightly_coupled_data_memory_s1_slavearbiterlockenable AND tightly_coupled_data_memory_s1_any_continuerequest));
  --tightly_coupled_data_memory_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_data_memory_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(tightly_coupled_data_memory_s1_begins_xfer) = '1' then 
        tightly_coupled_data_memory_s1_reg_firsttransfer <= tightly_coupled_data_memory_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --tightly_coupled_data_memory_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  tightly_coupled_data_memory_s1_beginbursttransfer_internal <= tightly_coupled_data_memory_s1_begins_xfer;
  --tightly_coupled_data_memory_s1_write assignment, which is an e_mux
  tightly_coupled_data_memory_s1_write <= internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 AND cpu_tightly_coupled_data_master_0_write;
  shifted_address_to_tightly_coupled_data_memory_s1_from_cpu_tightly_coupled_data_master_0 <= cpu_tightly_coupled_data_master_0_address_to_slave;
  --tightly_coupled_data_memory_s1_address mux, which is an e_mux
  tightly_coupled_data_memory_s1_address <= A_EXT (A_SRL(shifted_address_to_tightly_coupled_data_memory_s1_from_cpu_tightly_coupled_data_master_0,std_logic_vector'("00000000000000000000000000000010")), 9);
  --d1_tightly_coupled_data_memory_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_tightly_coupled_data_memory_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_tightly_coupled_data_memory_s1_end_xfer <= tightly_coupled_data_memory_s1_end_xfer;
      end if;
    end if;

  end process;

  --tightly_coupled_data_memory_s1_waits_for_read in a cycle, which is an e_mux
  tightly_coupled_data_memory_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_data_memory_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --tightly_coupled_data_memory_s1_in_a_read_cycle assignment, which is an e_assign
  tightly_coupled_data_memory_s1_in_a_read_cycle <= internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 AND cpu_tightly_coupled_data_master_0_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= tightly_coupled_data_memory_s1_in_a_read_cycle;
  --tightly_coupled_data_memory_s1_waits_for_write in a cycle, which is an e_mux
  tightly_coupled_data_memory_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_data_memory_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --tightly_coupled_data_memory_s1_in_a_write_cycle assignment, which is an e_assign
  tightly_coupled_data_memory_s1_in_a_write_cycle <= internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 AND cpu_tightly_coupled_data_master_0_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= tightly_coupled_data_memory_s1_in_a_write_cycle;
  wait_for_tightly_coupled_data_memory_s1_counter <= std_logic'('0');
  --tightly_coupled_data_memory_s1_byteenable byte enable port mux, which is an e_mux
  tightly_coupled_data_memory_s1_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_tightly_coupled_data_master_0_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 <= internal_cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1;
  --vhdl renameroo for output signals
  cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 <= internal_cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1;
  --vhdl renameroo for output signals
  cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 <= internal_cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1;
--synthesis translate_off
    --tightly_coupled_data_memory/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tightly_coupled_instruction_memory_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_tightly_coupled_instruction_master_0_clken : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_latency_counter : IN STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                 signal cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                 signal d1_tightly_coupled_instruction_memory_s1_end_xfer : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s1_address : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal tightly_coupled_instruction_memory_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal tightly_coupled_instruction_memory_s1_chipselect : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s1_clken : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tightly_coupled_instruction_memory_s1_write : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of tightly_coupled_instruction_memory_s1_arbitrator : entity is FALSE;
end entity tightly_coupled_instruction_memory_s1_arbitrator;


architecture europa of tightly_coupled_instruction_memory_s1_arbitrator is
                signal cpu_tightly_coupled_instruction_master_0_arbiterlock :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_arbiterlock2 :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_continuerequest :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register_in :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_saved_grant_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal internal_cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal internal_cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal p1_cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register :  STD_LOGIC;
                signal shifted_address_to_tightly_coupled_instruction_memory_s1_from_cpu_tightly_coupled_instruction_master_0 :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s1_allgrants :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_any_continuerequest :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_arb_counter_enable :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_arb_share_counter :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_arb_share_counter_next_value :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_arb_share_set_values :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_begins_xfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_end_xfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_grant_vector :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_in_a_read_cycle :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_in_a_write_cycle :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_master_qreq_vector :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_non_bursting_master_requests :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_reg_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_slavearbiterlockenable :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_unreg_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_waits_for_read :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_tightly_coupled_instruction_memory_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT tightly_coupled_instruction_memory_s1_end_xfer;
      end if;
    end if;

  end process;

  tightly_coupled_instruction_memory_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1);
  --assign tightly_coupled_instruction_memory_s1_readdata_from_sa = tightly_coupled_instruction_memory_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  tightly_coupled_instruction_memory_s1_readdata_from_sa <= tightly_coupled_instruction_memory_s1_readdata;
  internal_cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 <= ((to_std_logic(((Std_Logic_Vector'(cpu_tightly_coupled_instruction_master_0_address_to_slave(28 DOWNTO 14) & std_logic_vector'("00000000000000")) = std_logic_vector'("10001000000000000000000000000")))) AND (cpu_tightly_coupled_instruction_master_0_read))) AND cpu_tightly_coupled_instruction_master_0_read;
  --tightly_coupled_instruction_memory_s1_arb_share_counter set values, which is an e_mux
  tightly_coupled_instruction_memory_s1_arb_share_set_values <= std_logic'('1');
  --tightly_coupled_instruction_memory_s1_non_bursting_master_requests mux, which is an e_mux
  tightly_coupled_instruction_memory_s1_non_bursting_master_requests <= internal_cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1;
  --tightly_coupled_instruction_memory_s1_any_bursting_master_saved_grant mux, which is an e_mux
  tightly_coupled_instruction_memory_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --tightly_coupled_instruction_memory_s1_arb_share_counter_next_value assignment, which is an e_assign
  tightly_coupled_instruction_memory_s1_arb_share_counter_next_value <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(tightly_coupled_instruction_memory_s1_firsttransfer) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_instruction_memory_s1_arb_share_set_values))) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(tightly_coupled_instruction_memory_s1_arb_share_counter) = '1'), (((std_logic_vector'("00000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_instruction_memory_s1_arb_share_counter))) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))));
  --tightly_coupled_instruction_memory_s1_allgrants all slave grants, which is an e_mux
  tightly_coupled_instruction_memory_s1_allgrants <= tightly_coupled_instruction_memory_s1_grant_vector;
  --tightly_coupled_instruction_memory_s1_end_xfer assignment, which is an e_assign
  tightly_coupled_instruction_memory_s1_end_xfer <= NOT ((tightly_coupled_instruction_memory_s1_waits_for_read OR tightly_coupled_instruction_memory_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s1 <= tightly_coupled_instruction_memory_s1_end_xfer AND (((NOT tightly_coupled_instruction_memory_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --tightly_coupled_instruction_memory_s1_arb_share_counter arbitration counter enable, which is an e_assign
  tightly_coupled_instruction_memory_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s1 AND tightly_coupled_instruction_memory_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s1 AND NOT tightly_coupled_instruction_memory_s1_non_bursting_master_requests));
  --tightly_coupled_instruction_memory_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_instruction_memory_s1_arb_share_counter <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(tightly_coupled_instruction_memory_s1_arb_counter_enable) = '1' then 
        tightly_coupled_instruction_memory_s1_arb_share_counter <= tightly_coupled_instruction_memory_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --tightly_coupled_instruction_memory_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_instruction_memory_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((tightly_coupled_instruction_memory_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s1)) OR ((end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s1 AND NOT tightly_coupled_instruction_memory_s1_non_bursting_master_requests)))) = '1' then 
        tightly_coupled_instruction_memory_s1_slavearbiterlockenable <= tightly_coupled_instruction_memory_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --cpu/tightly_coupled_instruction_master_0 tightly_coupled_instruction_memory/s1 arbiterlock, which is an e_assign
  cpu_tightly_coupled_instruction_master_0_arbiterlock <= tightly_coupled_instruction_memory_s1_slavearbiterlockenable AND cpu_tightly_coupled_instruction_master_0_continuerequest;
  --tightly_coupled_instruction_memory_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  tightly_coupled_instruction_memory_s1_slavearbiterlockenable2 <= tightly_coupled_instruction_memory_s1_arb_share_counter_next_value;
  --cpu/tightly_coupled_instruction_master_0 tightly_coupled_instruction_memory/s1 arbiterlock2, which is an e_assign
  cpu_tightly_coupled_instruction_master_0_arbiterlock2 <= tightly_coupled_instruction_memory_s1_slavearbiterlockenable2 AND cpu_tightly_coupled_instruction_master_0_continuerequest;
  --tightly_coupled_instruction_memory_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  tightly_coupled_instruction_memory_s1_any_continuerequest <= std_logic'('1');
  --cpu_tightly_coupled_instruction_master_0_continuerequest continued request, which is an e_assign
  cpu_tightly_coupled_instruction_master_0_continuerequest <= std_logic'('1');
  internal_cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 <= internal_cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1;
  --cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register_in <= (internal_cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 AND cpu_tightly_coupled_instruction_master_0_read) AND NOT tightly_coupled_instruction_memory_s1_waits_for_read;
  --shift register p1 cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register) & A_ToStdLogicVector(cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register_in)));
  --cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register <= p1_cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1, which is an e_mux
  cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 <= cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1_shift_register;
  --mux tightly_coupled_instruction_memory_s1_clken, which is an e_mux
  tightly_coupled_instruction_memory_s1_clken <= A_WE_StdLogic((std_logic'((internal_cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1)) = '1'), cpu_tightly_coupled_instruction_master_0_clken, std_logic'('1'));
  --master is always granted when requested
  internal_cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 <= internal_cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1;
  --cpu/tightly_coupled_instruction_master_0 saved-grant tightly_coupled_instruction_memory/s1, which is an e_assign
  cpu_tightly_coupled_instruction_master_0_saved_grant_tightly_coupled_instruction_memory_s1 <= internal_cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1;
  --allow new arb cycle for tightly_coupled_instruction_memory/s1, which is an e_assign
  tightly_coupled_instruction_memory_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  tightly_coupled_instruction_memory_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  tightly_coupled_instruction_memory_s1_master_qreq_vector <= std_logic'('1');
  tightly_coupled_instruction_memory_s1_chipselect <= internal_cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1;
  --tightly_coupled_instruction_memory_s1_firsttransfer first transaction, which is an e_assign
  tightly_coupled_instruction_memory_s1_firsttransfer <= A_WE_StdLogic((std_logic'(tightly_coupled_instruction_memory_s1_begins_xfer) = '1'), tightly_coupled_instruction_memory_s1_unreg_firsttransfer, tightly_coupled_instruction_memory_s1_reg_firsttransfer);
  --tightly_coupled_instruction_memory_s1_unreg_firsttransfer first transaction, which is an e_assign
  tightly_coupled_instruction_memory_s1_unreg_firsttransfer <= NOT ((tightly_coupled_instruction_memory_s1_slavearbiterlockenable AND tightly_coupled_instruction_memory_s1_any_continuerequest));
  --tightly_coupled_instruction_memory_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_instruction_memory_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(tightly_coupled_instruction_memory_s1_begins_xfer) = '1' then 
        tightly_coupled_instruction_memory_s1_reg_firsttransfer <= tightly_coupled_instruction_memory_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --tightly_coupled_instruction_memory_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  tightly_coupled_instruction_memory_s1_beginbursttransfer_internal <= tightly_coupled_instruction_memory_s1_begins_xfer;
  --tightly_coupled_instruction_memory_s1_write assignment, which is an e_mux
  tightly_coupled_instruction_memory_s1_write <= std_logic'('0');
  shifted_address_to_tightly_coupled_instruction_memory_s1_from_cpu_tightly_coupled_instruction_master_0 <= cpu_tightly_coupled_instruction_master_0_address_to_slave;
  --tightly_coupled_instruction_memory_s1_address mux, which is an e_mux
  tightly_coupled_instruction_memory_s1_address <= A_EXT (A_SRL(shifted_address_to_tightly_coupled_instruction_memory_s1_from_cpu_tightly_coupled_instruction_master_0,std_logic_vector'("00000000000000000000000000000010")), 12);
  --d1_tightly_coupled_instruction_memory_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_tightly_coupled_instruction_memory_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_tightly_coupled_instruction_memory_s1_end_xfer <= tightly_coupled_instruction_memory_s1_end_xfer;
      end if;
    end if;

  end process;

  --tightly_coupled_instruction_memory_s1_waits_for_read in a cycle, which is an e_mux
  tightly_coupled_instruction_memory_s1_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_instruction_memory_s1_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --tightly_coupled_instruction_memory_s1_in_a_read_cycle assignment, which is an e_assign
  tightly_coupled_instruction_memory_s1_in_a_read_cycle <= internal_cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 AND cpu_tightly_coupled_instruction_master_0_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= tightly_coupled_instruction_memory_s1_in_a_read_cycle;
  --tightly_coupled_instruction_memory_s1_waits_for_write in a cycle, which is an e_mux
  tightly_coupled_instruction_memory_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_instruction_memory_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --tightly_coupled_instruction_memory_s1_in_a_write_cycle assignment, which is an e_assign
  tightly_coupled_instruction_memory_s1_in_a_write_cycle <= std_logic'('0');
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= tightly_coupled_instruction_memory_s1_in_a_write_cycle;
  wait_for_tightly_coupled_instruction_memory_s1_counter <= std_logic'('0');
  --tightly_coupled_instruction_memory_s1_byteenable byte enable port mux, which is an e_mux
  tightly_coupled_instruction_memory_s1_byteenable <= A_EXT (-SIGNED(std_logic_vector'("00000000000000000000000000000001")), 4);
  --vhdl renameroo for output signals
  cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 <= internal_cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1;
  --vhdl renameroo for output signals
  cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 <= internal_cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1;
  --vhdl renameroo for output signals
  cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 <= internal_cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1;
--synthesis translate_off
    --tightly_coupled_instruction_memory/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tightly_coupled_instruction_memory_s2_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s2_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                 signal d1_tightly_coupled_instruction_memory_s2_end_xfer : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s2_address : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                 signal tightly_coupled_instruction_memory_s2_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal tightly_coupled_instruction_memory_s2_chipselect : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s2_clken : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s2_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tightly_coupled_instruction_memory_s2_write : OUT STD_LOGIC;
                 signal tightly_coupled_instruction_memory_s2_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of tightly_coupled_instruction_memory_s2_arbitrator : entity is FALSE;
end entity tightly_coupled_instruction_memory_s2_arbitrator;


architecture europa of tightly_coupled_instruction_memory_s2_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal p1_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register :  STD_LOGIC;
                signal shifted_address_to_tightly_coupled_instruction_memory_s2_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_allgrants :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_allow_new_arb_cycle :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_any_bursting_master_saved_grant :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_any_continuerequest :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_arb_counter_enable :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_beginbursttransfer_internal :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_begins_xfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_end_xfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_grant_vector :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_in_a_read_cycle :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_in_a_write_cycle :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_master_qreq_vector :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_non_bursting_master_requests :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_reg_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_slavearbiterlockenable :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_slavearbiterlockenable2 :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_unreg_firsttransfer :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_waits_for_read :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_waits_for_write :  STD_LOGIC;
                signal wait_for_tightly_coupled_instruction_memory_s2_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT tightly_coupled_instruction_memory_s2_end_xfer;
      end if;
    end if;

  end process;

  tightly_coupled_instruction_memory_s2_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2);
  --assign tightly_coupled_instruction_memory_s2_readdata_from_sa = tightly_coupled_instruction_memory_s2_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  tightly_coupled_instruction_memory_s2_readdata_from_sa <= tightly_coupled_instruction_memory_s2_readdata;
  internal_cpu_data_master_requests_tightly_coupled_instruction_memory_s2 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 14) & std_logic_vector'("00000000000000")) = std_logic_vector'("10001000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 <= cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register_in;
  --tightly_coupled_instruction_memory_s2_arb_share_counter set values, which is an e_mux
  tightly_coupled_instruction_memory_s2_arb_share_set_values <= std_logic_vector'("001");
  --tightly_coupled_instruction_memory_s2_non_bursting_master_requests mux, which is an e_mux
  tightly_coupled_instruction_memory_s2_non_bursting_master_requests <= internal_cpu_data_master_requests_tightly_coupled_instruction_memory_s2;
  --tightly_coupled_instruction_memory_s2_any_bursting_master_saved_grant mux, which is an e_mux
  tightly_coupled_instruction_memory_s2_any_bursting_master_saved_grant <= std_logic'('0');
  --tightly_coupled_instruction_memory_s2_arb_share_counter_next_value assignment, which is an e_assign
  tightly_coupled_instruction_memory_s2_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(tightly_coupled_instruction_memory_s2_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (tightly_coupled_instruction_memory_s2_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(tightly_coupled_instruction_memory_s2_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (tightly_coupled_instruction_memory_s2_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --tightly_coupled_instruction_memory_s2_allgrants all slave grants, which is an e_mux
  tightly_coupled_instruction_memory_s2_allgrants <= tightly_coupled_instruction_memory_s2_grant_vector;
  --tightly_coupled_instruction_memory_s2_end_xfer assignment, which is an e_assign
  tightly_coupled_instruction_memory_s2_end_xfer <= NOT ((tightly_coupled_instruction_memory_s2_waits_for_read OR tightly_coupled_instruction_memory_s2_waits_for_write));
  --end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s2 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s2 <= tightly_coupled_instruction_memory_s2_end_xfer AND (((NOT tightly_coupled_instruction_memory_s2_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --tightly_coupled_instruction_memory_s2_arb_share_counter arbitration counter enable, which is an e_assign
  tightly_coupled_instruction_memory_s2_arb_counter_enable <= ((end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s2 AND tightly_coupled_instruction_memory_s2_allgrants)) OR ((end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s2 AND NOT tightly_coupled_instruction_memory_s2_non_bursting_master_requests));
  --tightly_coupled_instruction_memory_s2_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_instruction_memory_s2_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(tightly_coupled_instruction_memory_s2_arb_counter_enable) = '1' then 
        tightly_coupled_instruction_memory_s2_arb_share_counter <= tightly_coupled_instruction_memory_s2_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --tightly_coupled_instruction_memory_s2_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_instruction_memory_s2_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((tightly_coupled_instruction_memory_s2_master_qreq_vector AND end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s2)) OR ((end_xfer_arb_share_counter_term_tightly_coupled_instruction_memory_s2 AND NOT tightly_coupled_instruction_memory_s2_non_bursting_master_requests)))) = '1' then 
        tightly_coupled_instruction_memory_s2_slavearbiterlockenable <= or_reduce(tightly_coupled_instruction_memory_s2_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master tightly_coupled_instruction_memory/s2 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= tightly_coupled_instruction_memory_s2_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --tightly_coupled_instruction_memory_s2_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  tightly_coupled_instruction_memory_s2_slavearbiterlockenable2 <= or_reduce(tightly_coupled_instruction_memory_s2_arb_share_counter_next_value);
  --cpu/data_master tightly_coupled_instruction_memory/s2 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= tightly_coupled_instruction_memory_s2_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --tightly_coupled_instruction_memory_s2_any_continuerequest at least one master continues requesting, which is an e_assign
  tightly_coupled_instruction_memory_s2_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 <= internal_cpu_data_master_requests_tightly_coupled_instruction_memory_s2 AND NOT ((((cpu_data_master_read AND (cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  --cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register_in <= ((internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2 AND cpu_data_master_read) AND NOT tightly_coupled_instruction_memory_s2_waits_for_read) AND NOT (cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register);
  --shift register p1 cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register_in)));
  --cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register <= p1_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2, which is an e_mux
  cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 <= cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2_shift_register;
  --tightly_coupled_instruction_memory_s2_writedata mux, which is an e_mux
  tightly_coupled_instruction_memory_s2_writedata <= cpu_data_master_writedata;
  --mux tightly_coupled_instruction_memory_s2_clken, which is an e_mux
  tightly_coupled_instruction_memory_s2_clken <= std_logic'('1');
  --master is always granted when requested
  internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2 <= internal_cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2;
  --cpu/data_master saved-grant tightly_coupled_instruction_memory/s2, which is an e_assign
  cpu_data_master_saved_grant_tightly_coupled_instruction_memory_s2 <= internal_cpu_data_master_requests_tightly_coupled_instruction_memory_s2;
  --allow new arb cycle for tightly_coupled_instruction_memory/s2, which is an e_assign
  tightly_coupled_instruction_memory_s2_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  tightly_coupled_instruction_memory_s2_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  tightly_coupled_instruction_memory_s2_master_qreq_vector <= std_logic'('1');
  tightly_coupled_instruction_memory_s2_chipselect <= internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2;
  --tightly_coupled_instruction_memory_s2_firsttransfer first transaction, which is an e_assign
  tightly_coupled_instruction_memory_s2_firsttransfer <= A_WE_StdLogic((std_logic'(tightly_coupled_instruction_memory_s2_begins_xfer) = '1'), tightly_coupled_instruction_memory_s2_unreg_firsttransfer, tightly_coupled_instruction_memory_s2_reg_firsttransfer);
  --tightly_coupled_instruction_memory_s2_unreg_firsttransfer first transaction, which is an e_assign
  tightly_coupled_instruction_memory_s2_unreg_firsttransfer <= NOT ((tightly_coupled_instruction_memory_s2_slavearbiterlockenable AND tightly_coupled_instruction_memory_s2_any_continuerequest));
  --tightly_coupled_instruction_memory_s2_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tightly_coupled_instruction_memory_s2_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(tightly_coupled_instruction_memory_s2_begins_xfer) = '1' then 
        tightly_coupled_instruction_memory_s2_reg_firsttransfer <= tightly_coupled_instruction_memory_s2_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --tightly_coupled_instruction_memory_s2_beginbursttransfer_internal begin burst transfer, which is an e_assign
  tightly_coupled_instruction_memory_s2_beginbursttransfer_internal <= tightly_coupled_instruction_memory_s2_begins_xfer;
  --tightly_coupled_instruction_memory_s2_write assignment, which is an e_mux
  tightly_coupled_instruction_memory_s2_write <= internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2 AND cpu_data_master_write;
  shifted_address_to_tightly_coupled_instruction_memory_s2_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --tightly_coupled_instruction_memory_s2_address mux, which is an e_mux
  tightly_coupled_instruction_memory_s2_address <= A_EXT (A_SRL(shifted_address_to_tightly_coupled_instruction_memory_s2_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 12);
  --d1_tightly_coupled_instruction_memory_s2_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_tightly_coupled_instruction_memory_s2_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_tightly_coupled_instruction_memory_s2_end_xfer <= tightly_coupled_instruction_memory_s2_end_xfer;
      end if;
    end if;

  end process;

  --tightly_coupled_instruction_memory_s2_waits_for_read in a cycle, which is an e_mux
  tightly_coupled_instruction_memory_s2_waits_for_read <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_instruction_memory_s2_in_a_read_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --tightly_coupled_instruction_memory_s2_in_a_read_cycle assignment, which is an e_assign
  tightly_coupled_instruction_memory_s2_in_a_read_cycle <= internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= tightly_coupled_instruction_memory_s2_in_a_read_cycle;
  --tightly_coupled_instruction_memory_s2_waits_for_write in a cycle, which is an e_mux
  tightly_coupled_instruction_memory_s2_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(tightly_coupled_instruction_memory_s2_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --tightly_coupled_instruction_memory_s2_in_a_write_cycle assignment, which is an e_assign
  tightly_coupled_instruction_memory_s2_in_a_write_cycle <= internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= tightly_coupled_instruction_memory_s2_in_a_write_cycle;
  wait_for_tightly_coupled_instruction_memory_s2_counter <= std_logic'('0');
  --tightly_coupled_instruction_memory_s2_byteenable byte enable port mux, which is an e_mux
  tightly_coupled_instruction_memory_s2_byteenable <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2)) = '1'), (std_logic_vector'("0000000000000000000000000000") & (cpu_data_master_byteenable)), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))), 4);
  --vhdl renameroo for output signals
  cpu_data_master_granted_tightly_coupled_instruction_memory_s2 <= internal_cpu_data_master_granted_tightly_coupled_instruction_memory_s2;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 <= internal_cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2;
  --vhdl renameroo for output signals
  cpu_data_master_requests_tightly_coupled_instruction_memory_s2 <= internal_cpu_data_master_requests_tightly_coupled_instruction_memory_s2;
--synthesis translate_off
    --tightly_coupled_instruction_memory/s2 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity timer_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal reset_n : IN STD_LOGIC;
                 signal timer_s1_irq : IN STD_LOGIC;
                 signal timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_timer_s1 : OUT STD_LOGIC;
                 signal d1_timer_s1_end_xfer : OUT STD_LOGIC;
                 signal timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal timer_s1_chipselect : OUT STD_LOGIC;
                 signal timer_s1_irq_from_sa : OUT STD_LOGIC;
                 signal timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal timer_s1_reset_n : OUT STD_LOGIC;
                 signal timer_s1_write_n : OUT STD_LOGIC;
                 signal timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of timer_s1_arbitrator : entity is FALSE;
end entity timer_s1_arbitrator;


architecture europa of timer_s1_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_saved_grant_timer_s1 :  STD_LOGIC;
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_timer_s1 :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal internal_cpu_data_master_granted_timer_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_timer_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_timer_s1 :  STD_LOGIC;
                signal shifted_address_to_timer_s1_from_cpu_data_master :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal timer_s1_allgrants :  STD_LOGIC;
                signal timer_s1_allow_new_arb_cycle :  STD_LOGIC;
                signal timer_s1_any_bursting_master_saved_grant :  STD_LOGIC;
                signal timer_s1_any_continuerequest :  STD_LOGIC;
                signal timer_s1_arb_counter_enable :  STD_LOGIC;
                signal timer_s1_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer_s1_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer_s1_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer_s1_beginbursttransfer_internal :  STD_LOGIC;
                signal timer_s1_begins_xfer :  STD_LOGIC;
                signal timer_s1_end_xfer :  STD_LOGIC;
                signal timer_s1_firsttransfer :  STD_LOGIC;
                signal timer_s1_grant_vector :  STD_LOGIC;
                signal timer_s1_in_a_read_cycle :  STD_LOGIC;
                signal timer_s1_in_a_write_cycle :  STD_LOGIC;
                signal timer_s1_master_qreq_vector :  STD_LOGIC;
                signal timer_s1_non_bursting_master_requests :  STD_LOGIC;
                signal timer_s1_reg_firsttransfer :  STD_LOGIC;
                signal timer_s1_slavearbiterlockenable :  STD_LOGIC;
                signal timer_s1_slavearbiterlockenable2 :  STD_LOGIC;
                signal timer_s1_unreg_firsttransfer :  STD_LOGIC;
                signal timer_s1_waits_for_read :  STD_LOGIC;
                signal timer_s1_waits_for_write :  STD_LOGIC;
                signal wait_for_timer_s1_counter :  STD_LOGIC;

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT timer_s1_end_xfer;
      end if;
    end if;

  end process;

  timer_s1_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_timer_s1);
  --assign timer_s1_readdata_from_sa = timer_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_s1_readdata_from_sa <= timer_s1_readdata;
  internal_cpu_data_master_requests_timer_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 5) & std_logic_vector'("00000")) = std_logic_vector'("10001000000000111100000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --timer_s1_arb_share_counter set values, which is an e_mux
  timer_s1_arb_share_set_values <= std_logic_vector'("001");
  --timer_s1_non_bursting_master_requests mux, which is an e_mux
  timer_s1_non_bursting_master_requests <= internal_cpu_data_master_requests_timer_s1;
  --timer_s1_any_bursting_master_saved_grant mux, which is an e_mux
  timer_s1_any_bursting_master_saved_grant <= std_logic'('0');
  --timer_s1_arb_share_counter_next_value assignment, which is an e_assign
  timer_s1_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(timer_s1_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (timer_s1_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(timer_s1_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (timer_s1_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --timer_s1_allgrants all slave grants, which is an e_mux
  timer_s1_allgrants <= timer_s1_grant_vector;
  --timer_s1_end_xfer assignment, which is an e_assign
  timer_s1_end_xfer <= NOT ((timer_s1_waits_for_read OR timer_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_timer_s1 arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_timer_s1 <= timer_s1_end_xfer AND (((NOT timer_s1_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --timer_s1_arb_share_counter arbitration counter enable, which is an e_assign
  timer_s1_arb_counter_enable <= ((end_xfer_arb_share_counter_term_timer_s1 AND timer_s1_allgrants)) OR ((end_xfer_arb_share_counter_term_timer_s1 AND NOT timer_s1_non_bursting_master_requests));
  --timer_s1_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_s1_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(timer_s1_arb_counter_enable) = '1' then 
        timer_s1_arb_share_counter <= timer_s1_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --timer_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_s1_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((timer_s1_master_qreq_vector AND end_xfer_arb_share_counter_term_timer_s1)) OR ((end_xfer_arb_share_counter_term_timer_s1 AND NOT timer_s1_non_bursting_master_requests)))) = '1' then 
        timer_s1_slavearbiterlockenable <= or_reduce(timer_s1_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master timer/s1 arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= timer_s1_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --timer_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  timer_s1_slavearbiterlockenable2 <= or_reduce(timer_s1_arb_share_counter_next_value);
  --cpu/data_master timer/s1 arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= timer_s1_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --timer_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  timer_s1_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_timer_s1 <= internal_cpu_data_master_requests_timer_s1 AND NOT (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write));
  --timer_s1_writedata mux, which is an e_mux
  timer_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --master is always granted when requested
  internal_cpu_data_master_granted_timer_s1 <= internal_cpu_data_master_qualified_request_timer_s1;
  --cpu/data_master saved-grant timer/s1, which is an e_assign
  cpu_data_master_saved_grant_timer_s1 <= internal_cpu_data_master_requests_timer_s1;
  --allow new arb cycle for timer/s1, which is an e_assign
  timer_s1_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  timer_s1_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  timer_s1_master_qreq_vector <= std_logic'('1');
  --timer_s1_reset_n assignment, which is an e_assign
  timer_s1_reset_n <= reset_n;
  timer_s1_chipselect <= internal_cpu_data_master_granted_timer_s1;
  --timer_s1_firsttransfer first transaction, which is an e_assign
  timer_s1_firsttransfer <= A_WE_StdLogic((std_logic'(timer_s1_begins_xfer) = '1'), timer_s1_unreg_firsttransfer, timer_s1_reg_firsttransfer);
  --timer_s1_unreg_firsttransfer first transaction, which is an e_assign
  timer_s1_unreg_firsttransfer <= NOT ((timer_s1_slavearbiterlockenable AND timer_s1_any_continuerequest));
  --timer_s1_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      timer_s1_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(timer_s1_begins_xfer) = '1' then 
        timer_s1_reg_firsttransfer <= timer_s1_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --timer_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  timer_s1_beginbursttransfer_internal <= timer_s1_begins_xfer;
  --~timer_s1_write_n assignment, which is an e_mux
  timer_s1_write_n <= NOT ((internal_cpu_data_master_granted_timer_s1 AND cpu_data_master_write));
  shifted_address_to_timer_s1_from_cpu_data_master <= cpu_data_master_address_to_slave;
  --timer_s1_address mux, which is an e_mux
  timer_s1_address <= A_EXT (A_SRL(shifted_address_to_timer_s1_from_cpu_data_master,std_logic_vector'("00000000000000000000000000000010")), 3);
  --d1_timer_s1_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_timer_s1_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_timer_s1_end_xfer <= timer_s1_end_xfer;
      end if;
    end if;

  end process;

  --timer_s1_waits_for_read in a cycle, which is an e_mux
  timer_s1_waits_for_read <= timer_s1_in_a_read_cycle AND timer_s1_begins_xfer;
  --timer_s1_in_a_read_cycle assignment, which is an e_assign
  timer_s1_in_a_read_cycle <= internal_cpu_data_master_granted_timer_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= timer_s1_in_a_read_cycle;
  --timer_s1_waits_for_write in a cycle, which is an e_mux
  timer_s1_waits_for_write <= Vector_To_Std_Logic(((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(timer_s1_in_a_write_cycle))) AND std_logic_vector'("00000000000000000000000000000000")));
  --timer_s1_in_a_write_cycle assignment, which is an e_assign
  timer_s1_in_a_write_cycle <= internal_cpu_data_master_granted_timer_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= timer_s1_in_a_write_cycle;
  wait_for_timer_s1_counter <= std_logic'('0');
  --assign timer_s1_irq_from_sa = timer_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_s1_irq_from_sa <= timer_s1_irq;
  --vhdl renameroo for output signals
  cpu_data_master_granted_timer_s1 <= internal_cpu_data_master_granted_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_timer_s1 <= internal_cpu_data_master_qualified_request_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_timer_s1 <= internal_cpu_data_master_requests_timer_s1;
--synthesis translate_off
    --timer/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tri_state_bridge_avalon_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_byteenable_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_granted_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_flash_s1 : OUT STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : OUT STD_LOGIC;
                 signal flash_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                 signal flash_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                 signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                 signal select_n_to_the_flash : OUT STD_LOGIC;
                 signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal tri_state_bridge_readn : OUT STD_LOGIC;
                 signal write_n_to_the_flash : OUT STD_LOGIC
              );
attribute auto_dissolve : boolean;
attribute auto_dissolve of tri_state_bridge_avalon_slave_arbitrator : entity is FALSE;
end entity tri_state_bridge_avalon_slave_arbitrator;


architecture europa of tri_state_bridge_avalon_slave_arbitrator is
                signal cpu_data_master_arbiterlock :  STD_LOGIC;
                signal cpu_data_master_arbiterlock2 :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_0 :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_1 :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_2 :  STD_LOGIC;
                signal cpu_data_master_byteenable_flash_s1_segment_3 :  STD_LOGIC;
                signal cpu_data_master_continuerequest :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_read_data_valid_flash_s1_shift_register_in :  STD_LOGIC;
                signal cpu_data_master_saved_grant_flash_s1 :  STD_LOGIC;
                signal d1_in_a_write_cycle :  STD_LOGIC;
                signal d1_outgoing_tri_state_bridge_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal d1_reasons_to_wait :  STD_LOGIC;
                signal enable_nonzero_assertions :  STD_LOGIC;
                signal end_xfer_arb_share_counter_term_tri_state_bridge_avalon_slave :  STD_LOGIC;
                signal flash_s1_counter_load_value :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal flash_s1_in_a_read_cycle :  STD_LOGIC;
                signal flash_s1_in_a_write_cycle :  STD_LOGIC;
                signal flash_s1_pretend_byte_enable :  STD_LOGIC;
                signal flash_s1_wait_counter :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal flash_s1_waits_for_read :  STD_LOGIC;
                signal flash_s1_waits_for_write :  STD_LOGIC;
                signal flash_s1_with_write_latency :  STD_LOGIC;
                signal in_a_read_cycle :  STD_LOGIC;
                signal in_a_write_cycle :  STD_LOGIC;
                signal incoming_tri_state_bridge_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal incoming_tri_state_bridge_data_bit_0_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_1_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_2_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_3_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_4_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_5_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_6_is_x :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_bit_7_is_x :  STD_LOGIC;
                signal internal_cpu_data_master_byteenable_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_granted_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_qualified_request_flash_s1 :  STD_LOGIC;
                signal internal_cpu_data_master_requests_flash_s1 :  STD_LOGIC;
                signal internal_flash_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal outgoing_tri_state_bridge_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal p1_cpu_data_master_read_data_valid_flash_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal p1_select_n_to_the_flash :  STD_LOGIC;
                signal p1_tri_state_bridge_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal p1_tri_state_bridge_readn :  STD_LOGIC;
                signal p1_write_n_to_the_flash :  STD_LOGIC;
                signal time_to_write :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_allgrants :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_allow_new_arb_cycle :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_any_bursting_master_saved_grant :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_any_continuerequest :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_arb_counter_enable :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_arb_share_counter :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_arb_share_counter_next_value :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_arb_share_set_values :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal tri_state_bridge_avalon_slave_beginbursttransfer_internal :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_begins_xfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_end_xfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_firsttransfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_grant_vector :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_master_qreq_vector :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_non_bursting_master_requests :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_read_pending :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_reg_firsttransfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_slavearbiterlockenable :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_slavearbiterlockenable2 :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_unreg_firsttransfer :  STD_LOGIC;
                signal tri_state_bridge_avalon_slave_write_pending :  STD_LOGIC;
                signal wait_for_flash_s1_counter :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of d1_in_a_write_cycle : signal is "FAST_OUTPUT_ENABLE_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of d1_outgoing_tri_state_bridge_data : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of incoming_tri_state_bridge_data : signal is "FAST_INPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of select_n_to_the_flash : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of tri_state_bridge_address : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of tri_state_bridge_readn : signal is "FAST_OUTPUT_REGISTER=ON";
attribute ALTERA_ATTRIBUTE of write_n_to_the_flash : signal is "FAST_OUTPUT_REGISTER=ON";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_reasons_to_wait <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_reasons_to_wait <= NOT tri_state_bridge_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  tri_state_bridge_avalon_slave_begins_xfer <= NOT d1_reasons_to_wait AND (internal_cpu_data_master_qualified_request_flash_s1);
  internal_cpu_data_master_requests_flash_s1 <= to_std_logic(((Std_Logic_Vector'(cpu_data_master_address_to_slave(28 DOWNTO 24) & std_logic_vector'("000000000000000000000000")) = std_logic_vector'("10000000000000000000000000000")))) AND ((cpu_data_master_read OR cpu_data_master_write));
  --~select_n_to_the_flash of type chipselect to ~p1_select_n_to_the_flash, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      select_n_to_the_flash <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        select_n_to_the_flash <= p1_select_n_to_the_flash;
      end if;
    end if;

  end process;

  tri_state_bridge_avalon_slave_write_pending <= std_logic'('0');
  --tri_state_bridge/avalon_slave read pending calc, which is an e_assign
  tri_state_bridge_avalon_slave_read_pending <= std_logic'('0');
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_flash_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_flash_s1 <= cpu_data_master_read_data_valid_flash_s1_shift_register(0);
  --tri_state_bridge_avalon_slave_arb_share_counter set values, which is an e_mux
  tri_state_bridge_avalon_slave_arb_share_set_values <= A_EXT (A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_flash_s1)) = '1'), std_logic_vector'("00000000000000000000000000000100"), std_logic_vector'("00000000000000000000000000000001")), 3);
  --tri_state_bridge_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  tri_state_bridge_avalon_slave_non_bursting_master_requests <= internal_cpu_data_master_requests_flash_s1;
  --tri_state_bridge_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  tri_state_bridge_avalon_slave_any_bursting_master_saved_grant <= std_logic'('0');
  --tri_state_bridge_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  tri_state_bridge_avalon_slave_arb_share_counter_next_value <= A_EXT (A_WE_StdLogicVector((std_logic'(tri_state_bridge_avalon_slave_firsttransfer) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (tri_state_bridge_avalon_slave_arb_share_set_values)) - std_logic_vector'("000000000000000000000000000000001"))), A_WE_StdLogicVector((std_logic'(or_reduce(tri_state_bridge_avalon_slave_arb_share_counter)) = '1'), (((std_logic_vector'("000000000000000000000000000000") & (tri_state_bridge_avalon_slave_arb_share_counter)) - std_logic_vector'("000000000000000000000000000000001"))), std_logic_vector'("000000000000000000000000000000000"))), 3);
  --tri_state_bridge_avalon_slave_allgrants all slave grants, which is an e_mux
  tri_state_bridge_avalon_slave_allgrants <= tri_state_bridge_avalon_slave_grant_vector;
  --tri_state_bridge_avalon_slave_end_xfer assignment, which is an e_assign
  tri_state_bridge_avalon_slave_end_xfer <= NOT ((flash_s1_waits_for_read OR flash_s1_waits_for_write));
  --end_xfer_arb_share_counter_term_tri_state_bridge_avalon_slave arb share counter enable term, which is an e_assign
  end_xfer_arb_share_counter_term_tri_state_bridge_avalon_slave <= tri_state_bridge_avalon_slave_end_xfer AND (((NOT tri_state_bridge_avalon_slave_any_bursting_master_saved_grant OR in_a_read_cycle) OR in_a_write_cycle));
  --tri_state_bridge_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  tri_state_bridge_avalon_slave_arb_counter_enable <= ((end_xfer_arb_share_counter_term_tri_state_bridge_avalon_slave AND tri_state_bridge_avalon_slave_allgrants)) OR ((end_xfer_arb_share_counter_term_tri_state_bridge_avalon_slave AND NOT tri_state_bridge_avalon_slave_non_bursting_master_requests));
  --tri_state_bridge_avalon_slave_arb_share_counter counter, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_avalon_slave_arb_share_counter <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'(tri_state_bridge_avalon_slave_arb_counter_enable) = '1' then 
        tri_state_bridge_avalon_slave_arb_share_counter <= tri_state_bridge_avalon_slave_arb_share_counter_next_value;
      end if;
    end if;

  end process;

  --tri_state_bridge_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_avalon_slave_slavearbiterlockenable <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((tri_state_bridge_avalon_slave_master_qreq_vector AND end_xfer_arb_share_counter_term_tri_state_bridge_avalon_slave)) OR ((end_xfer_arb_share_counter_term_tri_state_bridge_avalon_slave AND NOT tri_state_bridge_avalon_slave_non_bursting_master_requests)))) = '1' then 
        tri_state_bridge_avalon_slave_slavearbiterlockenable <= or_reduce(tri_state_bridge_avalon_slave_arb_share_counter_next_value);
      end if;
    end if;

  end process;

  --cpu/data_master tri_state_bridge/avalon_slave arbiterlock, which is an e_assign
  cpu_data_master_arbiterlock <= tri_state_bridge_avalon_slave_slavearbiterlockenable AND cpu_data_master_continuerequest;
  --tri_state_bridge_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  tri_state_bridge_avalon_slave_slavearbiterlockenable2 <= or_reduce(tri_state_bridge_avalon_slave_arb_share_counter_next_value);
  --cpu/data_master tri_state_bridge/avalon_slave arbiterlock2, which is an e_assign
  cpu_data_master_arbiterlock2 <= tri_state_bridge_avalon_slave_slavearbiterlockenable2 AND cpu_data_master_continuerequest;
  --tri_state_bridge_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  tri_state_bridge_avalon_slave_any_continuerequest <= std_logic'('1');
  --cpu_data_master_continuerequest continued request, which is an e_assign
  cpu_data_master_continuerequest <= std_logic'('1');
  internal_cpu_data_master_qualified_request_flash_s1 <= internal_cpu_data_master_requests_flash_s1 AND NOT ((((cpu_data_master_read AND (((tri_state_bridge_avalon_slave_write_pending OR (tri_state_bridge_avalon_slave_read_pending)) OR (or_reduce(cpu_data_master_read_data_valid_flash_s1_shift_register)))))) OR (((((tri_state_bridge_avalon_slave_read_pending OR cpu_data_master_no_byte_enables_and_last_term) OR NOT(internal_cpu_data_master_byteenable_flash_s1))) AND cpu_data_master_write))));
  --cpu_data_master_read_data_valid_flash_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  cpu_data_master_read_data_valid_flash_s1_shift_register_in <= ((internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_read) AND NOT flash_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_flash_s1_shift_register));
  --shift register p1 cpu_data_master_read_data_valid_flash_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  p1_cpu_data_master_read_data_valid_flash_s1_shift_register <= A_EXT ((cpu_data_master_read_data_valid_flash_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_flash_s1_shift_register_in)), 2);
  --cpu_data_master_read_data_valid_flash_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      cpu_data_master_read_data_valid_flash_s1_shift_register <= std_logic_vector'("00");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        cpu_data_master_read_data_valid_flash_s1_shift_register <= p1_cpu_data_master_read_data_valid_flash_s1_shift_register;
      end if;
    end if;

  end process;

  --local readdatavalid cpu_data_master_read_data_valid_flash_s1, which is an e_mux
  cpu_data_master_read_data_valid_flash_s1 <= cpu_data_master_read_data_valid_flash_s1_shift_register(1);
  --tri_state_bridge_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      incoming_tri_state_bridge_data <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        incoming_tri_state_bridge_data <= tri_state_bridge_data;
      end if;
    end if;

  end process;

  --flash_s1_with_write_latency assignment, which is an e_assign
  flash_s1_with_write_latency <= in_a_write_cycle AND (internal_cpu_data_master_qualified_request_flash_s1);
  --time to write the data, which is an e_mux
  time_to_write <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((flash_s1_with_write_latency)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")));
  --d1_outgoing_tri_state_bridge_data register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_outgoing_tri_state_bridge_data <= std_logic_vector'("00000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_outgoing_tri_state_bridge_data <= outgoing_tri_state_bridge_data;
      end if;
    end if;

  end process;

  --write cycle delayed by 1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_in_a_write_cycle <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_in_a_write_cycle <= time_to_write;
      end if;
    end if;

  end process;

  --d1_outgoing_tri_state_bridge_data tristate driver, which is an e_assign
  tri_state_bridge_data <= A_WE_StdLogicVector((std_logic'((d1_in_a_write_cycle)) = '1'), d1_outgoing_tri_state_bridge_data, A_REP(std_logic'('Z'), 8));
  --outgoing_tri_state_bridge_data mux, which is an e_mux
  outgoing_tri_state_bridge_data <= cpu_data_master_dbs_write_8;
  --master is always granted when requested
  internal_cpu_data_master_granted_flash_s1 <= internal_cpu_data_master_qualified_request_flash_s1;
  --cpu/data_master saved-grant flash/s1, which is an e_assign
  cpu_data_master_saved_grant_flash_s1 <= internal_cpu_data_master_requests_flash_s1;
  --allow new arb cycle for tri_state_bridge/avalon_slave, which is an e_assign
  tri_state_bridge_avalon_slave_allow_new_arb_cycle <= std_logic'('1');
  --placeholder chosen master
  tri_state_bridge_avalon_slave_grant_vector <= std_logic'('1');
  --placeholder vector of master qualified-requests
  tri_state_bridge_avalon_slave_master_qreq_vector <= std_logic'('1');
  p1_select_n_to_the_flash <= NOT internal_cpu_data_master_granted_flash_s1;
  --tri_state_bridge_avalon_slave_firsttransfer first transaction, which is an e_assign
  tri_state_bridge_avalon_slave_firsttransfer <= A_WE_StdLogic((std_logic'(tri_state_bridge_avalon_slave_begins_xfer) = '1'), tri_state_bridge_avalon_slave_unreg_firsttransfer, tri_state_bridge_avalon_slave_reg_firsttransfer);
  --tri_state_bridge_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  tri_state_bridge_avalon_slave_unreg_firsttransfer <= NOT ((tri_state_bridge_avalon_slave_slavearbiterlockenable AND tri_state_bridge_avalon_slave_any_continuerequest));
  --tri_state_bridge_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_avalon_slave_reg_firsttransfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'(tri_state_bridge_avalon_slave_begins_xfer) = '1' then 
        tri_state_bridge_avalon_slave_reg_firsttransfer <= tri_state_bridge_avalon_slave_unreg_firsttransfer;
      end if;
    end if;

  end process;

  --tri_state_bridge_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  tri_state_bridge_avalon_slave_beginbursttransfer_internal <= tri_state_bridge_avalon_slave_begins_xfer;
  --~tri_state_bridge_readn of type read to ~p1_tri_state_bridge_readn, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_readn <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        tri_state_bridge_readn <= p1_tri_state_bridge_readn;
      end if;
    end if;

  end process;

  --~p1_tri_state_bridge_readn assignment, which is an e_mux
  p1_tri_state_bridge_readn <= NOT ((internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_read));
  --~write_n_to_the_flash of type write to ~p1_write_n_to_the_flash, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      write_n_to_the_flash <= Vector_To_Std_Logic(NOT std_logic_vector'("00000000000000000000000000000000"));
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        write_n_to_the_flash <= p1_write_n_to_the_flash;
      end if;
    end if;

  end process;

  --~p1_write_n_to_the_flash assignment, which is an e_mux
  p1_write_n_to_the_flash <= NOT (((((internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_write)) AND ((tri_state_bridge_avalon_slave_begins_xfer OR to_std_logic((((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter))>=std_logic_vector'("00000000000000000000000000000001"))))))) AND flash_s1_pretend_byte_enable));
  --tri_state_bridge_address of type address to p1_tri_state_bridge_address, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      tri_state_bridge_address <= std_logic_vector'("000000000000000000000000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        tri_state_bridge_address <= p1_tri_state_bridge_address;
      end if;
    end if;

  end process;

  --p1_tri_state_bridge_address mux, which is an e_mux
  p1_tri_state_bridge_address <= A_EXT (Std_Logic_Vector'(A_SRL(cpu_data_master_address_to_slave,std_logic_vector'("00000000000000000000000000000010")) & cpu_data_master_dbs_address(1 DOWNTO 0)), 24);
  --d1_tri_state_bridge_avalon_slave_end_xfer register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      d1_tri_state_bridge_avalon_slave_end_xfer <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        d1_tri_state_bridge_avalon_slave_end_xfer <= tri_state_bridge_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  --flash_s1_wait_counter_eq_1 assignment, which is an e_assign
  flash_s1_wait_counter_eq_1 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000001")));
  --flash_s1_waits_for_read in a cycle, which is an e_mux
  flash_s1_waits_for_read <= flash_s1_in_a_read_cycle AND wait_for_flash_s1_counter;
  --flash_s1_in_a_read_cycle assignment, which is an e_assign
  flash_s1_in_a_read_cycle <= internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= flash_s1_in_a_read_cycle;
  --flash_s1_waits_for_write in a cycle, which is an e_mux
  flash_s1_waits_for_write <= flash_s1_in_a_write_cycle AND wait_for_flash_s1_counter;
  --flash_s1_in_a_write_cycle assignment, which is an e_assign
  flash_s1_in_a_write_cycle <= internal_cpu_data_master_granted_flash_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= flash_s1_in_a_write_cycle;
  internal_flash_s1_wait_counter_eq_0 <= to_std_logic(((std_logic_vector'("0000000000000000000000000000") & (flash_s1_wait_counter)) = std_logic_vector'("00000000000000000000000000000000")));
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      flash_s1_wait_counter <= std_logic_vector'("0000");
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        flash_s1_wait_counter <= flash_s1_counter_load_value;
      end if;
    end if;

  end process;

  flash_s1_counter_load_value <= A_EXT (A_WE_StdLogicVector((std_logic'(((flash_s1_in_a_read_cycle AND tri_state_bridge_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000001001"), A_WE_StdLogicVector((std_logic'(((flash_s1_in_a_write_cycle AND tri_state_bridge_avalon_slave_begins_xfer))) = '1'), std_logic_vector'("000000000000000000000000000001010"), A_WE_StdLogicVector((std_logic'((NOT internal_flash_s1_wait_counter_eq_0)) = '1'), ((std_logic_vector'("00000000000000000000000000000") & (flash_s1_wait_counter)) - std_logic_vector'("000000000000000000000000000000001")), std_logic_vector'("000000000000000000000000000000000")))), 4);
  wait_for_flash_s1_counter <= tri_state_bridge_avalon_slave_begins_xfer OR NOT internal_flash_s1_wait_counter_eq_0;
  --flash_s1_pretend_byte_enable byte enable port mux, which is an e_mux
  flash_s1_pretend_byte_enable <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'((internal_cpu_data_master_granted_flash_s1)) = '1'), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(internal_cpu_data_master_byteenable_flash_s1))), -SIGNED(std_logic_vector'("00000000000000000000000000000001"))));
  (cpu_data_master_byteenable_flash_s1_segment_3, cpu_data_master_byteenable_flash_s1_segment_2, cpu_data_master_byteenable_flash_s1_segment_1, cpu_data_master_byteenable_flash_s1_segment_0) <= cpu_data_master_byteenable;
  internal_cpu_data_master_byteenable_flash_s1 <= A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000000"))), cpu_data_master_byteenable_flash_s1_segment_0, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000001"))), cpu_data_master_byteenable_flash_s1_segment_1, A_WE_StdLogic((((std_logic_vector'("000000000000000000000000000000") & (cpu_data_master_dbs_address(1 DOWNTO 0))) = std_logic_vector'("00000000000000000000000000000010"))), cpu_data_master_byteenable_flash_s1_segment_2, cpu_data_master_byteenable_flash_s1_segment_3)));
  --vhdl renameroo for output signals
  cpu_data_master_byteenable_flash_s1 <= internal_cpu_data_master_byteenable_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_flash_s1 <= internal_cpu_data_master_granted_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_flash_s1 <= internal_cpu_data_master_qualified_request_flash_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_flash_s1 <= internal_cpu_data_master_requests_flash_s1;
  --vhdl renameroo for output signals
  flash_s1_wait_counter_eq_0 <= internal_flash_s1_wait_counter_eq_0;
--synthesis translate_off
    --incoming_tri_state_bridge_data_bit_0_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_0_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(0))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[0] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(0) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_0_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(0));
    --incoming_tri_state_bridge_data_bit_1_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_1_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(1))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[1] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(1) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_1_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(1));
    --incoming_tri_state_bridge_data_bit_2_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_2_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(2))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[2] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(2) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_2_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(2));
    --incoming_tri_state_bridge_data_bit_3_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_3_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(3))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[3] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(3) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_3_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(3));
    --incoming_tri_state_bridge_data_bit_4_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_4_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(4))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[4] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(4) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_4_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(4));
    --incoming_tri_state_bridge_data_bit_5_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_5_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(5))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[5] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(5) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_5_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(5));
    --incoming_tri_state_bridge_data_bit_6_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_6_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(6))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[6] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(6) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_6_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(6));
    --incoming_tri_state_bridge_data_bit_7_is_x x check, which is an e_assign_is_x
    incoming_tri_state_bridge_data_bit_7_is_x <= A_WE_StdLogic(is_x(std_ulogic(incoming_tri_state_bridge_data(7))), '1','0');
    --Crush incoming_tri_state_bridge_data_with_Xs_converted_to_0[7] Xs to 0, which is an e_assign
    incoming_tri_state_bridge_data_with_Xs_converted_to_0(7) <= A_WE_StdLogic((std_logic'(incoming_tri_state_bridge_data_bit_7_is_x) = '1'), std_logic'('0'), incoming_tri_state_bridge_data(7));
    --flash/s1 enable non-zero assertions, which is an e_register
    process (clk, reset_n)
    begin
      if reset_n = '0' then
        enable_nonzero_assertions <= std_logic'('0');
      elsif clk'event and clk = '1' then
        if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
          enable_nonzero_assertions <= std_logic'('1');
        end if;
      end if;

    end process;

--synthesis translate_on
--synthesis read_comments_as_HDL on
--    
--    incoming_tri_state_bridge_data_with_Xs_converted_to_0 <= incoming_tri_state_bridge_data;
--synthesis read_comments_as_HDL off

end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tri_state_bridge_bridge_arbitrator is 
end entity tri_state_bridge_bridge_arbitrator;


architecture europa of tri_state_bridge_bridge_arbitrator is

begin


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios2_sys_reset_clk_domain_synch_module is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC
              );
end entity nios2_sys_reset_clk_domain_synch_module;


architecture europa of nios2_sys_reset_clk_domain_synch_module is
                signal data_in_d1 :  STD_LOGIC;
attribute ALTERA_ATTRIBUTE : string;
attribute ALTERA_ATTRIBUTE of data_in_d1 : signal is "MAX_DELAY=100ns ; PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101";
attribute ALTERA_ATTRIBUTE of data_out : signal is "PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101";

begin

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_in_d1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_in_d1 <= data_in;
      end if;
    end if;

  end process;

  process (clk, reset_n)
  begin
    if reset_n = '0' then
      data_out <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        data_out <= data_in_d1;
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity nios2_sys is 
        port (
              -- 1) global signals:
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- the_DM9000A
                 signal CMD_from_the_DM9000A : OUT STD_LOGIC;
                 signal CS_n_from_the_DM9000A : OUT STD_LOGIC;
                 signal INT_to_the_DM9000A : IN STD_LOGIC;
                 signal IORD_n_from_the_DM9000A : OUT STD_LOGIC;
                 signal IOWR_n_to_and_from_the_DM9000A : INOUT STD_LOGIC;
                 signal RST_n_from_the_DM9000A : OUT STD_LOGIC;
                 signal data_to_and_from_the_DM9000A : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- the_leds
                 signal out_port_from_the_leds : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);

              -- the_pio_0
                 signal out_port_from_the_pio_0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- the_pio_1
                 signal out_port_from_the_pio_1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- the_pio_2
                 signal out_port_from_the_pio_2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- the_pio_3
                 signal out_port_from_the_pio_3 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- the_pio_4
                 signal out_port_from_the_pio_4 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- the_pio_5
                 signal out_port_from_the_pio_5 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);

              -- the_sdram
                 signal zs_addr_from_the_sdram : OUT STD_LOGIC_VECTOR (12 DOWNTO 0);
                 signal zs_ba_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal zs_cas_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_cke_from_the_sdram : OUT STD_LOGIC;
                 signal zs_cs_n_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal zs_dq_to_and_from_the_sdram : INOUT STD_LOGIC_VECTOR (63 DOWNTO 0);
                 signal zs_dqm_from_the_sdram : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal zs_ras_n_from_the_sdram : OUT STD_LOGIC;
                 signal zs_we_n_from_the_sdram : OUT STD_LOGIC;

              -- the_tri_state_bridge_avalon_slave
                 signal select_n_to_the_flash : OUT STD_LOGIC;
                 signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal tri_state_bridge_readn : OUT STD_LOGIC;
                 signal write_n_to_the_flash : OUT STD_LOGIC
              );
end entity nios2_sys;


architecture europa of nios2_sys is
component DM9000A_avalon_slave_arbitrator is 
           port (
                 -- inputs:
                    signal DM9000A_avalon_slave_irq : IN STD_LOGIC;
                    signal DM9000A_avalon_slave_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal DM9000A_avalon_slave_address : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_chipselect_n : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_irq_from_sa : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_read_n : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal DM9000A_avalon_slave_reset_n : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_wait_counter_eq_1 : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_write_n : OUT STD_LOGIC;
                    signal DM9000A_avalon_slave_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_data_master_granted_DM9000A_avalon_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_DM9000A_avalon_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_DM9000A_avalon_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_DM9000A_avalon_slave : OUT STD_LOGIC;
                    signal d1_DM9000A_avalon_slave_end_xfer : OUT STD_LOGIC
                 );
end component DM9000A_avalon_slave_arbitrator;

component DM9000A is 
           port (
                 -- inputs:
                    signal CLK : IN STD_LOGIC;
                    signal INT : IN STD_LOGIC;
                    signal iCMD : IN STD_LOGIC;
                    signal iCS_n : IN STD_LOGIC;
                    signal iDATA : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal iIORD_n : IN STD_LOGIC;
                    signal iIOWR_n : IN STD_LOGIC;
                    signal iRST_n : IN STD_LOGIC;

                 -- outputs:
                    signal CMD : OUT STD_LOGIC;
                    signal CS_n : OUT STD_LOGIC;
                    signal IORD_n : OUT STD_LOGIC;
                    signal IOWR_n : INOUT STD_LOGIC;
                    signal RST_n : OUT STD_LOGIC;
                    signal data : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal oDATA : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal oINT : OUT STD_LOGIC
                 );
end component DM9000A;

component cpu_jtag_debug_module_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC;
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_resetrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal cpu_jtag_debug_module_begintransfer : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_jtag_debug_module_chipselect : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_debugaccess : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_reset : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_reset_n : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_resetrequest_from_sa : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_write : OUT STD_LOGIC;
                    signal cpu_jtag_debug_module_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : OUT STD_LOGIC
                 );
end component cpu_jtag_debug_module_arbitrator;

component cpu_data_master_arbitrator is 
           port (
                 -- inputs:
                    signal DM9000A_avalon_slave_irq_from_sa : IN STD_LOGIC;
                    signal DM9000A_avalon_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal DM9000A_avalon_slave_wait_counter_eq_0 : IN STD_LOGIC;
                    signal DM9000A_avalon_slave_wait_counter_eq_1 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_byteenable_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_debugaccess : IN STD_LOGIC;
                    signal cpu_data_master_granted_DM9000A_avalon_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_granted_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_leds_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_onchip_memory_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_pio_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_pio_1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_pio_2_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_pio_3_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_pio_4_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_pio_5_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_granted_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                    signal cpu_data_master_granted_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_DM9000A_avalon_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_leds_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_memory_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_2_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_3_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_4_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_5_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_DM9000A_avalon_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_leds_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_memory_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_2_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_3_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_4_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_5_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1_shift_register : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_DM9000A_avalon_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_data_master_requests_flash_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_leds_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_onchip_memory_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_pio_0_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_pio_1_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_pio_2_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_pio_3_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_pio_4_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_pio_5_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_sdram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : IN STD_LOGIC;
                    signal cpu_data_master_requests_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                    signal cpu_data_master_requests_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_DM9000A_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal d1_jtag_uart_avalon_jtag_slave_end_xfer : IN STD_LOGIC;
                    signal d1_leds_s1_end_xfer : IN STD_LOGIC;
                    signal d1_onchip_memory_s1_end_xfer : IN STD_LOGIC;
                    signal d1_pio_0_s1_end_xfer : IN STD_LOGIC;
                    signal d1_pio_1_s1_end_xfer : IN STD_LOGIC;
                    signal d1_pio_2_s1_end_xfer : IN STD_LOGIC;
                    signal d1_pio_3_s1_end_xfer : IN STD_LOGIC;
                    signal d1_pio_4_s1_end_xfer : IN STD_LOGIC;
                    signal d1_pio_5_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : IN STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : IN STD_LOGIC;
                    signal d1_tightly_coupled_instruction_memory_s2_end_xfer : IN STD_LOGIC;
                    signal d1_timer_s1_end_xfer : IN STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal flash_s1_wait_counter_eq_0 : IN STD_LOGIC;
                    signal flash_s1_wait_counter_eq_1 : IN STD_LOGIC;
                    signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_irq_from_sa : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : IN STD_LOGIC;
                    signal onchip_memory_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_flash_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_onchip_memory_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (63 DOWNTO 0);
                    signal sdram_s1_waitrequest_from_sa : IN STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tightly_coupled_instruction_memory_s2_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal timer_s1_irq_from_sa : IN STD_LOGIC;
                    signal timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_dbs_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_irq : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : OUT STD_LOGIC;
                    signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_data_master_arbitrator;

component cpu_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_instruction_master_granted_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_cpu_jtag_debug_module : IN STD_LOGIC;
                    signal cpu_jtag_debug_module_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_cpu_jtag_debug_module_end_xfer : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_instruction_master_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : OUT STD_LOGIC;
                    signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                    signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_instruction_master_arbitrator;

component cpu_tightly_coupled_data_master_0_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_tightly_coupled_data_master_0_clken : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_read : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_write : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d1_tightly_coupled_data_memory_s1_end_xfer : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal tightly_coupled_data_memory_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_tightly_coupled_data_master_0_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_tightly_coupled_data_master_0_latency_counter : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_tightly_coupled_data_master_0_readdatavalid : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_waitrequest : OUT STD_LOGIC
                 );
end component cpu_tightly_coupled_data_master_0_arbitrator;

component cpu_tightly_coupled_instruction_master_0_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_address : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_tightly_coupled_instruction_master_0_clken : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_read : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 : IN STD_LOGIC;
                    signal d1_tightly_coupled_instruction_memory_s1_end_xfer : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_tightly_coupled_instruction_master_0_address_to_slave : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_tightly_coupled_instruction_master_0_latency_counter : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_tightly_coupled_instruction_master_0_readdatavalid : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_waitrequest : OUT STD_LOGIC
                 );
end component cpu_tightly_coupled_instruction_master_0_arbitrator;

component cpu is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal d_irq : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_waitrequest : IN STD_LOGIC;
                    signal dcm0_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal dcm0_readdatavalid : IN STD_LOGIC;
                    signal dcm0_waitrequest : IN STD_LOGIC;
                    signal i_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_readdatavalid : IN STD_LOGIC;
                    signal i_waitrequest : IN STD_LOGIC;
                    signal icm0_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal icm0_readdatavalid : IN STD_LOGIC;
                    signal icm0_waitrequest : IN STD_LOGIC;
                    signal jtag_debug_module_address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal jtag_debug_module_begintransfer : IN STD_LOGIC;
                    signal jtag_debug_module_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal jtag_debug_module_clk : IN STD_LOGIC;
                    signal jtag_debug_module_debugaccess : IN STD_LOGIC;
                    signal jtag_debug_module_reset : IN STD_LOGIC;
                    signal jtag_debug_module_select : IN STD_LOGIC;
                    signal jtag_debug_module_write : IN STD_LOGIC;
                    signal jtag_debug_module_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal d_address : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal d_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal d_read : OUT STD_LOGIC;
                    signal d_write : OUT STD_LOGIC;
                    signal d_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal dcm0_address : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal dcm0_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal dcm0_clken : OUT STD_LOGIC;
                    signal dcm0_read : OUT STD_LOGIC;
                    signal dcm0_write : OUT STD_LOGIC;
                    signal dcm0_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_address : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal i_read : OUT STD_LOGIC;
                    signal icm0_address : OUT STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal icm0_clken : OUT STD_LOGIC;
                    signal icm0_read : OUT STD_LOGIC;
                    signal jtag_debug_module_debugaccess_to_roms : OUT STD_LOGIC;
                    signal jtag_debug_module_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_debug_module_resetrequest : OUT STD_LOGIC
                 );
end component cpu;

component jtag_uart_avalon_jtag_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_dataavailable : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_irq : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_readyfordata : IN STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_waitrequest : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave : OUT STD_LOGIC;
                    signal d1_jtag_uart_avalon_jtag_slave_end_xfer : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_address : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_chipselect : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_irq_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_read_n : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_reset_n : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_write_n : OUT STD_LOGIC;
                    signal jtag_uart_avalon_jtag_slave_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component jtag_uart_avalon_jtag_slave_arbitrator;

component jtag_uart is 
           port (
                 -- inputs:
                    signal av_address : IN STD_LOGIC;
                    signal av_chipselect : IN STD_LOGIC;
                    signal av_read_n : IN STD_LOGIC;
                    signal av_write_n : IN STD_LOGIC;
                    signal av_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal rst_n : IN STD_LOGIC;

                 -- outputs:
                    signal av_irq : OUT STD_LOGIC;
                    signal av_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal av_waitrequest : OUT STD_LOGIC;
                    signal dataavailable : OUT STD_LOGIC;
                    signal readyfordata : OUT STD_LOGIC
                 );
end component jtag_uart;

component leds_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_leds_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_leds_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_leds_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_leds_s1 : OUT STD_LOGIC;
                    signal d1_leds_s1_end_xfer : OUT STD_LOGIC;
                    signal leds_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal leds_s1_chipselect : OUT STD_LOGIC;
                    signal leds_s1_reset_n : OUT STD_LOGIC;
                    signal leds_s1_write_n : OUT STD_LOGIC;
                    signal leds_s1_writedata : OUT STD_LOGIC_VECTOR (2 DOWNTO 0)
                 );
end component leds_s1_arbitrator;

component leds is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (2 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (2 DOWNTO 0)
                 );
end component leds;

component onchip_memory_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_memory_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_onchip_memory_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_onchip_memory_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_onchip_memory_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_onchip_memory_s1 : OUT STD_LOGIC;
                    signal d1_onchip_memory_s1_end_xfer : OUT STD_LOGIC;
                    signal onchip_memory_s1_address : OUT STD_LOGIC_VECTOR (10 DOWNTO 0);
                    signal onchip_memory_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal onchip_memory_s1_chipselect : OUT STD_LOGIC;
                    signal onchip_memory_s1_clken : OUT STD_LOGIC;
                    signal onchip_memory_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal onchip_memory_s1_write : OUT STD_LOGIC;
                    signal onchip_memory_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_onchip_memory_s1 : OUT STD_LOGIC
                 );
end component onchip_memory_s1_arbitrator;

component onchip_memory is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (10 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component onchip_memory;

component pio_0_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_pio_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_0_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_pio_0_s1 : OUT STD_LOGIC;
                    signal d1_pio_0_s1_end_xfer : OUT STD_LOGIC;
                    signal pio_0_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal pio_0_s1_chipselect : OUT STD_LOGIC;
                    signal pio_0_s1_reset_n : OUT STD_LOGIC;
                    signal pio_0_s1_write_n : OUT STD_LOGIC;
                    signal pio_0_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_0_s1_arbitrator;

component pio_0 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_0;

component pio_1_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_pio_1_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_1_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_1_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_pio_1_s1 : OUT STD_LOGIC;
                    signal d1_pio_1_s1_end_xfer : OUT STD_LOGIC;
                    signal pio_1_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal pio_1_s1_chipselect : OUT STD_LOGIC;
                    signal pio_1_s1_reset_n : OUT STD_LOGIC;
                    signal pio_1_s1_write_n : OUT STD_LOGIC;
                    signal pio_1_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_1_s1_arbitrator;

component pio_1 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_1;

component pio_2_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_pio_2_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_2_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_2_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_pio_2_s1 : OUT STD_LOGIC;
                    signal d1_pio_2_s1_end_xfer : OUT STD_LOGIC;
                    signal pio_2_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal pio_2_s1_chipselect : OUT STD_LOGIC;
                    signal pio_2_s1_reset_n : OUT STD_LOGIC;
                    signal pio_2_s1_write_n : OUT STD_LOGIC;
                    signal pio_2_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_2_s1_arbitrator;

component pio_2 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_2;

component pio_3_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_pio_3_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_3_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_3_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_pio_3_s1 : OUT STD_LOGIC;
                    signal d1_pio_3_s1_end_xfer : OUT STD_LOGIC;
                    signal pio_3_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal pio_3_s1_chipselect : OUT STD_LOGIC;
                    signal pio_3_s1_reset_n : OUT STD_LOGIC;
                    signal pio_3_s1_write_n : OUT STD_LOGIC;
                    signal pio_3_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_3_s1_arbitrator;

component pio_3 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_3;

component pio_4_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_pio_4_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_4_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_4_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_pio_4_s1 : OUT STD_LOGIC;
                    signal d1_pio_4_s1_end_xfer : OUT STD_LOGIC;
                    signal pio_4_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal pio_4_s1_chipselect : OUT STD_LOGIC;
                    signal pio_4_s1_reset_n : OUT STD_LOGIC;
                    signal pio_4_s1_write_n : OUT STD_LOGIC;
                    signal pio_4_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_4_s1_arbitrator;

component pio_4 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component pio_4;

component pio_5_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_pio_5_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_pio_5_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_pio_5_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_pio_5_s1 : OUT STD_LOGIC;
                    signal d1_pio_5_s1_end_xfer : OUT STD_LOGIC;
                    signal pio_5_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal pio_5_s1_chipselect : OUT STD_LOGIC;
                    signal pio_5_s1_reset_n : OUT STD_LOGIC;
                    signal pio_5_s1_write_n : OUT STD_LOGIC;
                    signal pio_5_s1_writedata : OUT STD_LOGIC_VECTOR (6 DOWNTO 0)
                 );
end component pio_5_s1_arbitrator;

component pio_5 is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (6 DOWNTO 0);

                 -- outputs:
                    signal out_port : OUT STD_LOGIC_VECTOR (6 DOWNTO 0)
                 );
end component pio_5;

component sdram_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal sdram_s1_readdata : IN STD_LOGIC_VECTOR (63 DOWNTO 0);
                    signal sdram_s1_readdatavalid : IN STD_LOGIC;
                    signal sdram_s1_waitrequest : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sdram_s1_shift_register : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sdram_s1 : OUT STD_LOGIC;
                    signal d1_sdram_s1_end_xfer : OUT STD_LOGIC;
                    signal sdram_s1_address : OUT STD_LOGIC_VECTOR (24 DOWNTO 0);
                    signal sdram_s1_byteenable_n : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal sdram_s1_chipselect : OUT STD_LOGIC;
                    signal sdram_s1_read_n : OUT STD_LOGIC;
                    signal sdram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (63 DOWNTO 0);
                    signal sdram_s1_reset_n : OUT STD_LOGIC;
                    signal sdram_s1_waitrequest_from_sa : OUT STD_LOGIC;
                    signal sdram_s1_write_n : OUT STD_LOGIC;
                    signal sdram_s1_writedata : OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component sdram_s1_arbitrator;

component sdram is 
           port (
                 -- inputs:
                    signal az_addr : IN STD_LOGIC_VECTOR (24 DOWNTO 0);
                    signal az_be_n : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal az_cs : IN STD_LOGIC;
                    signal az_data : IN STD_LOGIC_VECTOR (63 DOWNTO 0);
                    signal az_rd_n : IN STD_LOGIC;
                    signal az_wr_n : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal za_data : OUT STD_LOGIC_VECTOR (63 DOWNTO 0);
                    signal za_valid : OUT STD_LOGIC;
                    signal za_waitrequest : OUT STD_LOGIC;
                    signal zs_addr : OUT STD_LOGIC_VECTOR (12 DOWNTO 0);
                    signal zs_ba : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n : OUT STD_LOGIC;
                    signal zs_cke : OUT STD_LOGIC;
                    signal zs_cs_n : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_dq : INOUT STD_LOGIC_VECTOR (63 DOWNTO 0);
                    signal zs_dqm : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal zs_ras_n : OUT STD_LOGIC;
                    signal zs_we_n : OUT STD_LOGIC
                 );
end component sdram;

component sysid_control_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sysid_control_slave_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sysid_control_slave : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sysid_control_slave : OUT STD_LOGIC;
                    signal d1_sysid_control_slave_end_xfer : OUT STD_LOGIC;
                    signal sysid_control_slave_address : OUT STD_LOGIC;
                    signal sysid_control_slave_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid_control_slave_arbitrator;

component sysid is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC;

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sysid;

component tightly_coupled_data_memory_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_tightly_coupled_data_master_0_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_tightly_coupled_data_master_0_clken : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_latency_counter : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_read : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_write : IN STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal tightly_coupled_data_memory_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 : OUT STD_LOGIC;
                    signal d1_tightly_coupled_data_memory_s1_end_xfer : OUT STD_LOGIC;
                    signal tightly_coupled_data_memory_s1_address : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal tightly_coupled_data_memory_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal tightly_coupled_data_memory_s1_chipselect : OUT STD_LOGIC;
                    signal tightly_coupled_data_memory_s1_clken : OUT STD_LOGIC;
                    signal tightly_coupled_data_memory_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tightly_coupled_data_memory_s1_write : OUT STD_LOGIC;
                    signal tightly_coupled_data_memory_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component tightly_coupled_data_memory_s1_arbitrator;

component tightly_coupled_data_memory is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component tightly_coupled_data_memory;

component tightly_coupled_instruction_memory_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_tightly_coupled_instruction_master_0_clken : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_latency_counter : IN STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                    signal cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 : OUT STD_LOGIC;
                    signal d1_tightly_coupled_instruction_memory_s1_end_xfer : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s1_address : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal tightly_coupled_instruction_memory_s1_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal tightly_coupled_instruction_memory_s1_chipselect : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s1_clken : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tightly_coupled_instruction_memory_s1_write : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component tightly_coupled_instruction_memory_s1_arbitrator;

component tightly_coupled_instruction_memory_s2_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s2_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                    signal d1_tightly_coupled_instruction_memory_s2_end_xfer : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s2_address : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal tightly_coupled_instruction_memory_s2_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal tightly_coupled_instruction_memory_s2_chipselect : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s2_clken : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s2_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tightly_coupled_instruction_memory_s2_write : OUT STD_LOGIC;
                    signal tightly_coupled_instruction_memory_s2_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component tightly_coupled_instruction_memory_s2_arbitrator;

component tightly_coupled_instruction_memory is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal address2 : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
                    signal byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal byteenable2 : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal chipselect2 : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal clk2 : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal clken2 : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;
                    signal write2 : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal writedata2 : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal readdata2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component tightly_coupled_instruction_memory;

component timer_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;
                    signal timer_s1_irq : IN STD_LOGIC;
                    signal timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_timer_s1 : OUT STD_LOGIC;
                    signal d1_timer_s1_end_xfer : OUT STD_LOGIC;
                    signal timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal timer_s1_chipselect : OUT STD_LOGIC;
                    signal timer_s1_irq_from_sa : OUT STD_LOGIC;
                    signal timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal timer_s1_reset_n : OUT STD_LOGIC;
                    signal timer_s1_write_n : OUT STD_LOGIC;
                    signal timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer_s1_arbitrator;

component timer is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer;

component tri_state_bridge_avalon_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address_to_slave : IN STD_LOGIC_VECTOR (28 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_dbs_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_data_master_dbs_write_8 : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal cpu_data_master_no_byte_enables_and_last_term : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_byteenable_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_granted_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_flash_s1 : OUT STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : OUT STD_LOGIC;
                    signal flash_s1_wait_counter_eq_0 : OUT STD_LOGIC;
                    signal flash_s1_wait_counter_eq_1 : OUT STD_LOGIC;
                    signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_flash_s1 : OUT STD_LOGIC;
                    signal select_n_to_the_flash : OUT STD_LOGIC;
                    signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal tri_state_bridge_readn : OUT STD_LOGIC;
                    signal write_n_to_the_flash : OUT STD_LOGIC
                 );
end component tri_state_bridge_avalon_slave_arbitrator;

component tri_state_bridge is 
end component tri_state_bridge;

component tri_state_bridge_bridge_arbitrator is 
end component tri_state_bridge_bridge_arbitrator;

component nios2_sys_reset_clk_domain_synch_module is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC
                 );
end component nios2_sys_reset_clk_domain_synch_module;

                signal DM9000A_avalon_slave_address :  STD_LOGIC;
                signal DM9000A_avalon_slave_chipselect_n :  STD_LOGIC;
                signal DM9000A_avalon_slave_irq :  STD_LOGIC;
                signal DM9000A_avalon_slave_irq_from_sa :  STD_LOGIC;
                signal DM9000A_avalon_slave_read_n :  STD_LOGIC;
                signal DM9000A_avalon_slave_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal DM9000A_avalon_slave_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal DM9000A_avalon_slave_reset_n :  STD_LOGIC;
                signal DM9000A_avalon_slave_wait_counter_eq_0 :  STD_LOGIC;
                signal DM9000A_avalon_slave_wait_counter_eq_1 :  STD_LOGIC;
                signal DM9000A_avalon_slave_write_n :  STD_LOGIC;
                signal DM9000A_avalon_slave_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal clk_reset_n :  STD_LOGIC;
                signal cpu_data_master_address :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_data_master_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_data_master_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_data_master_byteenable_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_dbs_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal cpu_data_master_dbs_write_8 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal cpu_data_master_debugaccess :  STD_LOGIC;
                signal cpu_data_master_granted_DM9000A_avalon_slave :  STD_LOGIC;
                signal cpu_data_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_granted_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_granted_leds_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_onchip_memory_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_pio_0_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_pio_1_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_pio_2_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_pio_3_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_pio_4_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_pio_5_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_granted_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_granted_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal cpu_data_master_granted_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_irq :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_no_byte_enables_and_last_term :  STD_LOGIC;
                signal cpu_data_master_qualified_request_DM9000A_avalon_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_qualified_request_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_leds_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_onchip_memory_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_pio_0_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_pio_1_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_pio_2_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_pio_3_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_pio_4_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_pio_5_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal cpu_data_master_qualified_request_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_read :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_DM9000A_avalon_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_leds_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_onchip_memory_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_pio_0_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_pio_1_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_pio_2_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_pio_3_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_pio_4_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_pio_5_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sdram_s1_shift_register :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal cpu_data_master_read_data_valid_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_data_master_requests_DM9000A_avalon_slave :  STD_LOGIC;
                signal cpu_data_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_data_master_requests_flash_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_jtag_uart_avalon_jtag_slave :  STD_LOGIC;
                signal cpu_data_master_requests_leds_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_onchip_memory_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_pio_0_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_pio_1_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_pio_2_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_pio_3_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_pio_4_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_pio_5_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_sdram_s1 :  STD_LOGIC;
                signal cpu_data_master_requests_sysid_control_slave :  STD_LOGIC;
                signal cpu_data_master_requests_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal cpu_data_master_requests_timer_s1 :  STD_LOGIC;
                signal cpu_data_master_waitrequest :  STD_LOGIC;
                signal cpu_data_master_write :  STD_LOGIC;
                signal cpu_data_master_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_address :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_instruction_master_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_instruction_master_granted_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_latency_counter :  STD_LOGIC;
                signal cpu_instruction_master_qualified_request_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_read :  STD_LOGIC;
                signal cpu_instruction_master_read_data_valid_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_instruction_master_readdatavalid :  STD_LOGIC;
                signal cpu_instruction_master_requests_cpu_jtag_debug_module :  STD_LOGIC;
                signal cpu_instruction_master_waitrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal cpu_jtag_debug_module_begintransfer :  STD_LOGIC;
                signal cpu_jtag_debug_module_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_jtag_debug_module_chipselect :  STD_LOGIC;
                signal cpu_jtag_debug_module_debugaccess :  STD_LOGIC;
                signal cpu_jtag_debug_module_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_jtag_debug_module_reset :  STD_LOGIC;
                signal cpu_jtag_debug_module_reset_n :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest :  STD_LOGIC;
                signal cpu_jtag_debug_module_resetrequest_from_sa :  STD_LOGIC;
                signal cpu_jtag_debug_module_write :  STD_LOGIC;
                signal cpu_jtag_debug_module_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_tightly_coupled_data_master_0_address :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_tightly_coupled_data_master_0_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_tightly_coupled_data_master_0_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal cpu_tightly_coupled_data_master_0_clken :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_latency_counter :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_read :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_tightly_coupled_data_master_0_readdatavalid :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_waitrequest :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_write :  STD_LOGIC;
                signal cpu_tightly_coupled_data_master_0_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_tightly_coupled_instruction_master_0_address :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_tightly_coupled_instruction_master_0_address_to_slave :  STD_LOGIC_VECTOR (28 DOWNTO 0);
                signal cpu_tightly_coupled_instruction_master_0_clken :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_latency_counter :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_read :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal cpu_tightly_coupled_instruction_master_0_readdatavalid :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 :  STD_LOGIC;
                signal cpu_tightly_coupled_instruction_master_0_waitrequest :  STD_LOGIC;
                signal d1_DM9000A_avalon_slave_end_xfer :  STD_LOGIC;
                signal d1_cpu_jtag_debug_module_end_xfer :  STD_LOGIC;
                signal d1_jtag_uart_avalon_jtag_slave_end_xfer :  STD_LOGIC;
                signal d1_leds_s1_end_xfer :  STD_LOGIC;
                signal d1_onchip_memory_s1_end_xfer :  STD_LOGIC;
                signal d1_pio_0_s1_end_xfer :  STD_LOGIC;
                signal d1_pio_1_s1_end_xfer :  STD_LOGIC;
                signal d1_pio_2_s1_end_xfer :  STD_LOGIC;
                signal d1_pio_3_s1_end_xfer :  STD_LOGIC;
                signal d1_pio_4_s1_end_xfer :  STD_LOGIC;
                signal d1_pio_5_s1_end_xfer :  STD_LOGIC;
                signal d1_sdram_s1_end_xfer :  STD_LOGIC;
                signal d1_sysid_control_slave_end_xfer :  STD_LOGIC;
                signal d1_tightly_coupled_data_memory_s1_end_xfer :  STD_LOGIC;
                signal d1_tightly_coupled_instruction_memory_s1_end_xfer :  STD_LOGIC;
                signal d1_tightly_coupled_instruction_memory_s2_end_xfer :  STD_LOGIC;
                signal d1_timer_s1_end_xfer :  STD_LOGIC;
                signal d1_tri_state_bridge_avalon_slave_end_xfer :  STD_LOGIC;
                signal flash_s1_wait_counter_eq_0 :  STD_LOGIC;
                signal flash_s1_wait_counter_eq_1 :  STD_LOGIC;
                signal incoming_tri_state_bridge_data_with_Xs_converted_to_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_CMD_from_the_DM9000A :  STD_LOGIC;
                signal internal_CS_n_from_the_DM9000A :  STD_LOGIC;
                signal internal_IORD_n_from_the_DM9000A :  STD_LOGIC;
                signal internal_RST_n_from_the_DM9000A :  STD_LOGIC;
                signal internal_out_port_from_the_leds :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal internal_out_port_from_the_pio_0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_out_port_from_the_pio_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_out_port_from_the_pio_2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_out_port_from_the_pio_3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_out_port_from_the_pio_4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_out_port_from_the_pio_5 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_select_n_to_the_flash :  STD_LOGIC;
                signal internal_tri_state_bridge_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal internal_tri_state_bridge_readn :  STD_LOGIC;
                signal internal_write_n_to_the_flash :  STD_LOGIC;
                signal internal_zs_addr_from_the_sdram :  STD_LOGIC_VECTOR (12 DOWNTO 0);
                signal internal_zs_ba_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_zs_cas_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_cke_from_the_sdram :  STD_LOGIC;
                signal internal_zs_cs_n_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_zs_dqm_from_the_sdram :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_zs_ras_n_from_the_sdram :  STD_LOGIC;
                signal internal_zs_we_n_from_the_sdram :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_address :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_chipselect :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_dataavailable :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_irq :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_irq_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_read_n :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_readyfordata :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_reset_n :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waitrequest :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_waitrequest_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_write_n :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal leds_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal leds_s1_chipselect :  STD_LOGIC;
                signal leds_s1_reset_n :  STD_LOGIC;
                signal leds_s1_write_n :  STD_LOGIC;
                signal leds_s1_writedata :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal module_input3 :  STD_LOGIC;
                signal onchip_memory_s1_address :  STD_LOGIC_VECTOR (10 DOWNTO 0);
                signal onchip_memory_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal onchip_memory_s1_chipselect :  STD_LOGIC;
                signal onchip_memory_s1_clken :  STD_LOGIC;
                signal onchip_memory_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_memory_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal onchip_memory_s1_write :  STD_LOGIC;
                signal onchip_memory_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pio_0_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal pio_0_s1_chipselect :  STD_LOGIC;
                signal pio_0_s1_reset_n :  STD_LOGIC;
                signal pio_0_s1_write_n :  STD_LOGIC;
                signal pio_0_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pio_1_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal pio_1_s1_chipselect :  STD_LOGIC;
                signal pio_1_s1_reset_n :  STD_LOGIC;
                signal pio_1_s1_write_n :  STD_LOGIC;
                signal pio_1_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pio_2_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal pio_2_s1_chipselect :  STD_LOGIC;
                signal pio_2_s1_reset_n :  STD_LOGIC;
                signal pio_2_s1_write_n :  STD_LOGIC;
                signal pio_2_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pio_3_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal pio_3_s1_chipselect :  STD_LOGIC;
                signal pio_3_s1_reset_n :  STD_LOGIC;
                signal pio_3_s1_write_n :  STD_LOGIC;
                signal pio_3_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pio_4_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal pio_4_s1_chipselect :  STD_LOGIC;
                signal pio_4_s1_reset_n :  STD_LOGIC;
                signal pio_4_s1_write_n :  STD_LOGIC;
                signal pio_4_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal pio_5_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal pio_5_s1_chipselect :  STD_LOGIC;
                signal pio_5_s1_reset_n :  STD_LOGIC;
                signal pio_5_s1_write_n :  STD_LOGIC;
                signal pio_5_s1_writedata :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal registered_cpu_data_master_read_data_valid_flash_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_onchip_memory_s1 :  STD_LOGIC;
                signal registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 :  STD_LOGIC;
                signal reset_n_sources :  STD_LOGIC;
                signal sdram_s1_address :  STD_LOGIC_VECTOR (24 DOWNTO 0);
                signal sdram_s1_byteenable_n :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal sdram_s1_chipselect :  STD_LOGIC;
                signal sdram_s1_read_n :  STD_LOGIC;
                signal sdram_s1_readdata :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal sdram_s1_readdata_from_sa :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal sdram_s1_readdatavalid :  STD_LOGIC;
                signal sdram_s1_reset_n :  STD_LOGIC;
                signal sdram_s1_waitrequest :  STD_LOGIC;
                signal sdram_s1_waitrequest_from_sa :  STD_LOGIC;
                signal sdram_s1_write_n :  STD_LOGIC;
                signal sdram_s1_writedata :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal sysid_control_slave_address :  STD_LOGIC;
                signal sysid_control_slave_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal sysid_control_slave_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_data_memory_s1_address :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal tightly_coupled_data_memory_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tightly_coupled_data_memory_s1_chipselect :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_clken :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_data_memory_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_data_memory_s1_write :  STD_LOGIC;
                signal tightly_coupled_data_memory_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s1_address :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s1_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s1_chipselect :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_clken :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s1_write :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_address :  STD_LOGIC_VECTOR (11 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_chipselect :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_clken :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal tightly_coupled_instruction_memory_s2_write :  STD_LOGIC;
                signal tightly_coupled_instruction_memory_s2_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal timer_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal timer_s1_chipselect :  STD_LOGIC;
                signal timer_s1_irq :  STD_LOGIC;
                signal timer_s1_irq_from_sa :  STD_LOGIC;
                signal timer_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal timer_s1_reset_n :  STD_LOGIC;
                signal timer_s1_write_n :  STD_LOGIC;
                signal timer_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  --the_DM9000A_avalon_slave, which is an e_instance
  the_DM9000A_avalon_slave : DM9000A_avalon_slave_arbitrator
    port map(
      DM9000A_avalon_slave_address => DM9000A_avalon_slave_address,
      DM9000A_avalon_slave_chipselect_n => DM9000A_avalon_slave_chipselect_n,
      DM9000A_avalon_slave_irq_from_sa => DM9000A_avalon_slave_irq_from_sa,
      DM9000A_avalon_slave_read_n => DM9000A_avalon_slave_read_n,
      DM9000A_avalon_slave_readdata_from_sa => DM9000A_avalon_slave_readdata_from_sa,
      DM9000A_avalon_slave_reset_n => DM9000A_avalon_slave_reset_n,
      DM9000A_avalon_slave_wait_counter_eq_0 => DM9000A_avalon_slave_wait_counter_eq_0,
      DM9000A_avalon_slave_wait_counter_eq_1 => DM9000A_avalon_slave_wait_counter_eq_1,
      DM9000A_avalon_slave_write_n => DM9000A_avalon_slave_write_n,
      DM9000A_avalon_slave_writedata => DM9000A_avalon_slave_writedata,
      cpu_data_master_granted_DM9000A_avalon_slave => cpu_data_master_granted_DM9000A_avalon_slave,
      cpu_data_master_qualified_request_DM9000A_avalon_slave => cpu_data_master_qualified_request_DM9000A_avalon_slave,
      cpu_data_master_read_data_valid_DM9000A_avalon_slave => cpu_data_master_read_data_valid_DM9000A_avalon_slave,
      cpu_data_master_requests_DM9000A_avalon_slave => cpu_data_master_requests_DM9000A_avalon_slave,
      d1_DM9000A_avalon_slave_end_xfer => d1_DM9000A_avalon_slave_end_xfer,
      DM9000A_avalon_slave_irq => DM9000A_avalon_slave_irq,
      DM9000A_avalon_slave_readdata => DM9000A_avalon_slave_readdata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_DM9000A, which is an e_ptf_instance
  the_DM9000A : DM9000A
    port map(
      CMD => internal_CMD_from_the_DM9000A,
      CS_n => internal_CS_n_from_the_DM9000A,
      IORD_n => internal_IORD_n_from_the_DM9000A,
      IOWR_n => IOWR_n_to_and_from_the_DM9000A,
      RST_n => internal_RST_n_from_the_DM9000A,
      data => data_to_and_from_the_DM9000A,
      oDATA => DM9000A_avalon_slave_readdata,
      oINT => DM9000A_avalon_slave_irq,
      CLK => clk,
      INT => INT_to_the_DM9000A,
      iCMD => DM9000A_avalon_slave_address,
      iCS_n => DM9000A_avalon_slave_chipselect_n,
      iDATA => DM9000A_avalon_slave_writedata,
      iIORD_n => DM9000A_avalon_slave_read_n,
      iIOWR_n => DM9000A_avalon_slave_write_n,
      iRST_n => DM9000A_avalon_slave_reset_n
    );


  --the_cpu_jtag_debug_module, which is an e_instance
  the_cpu_jtag_debug_module : cpu_jtag_debug_module_arbitrator
    port map(
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_jtag_debug_module_address => cpu_jtag_debug_module_address,
      cpu_jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      cpu_jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      cpu_jtag_debug_module_chipselect => cpu_jtag_debug_module_chipselect,
      cpu_jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      cpu_jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      cpu_jtag_debug_module_reset_n => cpu_jtag_debug_module_reset_n,
      cpu_jtag_debug_module_resetrequest_from_sa => cpu_jtag_debug_module_resetrequest_from_sa,
      cpu_jtag_debug_module_write => cpu_jtag_debug_module_write,
      cpu_jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      cpu_jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      reset_n => clk_reset_n
    );


  --the_cpu_data_master, which is an e_instance
  the_cpu_data_master : cpu_data_master_arbitrator
    port map(
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_irq => cpu_data_master_irq,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_readdata => cpu_data_master_readdata,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      DM9000A_avalon_slave_irq_from_sa => DM9000A_avalon_slave_irq_from_sa,
      DM9000A_avalon_slave_readdata_from_sa => DM9000A_avalon_slave_readdata_from_sa,
      DM9000A_avalon_slave_wait_counter_eq_0 => DM9000A_avalon_slave_wait_counter_eq_0,
      DM9000A_avalon_slave_wait_counter_eq_1 => DM9000A_avalon_slave_wait_counter_eq_1,
      clk => clk,
      cpu_data_master_address => cpu_data_master_address,
      cpu_data_master_byteenable_flash_s1 => cpu_data_master_byteenable_flash_s1,
      cpu_data_master_debugaccess => cpu_data_master_debugaccess,
      cpu_data_master_granted_DM9000A_avalon_slave => cpu_data_master_granted_DM9000A_avalon_slave,
      cpu_data_master_granted_cpu_jtag_debug_module => cpu_data_master_granted_cpu_jtag_debug_module,
      cpu_data_master_granted_flash_s1 => cpu_data_master_granted_flash_s1,
      cpu_data_master_granted_jtag_uart_avalon_jtag_slave => cpu_data_master_granted_jtag_uart_avalon_jtag_slave,
      cpu_data_master_granted_leds_s1 => cpu_data_master_granted_leds_s1,
      cpu_data_master_granted_onchip_memory_s1 => cpu_data_master_granted_onchip_memory_s1,
      cpu_data_master_granted_pio_0_s1 => cpu_data_master_granted_pio_0_s1,
      cpu_data_master_granted_pio_1_s1 => cpu_data_master_granted_pio_1_s1,
      cpu_data_master_granted_pio_2_s1 => cpu_data_master_granted_pio_2_s1,
      cpu_data_master_granted_pio_3_s1 => cpu_data_master_granted_pio_3_s1,
      cpu_data_master_granted_pio_4_s1 => cpu_data_master_granted_pio_4_s1,
      cpu_data_master_granted_pio_5_s1 => cpu_data_master_granted_pio_5_s1,
      cpu_data_master_granted_sdram_s1 => cpu_data_master_granted_sdram_s1,
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_granted_tightly_coupled_instruction_memory_s2 => cpu_data_master_granted_tightly_coupled_instruction_memory_s2,
      cpu_data_master_granted_timer_s1 => cpu_data_master_granted_timer_s1,
      cpu_data_master_qualified_request_DM9000A_avalon_slave => cpu_data_master_qualified_request_DM9000A_avalon_slave,
      cpu_data_master_qualified_request_cpu_jtag_debug_module => cpu_data_master_qualified_request_cpu_jtag_debug_module,
      cpu_data_master_qualified_request_flash_s1 => cpu_data_master_qualified_request_flash_s1,
      cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
      cpu_data_master_qualified_request_leds_s1 => cpu_data_master_qualified_request_leds_s1,
      cpu_data_master_qualified_request_onchip_memory_s1 => cpu_data_master_qualified_request_onchip_memory_s1,
      cpu_data_master_qualified_request_pio_0_s1 => cpu_data_master_qualified_request_pio_0_s1,
      cpu_data_master_qualified_request_pio_1_s1 => cpu_data_master_qualified_request_pio_1_s1,
      cpu_data_master_qualified_request_pio_2_s1 => cpu_data_master_qualified_request_pio_2_s1,
      cpu_data_master_qualified_request_pio_3_s1 => cpu_data_master_qualified_request_pio_3_s1,
      cpu_data_master_qualified_request_pio_4_s1 => cpu_data_master_qualified_request_pio_4_s1,
      cpu_data_master_qualified_request_pio_5_s1 => cpu_data_master_qualified_request_pio_5_s1,
      cpu_data_master_qualified_request_sdram_s1 => cpu_data_master_qualified_request_sdram_s1,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 => cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2,
      cpu_data_master_qualified_request_timer_s1 => cpu_data_master_qualified_request_timer_s1,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_read_data_valid_DM9000A_avalon_slave => cpu_data_master_read_data_valid_DM9000A_avalon_slave,
      cpu_data_master_read_data_valid_cpu_jtag_debug_module => cpu_data_master_read_data_valid_cpu_jtag_debug_module,
      cpu_data_master_read_data_valid_flash_s1 => cpu_data_master_read_data_valid_flash_s1,
      cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
      cpu_data_master_read_data_valid_leds_s1 => cpu_data_master_read_data_valid_leds_s1,
      cpu_data_master_read_data_valid_onchip_memory_s1 => cpu_data_master_read_data_valid_onchip_memory_s1,
      cpu_data_master_read_data_valid_pio_0_s1 => cpu_data_master_read_data_valid_pio_0_s1,
      cpu_data_master_read_data_valid_pio_1_s1 => cpu_data_master_read_data_valid_pio_1_s1,
      cpu_data_master_read_data_valid_pio_2_s1 => cpu_data_master_read_data_valid_pio_2_s1,
      cpu_data_master_read_data_valid_pio_3_s1 => cpu_data_master_read_data_valid_pio_3_s1,
      cpu_data_master_read_data_valid_pio_4_s1 => cpu_data_master_read_data_valid_pio_4_s1,
      cpu_data_master_read_data_valid_pio_5_s1 => cpu_data_master_read_data_valid_pio_5_s1,
      cpu_data_master_read_data_valid_sdram_s1 => cpu_data_master_read_data_valid_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1_shift_register => cpu_data_master_read_data_valid_sdram_s1_shift_register,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 => cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2,
      cpu_data_master_read_data_valid_timer_s1 => cpu_data_master_read_data_valid_timer_s1,
      cpu_data_master_requests_DM9000A_avalon_slave => cpu_data_master_requests_DM9000A_avalon_slave,
      cpu_data_master_requests_cpu_jtag_debug_module => cpu_data_master_requests_cpu_jtag_debug_module,
      cpu_data_master_requests_flash_s1 => cpu_data_master_requests_flash_s1,
      cpu_data_master_requests_jtag_uart_avalon_jtag_slave => cpu_data_master_requests_jtag_uart_avalon_jtag_slave,
      cpu_data_master_requests_leds_s1 => cpu_data_master_requests_leds_s1,
      cpu_data_master_requests_onchip_memory_s1 => cpu_data_master_requests_onchip_memory_s1,
      cpu_data_master_requests_pio_0_s1 => cpu_data_master_requests_pio_0_s1,
      cpu_data_master_requests_pio_1_s1 => cpu_data_master_requests_pio_1_s1,
      cpu_data_master_requests_pio_2_s1 => cpu_data_master_requests_pio_2_s1,
      cpu_data_master_requests_pio_3_s1 => cpu_data_master_requests_pio_3_s1,
      cpu_data_master_requests_pio_4_s1 => cpu_data_master_requests_pio_4_s1,
      cpu_data_master_requests_pio_5_s1 => cpu_data_master_requests_pio_5_s1,
      cpu_data_master_requests_sdram_s1 => cpu_data_master_requests_sdram_s1,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      cpu_data_master_requests_tightly_coupled_instruction_memory_s2 => cpu_data_master_requests_tightly_coupled_instruction_memory_s2,
      cpu_data_master_requests_timer_s1 => cpu_data_master_requests_timer_s1,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_DM9000A_avalon_slave_end_xfer => d1_DM9000A_avalon_slave_end_xfer,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      d1_jtag_uart_avalon_jtag_slave_end_xfer => d1_jtag_uart_avalon_jtag_slave_end_xfer,
      d1_leds_s1_end_xfer => d1_leds_s1_end_xfer,
      d1_onchip_memory_s1_end_xfer => d1_onchip_memory_s1_end_xfer,
      d1_pio_0_s1_end_xfer => d1_pio_0_s1_end_xfer,
      d1_pio_1_s1_end_xfer => d1_pio_1_s1_end_xfer,
      d1_pio_2_s1_end_xfer => d1_pio_2_s1_end_xfer,
      d1_pio_3_s1_end_xfer => d1_pio_3_s1_end_xfer,
      d1_pio_4_s1_end_xfer => d1_pio_4_s1_end_xfer,
      d1_pio_5_s1_end_xfer => d1_pio_5_s1_end_xfer,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      d1_tightly_coupled_instruction_memory_s2_end_xfer => d1_tightly_coupled_instruction_memory_s2_end_xfer,
      d1_timer_s1_end_xfer => d1_timer_s1_end_xfer,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      flash_s1_wait_counter_eq_0 => flash_s1_wait_counter_eq_0,
      flash_s1_wait_counter_eq_1 => flash_s1_wait_counter_eq_1,
      incoming_tri_state_bridge_data_with_Xs_converted_to_0 => incoming_tri_state_bridge_data_with_Xs_converted_to_0,
      jtag_uart_avalon_jtag_slave_irq_from_sa => jtag_uart_avalon_jtag_slave_irq_from_sa,
      jtag_uart_avalon_jtag_slave_readdata_from_sa => jtag_uart_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
      onchip_memory_s1_readdata_from_sa => onchip_memory_s1_readdata_from_sa,
      registered_cpu_data_master_read_data_valid_flash_s1 => registered_cpu_data_master_read_data_valid_flash_s1,
      registered_cpu_data_master_read_data_valid_onchip_memory_s1 => registered_cpu_data_master_read_data_valid_onchip_memory_s1,
      registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 => registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2,
      reset_n => clk_reset_n,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa,
      sdram_s1_waitrequest_from_sa => sdram_s1_waitrequest_from_sa,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      tightly_coupled_instruction_memory_s2_readdata_from_sa => tightly_coupled_instruction_memory_s2_readdata_from_sa,
      timer_s1_irq_from_sa => timer_s1_irq_from_sa,
      timer_s1_readdata_from_sa => timer_s1_readdata_from_sa
    );


  --the_cpu_instruction_master, which is an e_instance
  the_cpu_instruction_master : cpu_instruction_master_arbitrator
    port map(
      cpu_instruction_master_address_to_slave => cpu_instruction_master_address_to_slave,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_readdata => cpu_instruction_master_readdata,
      cpu_instruction_master_readdatavalid => cpu_instruction_master_readdatavalid,
      cpu_instruction_master_waitrequest => cpu_instruction_master_waitrequest,
      clk => clk,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_instruction_master_granted_cpu_jtag_debug_module => cpu_instruction_master_granted_cpu_jtag_debug_module,
      cpu_instruction_master_qualified_request_cpu_jtag_debug_module => cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_read_data_valid_cpu_jtag_debug_module => cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
      cpu_instruction_master_requests_cpu_jtag_debug_module => cpu_instruction_master_requests_cpu_jtag_debug_module,
      cpu_jtag_debug_module_readdata_from_sa => cpu_jtag_debug_module_readdata_from_sa,
      d1_cpu_jtag_debug_module_end_xfer => d1_cpu_jtag_debug_module_end_xfer,
      reset_n => clk_reset_n
    );


  --the_cpu_tightly_coupled_data_master_0, which is an e_instance
  the_cpu_tightly_coupled_data_master_0 : cpu_tightly_coupled_data_master_0_arbitrator
    port map(
      cpu_tightly_coupled_data_master_0_address_to_slave => cpu_tightly_coupled_data_master_0_address_to_slave,
      cpu_tightly_coupled_data_master_0_latency_counter => cpu_tightly_coupled_data_master_0_latency_counter,
      cpu_tightly_coupled_data_master_0_readdata => cpu_tightly_coupled_data_master_0_readdata,
      cpu_tightly_coupled_data_master_0_readdatavalid => cpu_tightly_coupled_data_master_0_readdatavalid,
      cpu_tightly_coupled_data_master_0_waitrequest => cpu_tightly_coupled_data_master_0_waitrequest,
      clk => clk,
      cpu_tightly_coupled_data_master_0_address => cpu_tightly_coupled_data_master_0_address,
      cpu_tightly_coupled_data_master_0_clken => cpu_tightly_coupled_data_master_0_clken,
      cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1,
      cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1,
      cpu_tightly_coupled_data_master_0_read => cpu_tightly_coupled_data_master_0_read,
      cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1,
      cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1,
      cpu_tightly_coupled_data_master_0_write => cpu_tightly_coupled_data_master_0_write,
      cpu_tightly_coupled_data_master_0_writedata => cpu_tightly_coupled_data_master_0_writedata,
      d1_tightly_coupled_data_memory_s1_end_xfer => d1_tightly_coupled_data_memory_s1_end_xfer,
      reset_n => clk_reset_n,
      tightly_coupled_data_memory_s1_readdata_from_sa => tightly_coupled_data_memory_s1_readdata_from_sa
    );


  --the_cpu_tightly_coupled_instruction_master_0, which is an e_instance
  the_cpu_tightly_coupled_instruction_master_0 : cpu_tightly_coupled_instruction_master_0_arbitrator
    port map(
      cpu_tightly_coupled_instruction_master_0_address_to_slave => cpu_tightly_coupled_instruction_master_0_address_to_slave,
      cpu_tightly_coupled_instruction_master_0_latency_counter => cpu_tightly_coupled_instruction_master_0_latency_counter,
      cpu_tightly_coupled_instruction_master_0_readdata => cpu_tightly_coupled_instruction_master_0_readdata,
      cpu_tightly_coupled_instruction_master_0_readdatavalid => cpu_tightly_coupled_instruction_master_0_readdatavalid,
      cpu_tightly_coupled_instruction_master_0_waitrequest => cpu_tightly_coupled_instruction_master_0_waitrequest,
      clk => clk,
      cpu_tightly_coupled_instruction_master_0_address => cpu_tightly_coupled_instruction_master_0_address,
      cpu_tightly_coupled_instruction_master_0_clken => cpu_tightly_coupled_instruction_master_0_clken,
      cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1,
      cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1,
      cpu_tightly_coupled_instruction_master_0_read => cpu_tightly_coupled_instruction_master_0_read,
      cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1,
      cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1,
      d1_tightly_coupled_instruction_memory_s1_end_xfer => d1_tightly_coupled_instruction_memory_s1_end_xfer,
      reset_n => clk_reset_n,
      tightly_coupled_instruction_memory_s1_readdata_from_sa => tightly_coupled_instruction_memory_s1_readdata_from_sa
    );


  --the_cpu, which is an e_ptf_instance
  the_cpu : cpu
    port map(
      d_address => cpu_data_master_address,
      d_byteenable => cpu_data_master_byteenable,
      d_read => cpu_data_master_read,
      d_write => cpu_data_master_write,
      d_writedata => cpu_data_master_writedata,
      dcm0_address => cpu_tightly_coupled_data_master_0_address,
      dcm0_byteenable => cpu_tightly_coupled_data_master_0_byteenable,
      dcm0_clken => cpu_tightly_coupled_data_master_0_clken,
      dcm0_read => cpu_tightly_coupled_data_master_0_read,
      dcm0_write => cpu_tightly_coupled_data_master_0_write,
      dcm0_writedata => cpu_tightly_coupled_data_master_0_writedata,
      i_address => cpu_instruction_master_address,
      i_read => cpu_instruction_master_read,
      icm0_address => cpu_tightly_coupled_instruction_master_0_address,
      icm0_clken => cpu_tightly_coupled_instruction_master_0_clken,
      icm0_read => cpu_tightly_coupled_instruction_master_0_read,
      jtag_debug_module_debugaccess_to_roms => cpu_data_master_debugaccess,
      jtag_debug_module_readdata => cpu_jtag_debug_module_readdata,
      jtag_debug_module_resetrequest => cpu_jtag_debug_module_resetrequest,
      clk => clk,
      d_irq => cpu_data_master_irq,
      d_readdata => cpu_data_master_readdata,
      d_waitrequest => cpu_data_master_waitrequest,
      dcm0_readdata => cpu_tightly_coupled_data_master_0_readdata,
      dcm0_readdatavalid => cpu_tightly_coupled_data_master_0_readdatavalid,
      dcm0_waitrequest => cpu_tightly_coupled_data_master_0_waitrequest,
      i_readdata => cpu_instruction_master_readdata,
      i_readdatavalid => cpu_instruction_master_readdatavalid,
      i_waitrequest => cpu_instruction_master_waitrequest,
      icm0_readdata => cpu_tightly_coupled_instruction_master_0_readdata,
      icm0_readdatavalid => cpu_tightly_coupled_instruction_master_0_readdatavalid,
      icm0_waitrequest => cpu_tightly_coupled_instruction_master_0_waitrequest,
      jtag_debug_module_address => cpu_jtag_debug_module_address,
      jtag_debug_module_begintransfer => cpu_jtag_debug_module_begintransfer,
      jtag_debug_module_byteenable => cpu_jtag_debug_module_byteenable,
      jtag_debug_module_clk => clk,
      jtag_debug_module_debugaccess => cpu_jtag_debug_module_debugaccess,
      jtag_debug_module_reset => cpu_jtag_debug_module_reset,
      jtag_debug_module_select => cpu_jtag_debug_module_chipselect,
      jtag_debug_module_write => cpu_jtag_debug_module_write,
      jtag_debug_module_writedata => cpu_jtag_debug_module_writedata,
      reset_n => cpu_jtag_debug_module_reset_n
    );


  --the_jtag_uart_avalon_jtag_slave, which is an e_instance
  the_jtag_uart_avalon_jtag_slave : jtag_uart_avalon_jtag_slave_arbitrator
    port map(
      cpu_data_master_granted_jtag_uart_avalon_jtag_slave => cpu_data_master_granted_jtag_uart_avalon_jtag_slave,
      cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave => cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
      cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave => cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
      cpu_data_master_requests_jtag_uart_avalon_jtag_slave => cpu_data_master_requests_jtag_uart_avalon_jtag_slave,
      d1_jtag_uart_avalon_jtag_slave_end_xfer => d1_jtag_uart_avalon_jtag_slave_end_xfer,
      jtag_uart_avalon_jtag_slave_address => jtag_uart_avalon_jtag_slave_address,
      jtag_uart_avalon_jtag_slave_chipselect => jtag_uart_avalon_jtag_slave_chipselect,
      jtag_uart_avalon_jtag_slave_dataavailable_from_sa => jtag_uart_avalon_jtag_slave_dataavailable_from_sa,
      jtag_uart_avalon_jtag_slave_irq_from_sa => jtag_uart_avalon_jtag_slave_irq_from_sa,
      jtag_uart_avalon_jtag_slave_read_n => jtag_uart_avalon_jtag_slave_read_n,
      jtag_uart_avalon_jtag_slave_readdata_from_sa => jtag_uart_avalon_jtag_slave_readdata_from_sa,
      jtag_uart_avalon_jtag_slave_readyfordata_from_sa => jtag_uart_avalon_jtag_slave_readyfordata_from_sa,
      jtag_uart_avalon_jtag_slave_reset_n => jtag_uart_avalon_jtag_slave_reset_n,
      jtag_uart_avalon_jtag_slave_waitrequest_from_sa => jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
      jtag_uart_avalon_jtag_slave_write_n => jtag_uart_avalon_jtag_slave_write_n,
      jtag_uart_avalon_jtag_slave_writedata => jtag_uart_avalon_jtag_slave_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      jtag_uart_avalon_jtag_slave_dataavailable => jtag_uart_avalon_jtag_slave_dataavailable,
      jtag_uart_avalon_jtag_slave_irq => jtag_uart_avalon_jtag_slave_irq,
      jtag_uart_avalon_jtag_slave_readdata => jtag_uart_avalon_jtag_slave_readdata,
      jtag_uart_avalon_jtag_slave_readyfordata => jtag_uart_avalon_jtag_slave_readyfordata,
      jtag_uart_avalon_jtag_slave_waitrequest => jtag_uart_avalon_jtag_slave_waitrequest,
      reset_n => clk_reset_n
    );


  --the_jtag_uart, which is an e_ptf_instance
  the_jtag_uart : jtag_uart
    port map(
      av_irq => jtag_uart_avalon_jtag_slave_irq,
      av_readdata => jtag_uart_avalon_jtag_slave_readdata,
      av_waitrequest => jtag_uart_avalon_jtag_slave_waitrequest,
      dataavailable => jtag_uart_avalon_jtag_slave_dataavailable,
      readyfordata => jtag_uart_avalon_jtag_slave_readyfordata,
      av_address => jtag_uart_avalon_jtag_slave_address,
      av_chipselect => jtag_uart_avalon_jtag_slave_chipselect,
      av_read_n => jtag_uart_avalon_jtag_slave_read_n,
      av_write_n => jtag_uart_avalon_jtag_slave_write_n,
      av_writedata => jtag_uart_avalon_jtag_slave_writedata,
      clk => clk,
      rst_n => jtag_uart_avalon_jtag_slave_reset_n
    );


  --the_leds_s1, which is an e_instance
  the_leds_s1 : leds_s1_arbitrator
    port map(
      cpu_data_master_granted_leds_s1 => cpu_data_master_granted_leds_s1,
      cpu_data_master_qualified_request_leds_s1 => cpu_data_master_qualified_request_leds_s1,
      cpu_data_master_read_data_valid_leds_s1 => cpu_data_master_read_data_valid_leds_s1,
      cpu_data_master_requests_leds_s1 => cpu_data_master_requests_leds_s1,
      d1_leds_s1_end_xfer => d1_leds_s1_end_xfer,
      leds_s1_address => leds_s1_address,
      leds_s1_chipselect => leds_s1_chipselect,
      leds_s1_reset_n => leds_s1_reset_n,
      leds_s1_write_n => leds_s1_write_n,
      leds_s1_writedata => leds_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_leds, which is an e_ptf_instance
  the_leds : leds
    port map(
      out_port => internal_out_port_from_the_leds,
      address => leds_s1_address,
      chipselect => leds_s1_chipselect,
      clk => clk,
      reset_n => leds_s1_reset_n,
      write_n => leds_s1_write_n,
      writedata => leds_s1_writedata
    );


  --the_onchip_memory_s1, which is an e_instance
  the_onchip_memory_s1 : onchip_memory_s1_arbitrator
    port map(
      cpu_data_master_granted_onchip_memory_s1 => cpu_data_master_granted_onchip_memory_s1,
      cpu_data_master_qualified_request_onchip_memory_s1 => cpu_data_master_qualified_request_onchip_memory_s1,
      cpu_data_master_read_data_valid_onchip_memory_s1 => cpu_data_master_read_data_valid_onchip_memory_s1,
      cpu_data_master_requests_onchip_memory_s1 => cpu_data_master_requests_onchip_memory_s1,
      d1_onchip_memory_s1_end_xfer => d1_onchip_memory_s1_end_xfer,
      onchip_memory_s1_address => onchip_memory_s1_address,
      onchip_memory_s1_byteenable => onchip_memory_s1_byteenable,
      onchip_memory_s1_chipselect => onchip_memory_s1_chipselect,
      onchip_memory_s1_clken => onchip_memory_s1_clken,
      onchip_memory_s1_readdata_from_sa => onchip_memory_s1_readdata_from_sa,
      onchip_memory_s1_write => onchip_memory_s1_write,
      onchip_memory_s1_writedata => onchip_memory_s1_writedata,
      registered_cpu_data_master_read_data_valid_onchip_memory_s1 => registered_cpu_data_master_read_data_valid_onchip_memory_s1,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      onchip_memory_s1_readdata => onchip_memory_s1_readdata,
      reset_n => clk_reset_n
    );


  --the_onchip_memory, which is an e_ptf_instance
  the_onchip_memory : onchip_memory
    port map(
      readdata => onchip_memory_s1_readdata,
      address => onchip_memory_s1_address,
      byteenable => onchip_memory_s1_byteenable,
      chipselect => onchip_memory_s1_chipselect,
      clk => clk,
      clken => onchip_memory_s1_clken,
      write => onchip_memory_s1_write,
      writedata => onchip_memory_s1_writedata
    );


  --the_pio_0_s1, which is an e_instance
  the_pio_0_s1 : pio_0_s1_arbitrator
    port map(
      cpu_data_master_granted_pio_0_s1 => cpu_data_master_granted_pio_0_s1,
      cpu_data_master_qualified_request_pio_0_s1 => cpu_data_master_qualified_request_pio_0_s1,
      cpu_data_master_read_data_valid_pio_0_s1 => cpu_data_master_read_data_valid_pio_0_s1,
      cpu_data_master_requests_pio_0_s1 => cpu_data_master_requests_pio_0_s1,
      d1_pio_0_s1_end_xfer => d1_pio_0_s1_end_xfer,
      pio_0_s1_address => pio_0_s1_address,
      pio_0_s1_chipselect => pio_0_s1_chipselect,
      pio_0_s1_reset_n => pio_0_s1_reset_n,
      pio_0_s1_write_n => pio_0_s1_write_n,
      pio_0_s1_writedata => pio_0_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_pio_0, which is an e_ptf_instance
  the_pio_0 : pio_0
    port map(
      out_port => internal_out_port_from_the_pio_0,
      address => pio_0_s1_address,
      chipselect => pio_0_s1_chipselect,
      clk => clk,
      reset_n => pio_0_s1_reset_n,
      write_n => pio_0_s1_write_n,
      writedata => pio_0_s1_writedata
    );


  --the_pio_1_s1, which is an e_instance
  the_pio_1_s1 : pio_1_s1_arbitrator
    port map(
      cpu_data_master_granted_pio_1_s1 => cpu_data_master_granted_pio_1_s1,
      cpu_data_master_qualified_request_pio_1_s1 => cpu_data_master_qualified_request_pio_1_s1,
      cpu_data_master_read_data_valid_pio_1_s1 => cpu_data_master_read_data_valid_pio_1_s1,
      cpu_data_master_requests_pio_1_s1 => cpu_data_master_requests_pio_1_s1,
      d1_pio_1_s1_end_xfer => d1_pio_1_s1_end_xfer,
      pio_1_s1_address => pio_1_s1_address,
      pio_1_s1_chipselect => pio_1_s1_chipselect,
      pio_1_s1_reset_n => pio_1_s1_reset_n,
      pio_1_s1_write_n => pio_1_s1_write_n,
      pio_1_s1_writedata => pio_1_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_pio_1, which is an e_ptf_instance
  the_pio_1 : pio_1
    port map(
      out_port => internal_out_port_from_the_pio_1,
      address => pio_1_s1_address,
      chipselect => pio_1_s1_chipselect,
      clk => clk,
      reset_n => pio_1_s1_reset_n,
      write_n => pio_1_s1_write_n,
      writedata => pio_1_s1_writedata
    );


  --the_pio_2_s1, which is an e_instance
  the_pio_2_s1 : pio_2_s1_arbitrator
    port map(
      cpu_data_master_granted_pio_2_s1 => cpu_data_master_granted_pio_2_s1,
      cpu_data_master_qualified_request_pio_2_s1 => cpu_data_master_qualified_request_pio_2_s1,
      cpu_data_master_read_data_valid_pio_2_s1 => cpu_data_master_read_data_valid_pio_2_s1,
      cpu_data_master_requests_pio_2_s1 => cpu_data_master_requests_pio_2_s1,
      d1_pio_2_s1_end_xfer => d1_pio_2_s1_end_xfer,
      pio_2_s1_address => pio_2_s1_address,
      pio_2_s1_chipselect => pio_2_s1_chipselect,
      pio_2_s1_reset_n => pio_2_s1_reset_n,
      pio_2_s1_write_n => pio_2_s1_write_n,
      pio_2_s1_writedata => pio_2_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_pio_2, which is an e_ptf_instance
  the_pio_2 : pio_2
    port map(
      out_port => internal_out_port_from_the_pio_2,
      address => pio_2_s1_address,
      chipselect => pio_2_s1_chipselect,
      clk => clk,
      reset_n => pio_2_s1_reset_n,
      write_n => pio_2_s1_write_n,
      writedata => pio_2_s1_writedata
    );


  --the_pio_3_s1, which is an e_instance
  the_pio_3_s1 : pio_3_s1_arbitrator
    port map(
      cpu_data_master_granted_pio_3_s1 => cpu_data_master_granted_pio_3_s1,
      cpu_data_master_qualified_request_pio_3_s1 => cpu_data_master_qualified_request_pio_3_s1,
      cpu_data_master_read_data_valid_pio_3_s1 => cpu_data_master_read_data_valid_pio_3_s1,
      cpu_data_master_requests_pio_3_s1 => cpu_data_master_requests_pio_3_s1,
      d1_pio_3_s1_end_xfer => d1_pio_3_s1_end_xfer,
      pio_3_s1_address => pio_3_s1_address,
      pio_3_s1_chipselect => pio_3_s1_chipselect,
      pio_3_s1_reset_n => pio_3_s1_reset_n,
      pio_3_s1_write_n => pio_3_s1_write_n,
      pio_3_s1_writedata => pio_3_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_pio_3, which is an e_ptf_instance
  the_pio_3 : pio_3
    port map(
      out_port => internal_out_port_from_the_pio_3,
      address => pio_3_s1_address,
      chipselect => pio_3_s1_chipselect,
      clk => clk,
      reset_n => pio_3_s1_reset_n,
      write_n => pio_3_s1_write_n,
      writedata => pio_3_s1_writedata
    );


  --the_pio_4_s1, which is an e_instance
  the_pio_4_s1 : pio_4_s1_arbitrator
    port map(
      cpu_data_master_granted_pio_4_s1 => cpu_data_master_granted_pio_4_s1,
      cpu_data_master_qualified_request_pio_4_s1 => cpu_data_master_qualified_request_pio_4_s1,
      cpu_data_master_read_data_valid_pio_4_s1 => cpu_data_master_read_data_valid_pio_4_s1,
      cpu_data_master_requests_pio_4_s1 => cpu_data_master_requests_pio_4_s1,
      d1_pio_4_s1_end_xfer => d1_pio_4_s1_end_xfer,
      pio_4_s1_address => pio_4_s1_address,
      pio_4_s1_chipselect => pio_4_s1_chipselect,
      pio_4_s1_reset_n => pio_4_s1_reset_n,
      pio_4_s1_write_n => pio_4_s1_write_n,
      pio_4_s1_writedata => pio_4_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_pio_4, which is an e_ptf_instance
  the_pio_4 : pio_4
    port map(
      out_port => internal_out_port_from_the_pio_4,
      address => pio_4_s1_address,
      chipselect => pio_4_s1_chipselect,
      clk => clk,
      reset_n => pio_4_s1_reset_n,
      write_n => pio_4_s1_write_n,
      writedata => pio_4_s1_writedata
    );


  --the_pio_5_s1, which is an e_instance
  the_pio_5_s1 : pio_5_s1_arbitrator
    port map(
      cpu_data_master_granted_pio_5_s1 => cpu_data_master_granted_pio_5_s1,
      cpu_data_master_qualified_request_pio_5_s1 => cpu_data_master_qualified_request_pio_5_s1,
      cpu_data_master_read_data_valid_pio_5_s1 => cpu_data_master_read_data_valid_pio_5_s1,
      cpu_data_master_requests_pio_5_s1 => cpu_data_master_requests_pio_5_s1,
      d1_pio_5_s1_end_xfer => d1_pio_5_s1_end_xfer,
      pio_5_s1_address => pio_5_s1_address,
      pio_5_s1_chipselect => pio_5_s1_chipselect,
      pio_5_s1_reset_n => pio_5_s1_reset_n,
      pio_5_s1_write_n => pio_5_s1_write_n,
      pio_5_s1_writedata => pio_5_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n
    );


  --the_pio_5, which is an e_ptf_instance
  the_pio_5 : pio_5
    port map(
      out_port => internal_out_port_from_the_pio_5,
      address => pio_5_s1_address,
      chipselect => pio_5_s1_chipselect,
      clk => clk,
      reset_n => pio_5_s1_reset_n,
      write_n => pio_5_s1_write_n,
      writedata => pio_5_s1_writedata
    );


  --the_sdram_s1, which is an e_instance
  the_sdram_s1 : sdram_s1_arbitrator
    port map(
      cpu_data_master_granted_sdram_s1 => cpu_data_master_granted_sdram_s1,
      cpu_data_master_qualified_request_sdram_s1 => cpu_data_master_qualified_request_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1 => cpu_data_master_read_data_valid_sdram_s1,
      cpu_data_master_read_data_valid_sdram_s1_shift_register => cpu_data_master_read_data_valid_sdram_s1_shift_register,
      cpu_data_master_requests_sdram_s1 => cpu_data_master_requests_sdram_s1,
      d1_sdram_s1_end_xfer => d1_sdram_s1_end_xfer,
      sdram_s1_address => sdram_s1_address,
      sdram_s1_byteenable_n => sdram_s1_byteenable_n,
      sdram_s1_chipselect => sdram_s1_chipselect,
      sdram_s1_read_n => sdram_s1_read_n,
      sdram_s1_readdata_from_sa => sdram_s1_readdata_from_sa,
      sdram_s1_reset_n => sdram_s1_reset_n,
      sdram_s1_waitrequest_from_sa => sdram_s1_waitrequest_from_sa,
      sdram_s1_write_n => sdram_s1_write_n,
      sdram_s1_writedata => sdram_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      sdram_s1_readdata => sdram_s1_readdata,
      sdram_s1_readdatavalid => sdram_s1_readdatavalid,
      sdram_s1_waitrequest => sdram_s1_waitrequest
    );


  --the_sdram, which is an e_ptf_instance
  the_sdram : sdram
    port map(
      za_data => sdram_s1_readdata,
      za_valid => sdram_s1_readdatavalid,
      za_waitrequest => sdram_s1_waitrequest,
      zs_addr => internal_zs_addr_from_the_sdram,
      zs_ba => internal_zs_ba_from_the_sdram,
      zs_cas_n => internal_zs_cas_n_from_the_sdram,
      zs_cke => internal_zs_cke_from_the_sdram,
      zs_cs_n => internal_zs_cs_n_from_the_sdram,
      zs_dq => zs_dq_to_and_from_the_sdram,
      zs_dqm => internal_zs_dqm_from_the_sdram,
      zs_ras_n => internal_zs_ras_n_from_the_sdram,
      zs_we_n => internal_zs_we_n_from_the_sdram,
      az_addr => sdram_s1_address,
      az_be_n => sdram_s1_byteenable_n,
      az_cs => sdram_s1_chipselect,
      az_data => sdram_s1_writedata,
      az_rd_n => sdram_s1_read_n,
      az_wr_n => sdram_s1_write_n,
      clk => clk,
      reset_n => sdram_s1_reset_n
    );


  --the_sysid_control_slave, which is an e_instance
  the_sysid_control_slave : sysid_control_slave_arbitrator
    port map(
      cpu_data_master_granted_sysid_control_slave => cpu_data_master_granted_sysid_control_slave,
      cpu_data_master_qualified_request_sysid_control_slave => cpu_data_master_qualified_request_sysid_control_slave,
      cpu_data_master_read_data_valid_sysid_control_slave => cpu_data_master_read_data_valid_sysid_control_slave,
      cpu_data_master_requests_sysid_control_slave => cpu_data_master_requests_sysid_control_slave,
      d1_sysid_control_slave_end_xfer => d1_sysid_control_slave_end_xfer,
      sysid_control_slave_address => sysid_control_slave_address,
      sysid_control_slave_readdata_from_sa => sysid_control_slave_readdata_from_sa,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      reset_n => clk_reset_n,
      sysid_control_slave_readdata => sysid_control_slave_readdata
    );


  --the_sysid, which is an e_ptf_instance
  the_sysid : sysid
    port map(
      readdata => sysid_control_slave_readdata,
      address => sysid_control_slave_address
    );


  --the_tightly_coupled_data_memory_s1, which is an e_instance
  the_tightly_coupled_data_memory_s1 : tightly_coupled_data_memory_s1_arbitrator
    port map(
      cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_granted_tightly_coupled_data_memory_s1,
      cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_qualified_request_tightly_coupled_data_memory_s1,
      cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_read_data_valid_tightly_coupled_data_memory_s1,
      cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1 => cpu_tightly_coupled_data_master_0_requests_tightly_coupled_data_memory_s1,
      d1_tightly_coupled_data_memory_s1_end_xfer => d1_tightly_coupled_data_memory_s1_end_xfer,
      tightly_coupled_data_memory_s1_address => tightly_coupled_data_memory_s1_address,
      tightly_coupled_data_memory_s1_byteenable => tightly_coupled_data_memory_s1_byteenable,
      tightly_coupled_data_memory_s1_chipselect => tightly_coupled_data_memory_s1_chipselect,
      tightly_coupled_data_memory_s1_clken => tightly_coupled_data_memory_s1_clken,
      tightly_coupled_data_memory_s1_readdata_from_sa => tightly_coupled_data_memory_s1_readdata_from_sa,
      tightly_coupled_data_memory_s1_write => tightly_coupled_data_memory_s1_write,
      tightly_coupled_data_memory_s1_writedata => tightly_coupled_data_memory_s1_writedata,
      clk => clk,
      cpu_tightly_coupled_data_master_0_address_to_slave => cpu_tightly_coupled_data_master_0_address_to_slave,
      cpu_tightly_coupled_data_master_0_byteenable => cpu_tightly_coupled_data_master_0_byteenable,
      cpu_tightly_coupled_data_master_0_clken => cpu_tightly_coupled_data_master_0_clken,
      cpu_tightly_coupled_data_master_0_latency_counter => cpu_tightly_coupled_data_master_0_latency_counter,
      cpu_tightly_coupled_data_master_0_read => cpu_tightly_coupled_data_master_0_read,
      cpu_tightly_coupled_data_master_0_write => cpu_tightly_coupled_data_master_0_write,
      cpu_tightly_coupled_data_master_0_writedata => cpu_tightly_coupled_data_master_0_writedata,
      reset_n => clk_reset_n,
      tightly_coupled_data_memory_s1_readdata => tightly_coupled_data_memory_s1_readdata
    );


  --the_tightly_coupled_data_memory, which is an e_ptf_instance
  the_tightly_coupled_data_memory : tightly_coupled_data_memory
    port map(
      readdata => tightly_coupled_data_memory_s1_readdata,
      address => tightly_coupled_data_memory_s1_address,
      byteenable => tightly_coupled_data_memory_s1_byteenable,
      chipselect => tightly_coupled_data_memory_s1_chipselect,
      clk => clk,
      clken => tightly_coupled_data_memory_s1_clken,
      write => tightly_coupled_data_memory_s1_write,
      writedata => tightly_coupled_data_memory_s1_writedata
    );


  --the_tightly_coupled_instruction_memory_s1, which is an e_instance
  the_tightly_coupled_instruction_memory_s1 : tightly_coupled_instruction_memory_s1_arbitrator
    port map(
      cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_granted_tightly_coupled_instruction_memory_s1,
      cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_qualified_request_tightly_coupled_instruction_memory_s1,
      cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_read_data_valid_tightly_coupled_instruction_memory_s1,
      cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1 => cpu_tightly_coupled_instruction_master_0_requests_tightly_coupled_instruction_memory_s1,
      d1_tightly_coupled_instruction_memory_s1_end_xfer => d1_tightly_coupled_instruction_memory_s1_end_xfer,
      tightly_coupled_instruction_memory_s1_address => tightly_coupled_instruction_memory_s1_address,
      tightly_coupled_instruction_memory_s1_byteenable => tightly_coupled_instruction_memory_s1_byteenable,
      tightly_coupled_instruction_memory_s1_chipselect => tightly_coupled_instruction_memory_s1_chipselect,
      tightly_coupled_instruction_memory_s1_clken => tightly_coupled_instruction_memory_s1_clken,
      tightly_coupled_instruction_memory_s1_readdata_from_sa => tightly_coupled_instruction_memory_s1_readdata_from_sa,
      tightly_coupled_instruction_memory_s1_write => tightly_coupled_instruction_memory_s1_write,
      tightly_coupled_instruction_memory_s1_writedata => tightly_coupled_instruction_memory_s1_writedata,
      clk => clk,
      cpu_tightly_coupled_instruction_master_0_address_to_slave => cpu_tightly_coupled_instruction_master_0_address_to_slave,
      cpu_tightly_coupled_instruction_master_0_clken => cpu_tightly_coupled_instruction_master_0_clken,
      cpu_tightly_coupled_instruction_master_0_latency_counter => cpu_tightly_coupled_instruction_master_0_latency_counter,
      cpu_tightly_coupled_instruction_master_0_read => cpu_tightly_coupled_instruction_master_0_read,
      reset_n => clk_reset_n,
      tightly_coupled_instruction_memory_s1_readdata => tightly_coupled_instruction_memory_s1_readdata
    );


  --the_tightly_coupled_instruction_memory_s2, which is an e_instance
  the_tightly_coupled_instruction_memory_s2 : tightly_coupled_instruction_memory_s2_arbitrator
    port map(
      cpu_data_master_granted_tightly_coupled_instruction_memory_s2 => cpu_data_master_granted_tightly_coupled_instruction_memory_s2,
      cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2 => cpu_data_master_qualified_request_tightly_coupled_instruction_memory_s2,
      cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 => cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2,
      cpu_data_master_requests_tightly_coupled_instruction_memory_s2 => cpu_data_master_requests_tightly_coupled_instruction_memory_s2,
      d1_tightly_coupled_instruction_memory_s2_end_xfer => d1_tightly_coupled_instruction_memory_s2_end_xfer,
      registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2 => registered_cpu_data_master_read_data_valid_tightly_coupled_instruction_memory_s2,
      tightly_coupled_instruction_memory_s2_address => tightly_coupled_instruction_memory_s2_address,
      tightly_coupled_instruction_memory_s2_byteenable => tightly_coupled_instruction_memory_s2_byteenable,
      tightly_coupled_instruction_memory_s2_chipselect => tightly_coupled_instruction_memory_s2_chipselect,
      tightly_coupled_instruction_memory_s2_clken => tightly_coupled_instruction_memory_s2_clken,
      tightly_coupled_instruction_memory_s2_readdata_from_sa => tightly_coupled_instruction_memory_s2_readdata_from_sa,
      tightly_coupled_instruction_memory_s2_write => tightly_coupled_instruction_memory_s2_write,
      tightly_coupled_instruction_memory_s2_writedata => tightly_coupled_instruction_memory_s2_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      tightly_coupled_instruction_memory_s2_readdata => tightly_coupled_instruction_memory_s2_readdata
    );


  --the_tightly_coupled_instruction_memory, which is an e_ptf_instance
  the_tightly_coupled_instruction_memory : tightly_coupled_instruction_memory
    port map(
      readdata => tightly_coupled_instruction_memory_s1_readdata,
      readdata2 => tightly_coupled_instruction_memory_s2_readdata,
      address => tightly_coupled_instruction_memory_s1_address,
      address2 => tightly_coupled_instruction_memory_s2_address,
      byteenable => tightly_coupled_instruction_memory_s1_byteenable,
      byteenable2 => tightly_coupled_instruction_memory_s2_byteenable,
      chipselect => tightly_coupled_instruction_memory_s1_chipselect,
      chipselect2 => tightly_coupled_instruction_memory_s2_chipselect,
      clk => clk,
      clk2 => clk,
      clken => tightly_coupled_instruction_memory_s1_clken,
      clken2 => tightly_coupled_instruction_memory_s2_clken,
      write => tightly_coupled_instruction_memory_s1_write,
      write2 => tightly_coupled_instruction_memory_s2_write,
      writedata => tightly_coupled_instruction_memory_s1_writedata,
      writedata2 => tightly_coupled_instruction_memory_s2_writedata
    );


  --the_timer_s1, which is an e_instance
  the_timer_s1 : timer_s1_arbitrator
    port map(
      cpu_data_master_granted_timer_s1 => cpu_data_master_granted_timer_s1,
      cpu_data_master_qualified_request_timer_s1 => cpu_data_master_qualified_request_timer_s1,
      cpu_data_master_read_data_valid_timer_s1 => cpu_data_master_read_data_valid_timer_s1,
      cpu_data_master_requests_timer_s1 => cpu_data_master_requests_timer_s1,
      d1_timer_s1_end_xfer => d1_timer_s1_end_xfer,
      timer_s1_address => timer_s1_address,
      timer_s1_chipselect => timer_s1_chipselect,
      timer_s1_irq_from_sa => timer_s1_irq_from_sa,
      timer_s1_readdata_from_sa => timer_s1_readdata_from_sa,
      timer_s1_reset_n => timer_s1_reset_n,
      timer_s1_write_n => timer_s1_write_n,
      timer_s1_writedata => timer_s1_writedata,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata,
      reset_n => clk_reset_n,
      timer_s1_irq => timer_s1_irq,
      timer_s1_readdata => timer_s1_readdata
    );


  --the_timer, which is an e_ptf_instance
  the_timer : timer
    port map(
      irq => timer_s1_irq,
      readdata => timer_s1_readdata,
      address => timer_s1_address,
      chipselect => timer_s1_chipselect,
      clk => clk,
      reset_n => timer_s1_reset_n,
      write_n => timer_s1_write_n,
      writedata => timer_s1_writedata
    );


  --the_tri_state_bridge_avalon_slave, which is an e_instance
  the_tri_state_bridge_avalon_slave : tri_state_bridge_avalon_slave_arbitrator
    port map(
      cpu_data_master_byteenable_flash_s1 => cpu_data_master_byteenable_flash_s1,
      cpu_data_master_granted_flash_s1 => cpu_data_master_granted_flash_s1,
      cpu_data_master_qualified_request_flash_s1 => cpu_data_master_qualified_request_flash_s1,
      cpu_data_master_read_data_valid_flash_s1 => cpu_data_master_read_data_valid_flash_s1,
      cpu_data_master_requests_flash_s1 => cpu_data_master_requests_flash_s1,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      flash_s1_wait_counter_eq_0 => flash_s1_wait_counter_eq_0,
      flash_s1_wait_counter_eq_1 => flash_s1_wait_counter_eq_1,
      incoming_tri_state_bridge_data_with_Xs_converted_to_0 => incoming_tri_state_bridge_data_with_Xs_converted_to_0,
      registered_cpu_data_master_read_data_valid_flash_s1 => registered_cpu_data_master_read_data_valid_flash_s1,
      select_n_to_the_flash => internal_select_n_to_the_flash,
      tri_state_bridge_address => internal_tri_state_bridge_address,
      tri_state_bridge_data => tri_state_bridge_data,
      tri_state_bridge_readn => internal_tri_state_bridge_readn,
      write_n_to_the_flash => internal_write_n_to_the_flash,
      clk => clk,
      cpu_data_master_address_to_slave => cpu_data_master_address_to_slave,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      cpu_data_master_dbs_address => cpu_data_master_dbs_address,
      cpu_data_master_dbs_write_8 => cpu_data_master_dbs_write_8,
      cpu_data_master_no_byte_enables_and_last_term => cpu_data_master_no_byte_enables_and_last_term,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_write => cpu_data_master_write,
      reset_n => clk_reset_n
    );


  --reset is asserted asynchronously and deasserted synchronously
  nios2_sys_reset_clk_domain_synch : nios2_sys_reset_clk_domain_synch_module
    port map(
      data_out => clk_reset_n,
      clk => clk,
      data_in => module_input3,
      reset_n => reset_n_sources
    );

  module_input3 <= std_logic'('1');

  --reset sources mux, which is an e_mux
  reset_n_sources <= Vector_To_Std_Logic(NOT (((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(NOT reset_n))) OR std_logic_vector'("00000000000000000000000000000000")) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa)))) OR (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(cpu_jtag_debug_module_resetrequest_from_sa))))));
  --vhdl renameroo for output signals
  CMD_from_the_DM9000A <= internal_CMD_from_the_DM9000A;
  --vhdl renameroo for output signals
  CS_n_from_the_DM9000A <= internal_CS_n_from_the_DM9000A;
  --vhdl renameroo for output signals
  IORD_n_from_the_DM9000A <= internal_IORD_n_from_the_DM9000A;
  --vhdl renameroo for output signals
  RST_n_from_the_DM9000A <= internal_RST_n_from_the_DM9000A;
  --vhdl renameroo for output signals
  out_port_from_the_leds <= internal_out_port_from_the_leds;
  --vhdl renameroo for output signals
  out_port_from_the_pio_0 <= internal_out_port_from_the_pio_0;
  --vhdl renameroo for output signals
  out_port_from_the_pio_1 <= internal_out_port_from_the_pio_1;
  --vhdl renameroo for output signals
  out_port_from_the_pio_2 <= internal_out_port_from_the_pio_2;
  --vhdl renameroo for output signals
  out_port_from_the_pio_3 <= internal_out_port_from_the_pio_3;
  --vhdl renameroo for output signals
  out_port_from_the_pio_4 <= internal_out_port_from_the_pio_4;
  --vhdl renameroo for output signals
  out_port_from_the_pio_5 <= internal_out_port_from_the_pio_5;
  --vhdl renameroo for output signals
  select_n_to_the_flash <= internal_select_n_to_the_flash;
  --vhdl renameroo for output signals
  tri_state_bridge_address <= internal_tri_state_bridge_address;
  --vhdl renameroo for output signals
  tri_state_bridge_readn <= internal_tri_state_bridge_readn;
  --vhdl renameroo for output signals
  write_n_to_the_flash <= internal_write_n_to_the_flash;
  --vhdl renameroo for output signals
  zs_addr_from_the_sdram <= internal_zs_addr_from_the_sdram;
  --vhdl renameroo for output signals
  zs_ba_from_the_sdram <= internal_zs_ba_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cas_n_from_the_sdram <= internal_zs_cas_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cke_from_the_sdram <= internal_zs_cke_from_the_sdram;
  --vhdl renameroo for output signals
  zs_cs_n_from_the_sdram <= internal_zs_cs_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_dqm_from_the_sdram <= internal_zs_dqm_from_the_sdram;
  --vhdl renameroo for output signals
  zs_ras_n_from_the_sdram <= internal_zs_ras_n_from_the_sdram;
  --vhdl renameroo for output signals
  zs_we_n_from_the_sdram <= internal_zs_we_n_from_the_sdram;

end europa;


--synthesis translate_off

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity flash_lane0_module is 
        port (
              -- inputs:
                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal rdaddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal rdclken : IN STD_LOGIC;
                 signal wraddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal wrclock : IN STD_LOGIC;
                 signal wren : IN STD_LOGIC;

              -- outputs:
                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity flash_lane0_module;


architecture europa of flash_lane0_module is
              signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              TYPE mem_array is ARRAY( 16777215 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
              signal memory_has_been_read :  STD_LOGIC;
              signal read_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);

      
FUNCTION convert_string_to_number(string_to_convert : STRING;
      final_char_index : NATURAL := 0)
RETURN NATURAL IS
   VARIABLE result: NATURAL := 0;
   VARIABLE current_index : NATURAL := 1;
   VARIABLE the_char : CHARACTER;

   BEGIN
      IF final_char_index = 0 THEN
         result := 0;
	 ELSE
         WHILE current_index <= final_char_index LOOP
            the_char := string_to_convert(current_index);
            IF    '0' <= the_char AND the_char <= '9' THEN
               result := result * 16 + character'pos(the_char) - character'pos('0');
            ELSIF 'A' <= the_char AND the_char <= 'F' THEN
               result := result * 16 + character'pos(the_char) - character'pos('A') + 10;
            ELSIF 'a' <= the_char AND the_char <= 'f' THEN
               result := result * 16 + character'pos(the_char) - character'pos('a') + 10;
            ELSE
               report "Ack, a formatting error!";
            END IF;
            current_index := current_index + 1;
         END LOOP;
      END IF; 
   RETURN result;
END convert_string_to_number;

 FUNCTION convert_string_to_std_logic(value : STRING; num_chars : INTEGER; mem_width_bits : INTEGER)
 RETURN STD_LOGIC_VECTOR is			   
     VARIABLE conv_string: std_logic_vector((mem_width_bits + 4)-1 downto 0);
     VARIABLE result : std_logic_vector((mem_width_bits -1) downto 0);
     VARIABLE curr_char : integer;
              
     BEGIN
     result := (others => '0');
     conv_string := (others => '0');
     
          FOR I IN 1 TO num_chars LOOP
	     curr_char := num_chars - (I-1);

             CASE value(I) IS
               WHEN '0' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0000";
               WHEN '1' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0001";
               WHEN '2' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0010";
               WHEN '3' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0011";
               WHEN '4' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0100";
               WHEN '5' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0101";
               WHEN '6' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0110";
               WHEN '7' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "0111";
               WHEN '8' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1000";
               WHEN '9' =>  conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1001";
               WHEN 'A' | 'a' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1010";
               WHEN 'B' | 'b' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1011";
               WHEN 'C' | 'c' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1100";
               WHEN 'D' | 'd' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1101";
               WHEN 'E' | 'e' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1110";
               WHEN 'F' | 'f' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "1111";
               WHEN 'X' | 'x' => conv_string((4*curr_char)-1  DOWNTO 4*(curr_char-1)) := "XXXX";
               WHEN ' ' => EXIT;
               WHEN HT  => exit;
               WHEN others =>
                  ASSERT False
                  REPORT "function From_Hex: string """ & value & """ contains non-hex character"
                       severity Error;
                  EXIT;
               END case;
            END loop;

          -- convert back to normal bit size
          result(mem_width_bits - 1 downto 0) := conv_string(mem_width_bits - 1 downto 0);

          RETURN result;
        END convert_string_to_std_logic;



begin
   process (wrclock, rdaddress) -- MG
    VARIABLE data_line : LINE;
    VARIABLE the_character_from_data_line : CHARACTER;
    VARIABLE b_munging_address : BOOLEAN := FALSE;
    VARIABLE converted_number : NATURAL := 0;
    VARIABLE found_string_array : STRING(1 TO 128);
    VARIABLE string_index : NATURAL := 0;
    VARIABLE line_length : NATURAL := 0;
    VARIABLE b_convert : BOOLEAN := FALSE;
    VARIABLE b_found_new_val : BOOLEAN := FALSE;
    VARIABLE load_address : NATURAL := 0;
    VARIABLE mem_index : NATURAL := 0;
    VARIABLE mem_init : BOOLEAN := FALSE;

    VARIABLE wr_address_internal : STD_LOGIC_VECTOR (23 DOWNTO 0) := (others => '0');
    FILE memory_contents_file : TEXT OPEN read_mode IS "flash.dat";  
    variable Marc_Gaucherons_Memory_Variable : mem_array; -- MG
    
    begin
   -- need an initialization process
   -- this process initializes the whole memory array from a named file by copying the
   -- contents of the *.dat file to the memory array.

   -- find the @<address> thingy to load the memory from this point 
IF(NOT mem_init) THEN
   WHILE NOT(endfile(memory_contents_file)) LOOP

      readline(memory_contents_file, data_line);
      line_length := data_line'LENGTH;


      WHILE line_length > 0 LOOP
         read(data_line, the_character_from_data_line);

	       -- check for the @ character indicating a new address wad
 	       -- if not found, we're either still reading the new address _or_loading data
         IF '@' = the_character_from_data_line AND NOT b_munging_address THEN
  	    b_munging_address := TRUE;
            b_found_new_val := TRUE; 
	    -- get the rest of characters before white space and then convert them
	    -- to a number
	 ELSE 

            IF (' ' = the_character_from_data_line AND b_found_new_val) 
		OR (line_length = 1) THEN
               b_convert := TRUE;
	    END IF;

            IF NOT(' ' = the_character_from_data_line) THEN
               string_index := string_index + 1;
               found_string_array(string_index) := the_character_from_data_line;
--               IF NOT(b_munging_address) THEN
--                 dat_string_array(string_index) := the_character_from_data_line;
--               END IF;
	       b_found_new_val := TRUE;
            END IF;
	 END IF;

     IF b_convert THEN

       IF b_munging_address THEN
          converted_number := convert_string_to_number(found_string_array, string_index);    
          load_address := converted_number;
          mem_index := load_address;
--          mem_index := load_address / 1;
          b_munging_address := FALSE;
       ELSE
	  IF (mem_index < 16777216) THEN
	    Marc_Gaucherons_Memory_Variable(mem_index) := convert_string_to_std_logic(found_string_array, string_index, 8);
            mem_index := mem_index + 1;
          END IF;
       END IF; 
       b_convert := FALSE;
       b_found_new_val := FALSE;
       string_index := 0;
    END IF;
    line_length := line_length - 1; 
    END LOOP;

END LOOP;
-- get the first _real_ block of data, sized to our memory width
-- and keep on loading.
  mem_init := TRUE;
END IF;
-- END OF READMEM



      -- Write data
      if wrclock'event and wrclock = '1' then
        wr_address_internal := wraddress;
        if wren = '1' then 
          Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(wr_address_internal))) := data;
        end if;
      end if;

      -- read data
      q <= Marc_Gaucherons_Memory_Variable(CONV_INTEGER(UNSIGNED(rdaddress)));
      


    end process;
end europa;

--synthesis translate_on


--synthesis read_comments_as_HDL on
--library altera;
--use altera.altera_europa_support_lib.all;
--
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.std_logic_arith.all;
--use ieee.std_logic_unsigned.all;
--
--library std;
--use std.textio.all;
--
--entity flash_lane0_module is 
--        port (
--              
--                 signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--                 signal rdaddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
--                 signal rdclken : IN STD_LOGIC;
--                 signal wraddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
--                 signal wrclock : IN STD_LOGIC;
--                 signal wren : IN STD_LOGIC;
--
--              
--                 signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
--              );
--end entity flash_lane0_module;
--
--
--architecture europa of flash_lane0_module is
--  component lpm_ram_dp is
--GENERIC (
--      lpm_file : STRING;
--        lpm_hint : STRING;
--        lpm_indata : STRING;
--        lpm_outdata : STRING;
--        lpm_rdaddress_control : STRING;
--        lpm_width : NATURAL;
--        lpm_widthad : NATURAL;
--        lpm_wraddress_control : STRING;
--        suppress_memory_conversion_warnings : STRING
--      );
--    PORT (
--    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal rdaddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
--        signal wren : IN STD_LOGIC;
--        signal wrclock : IN STD_LOGIC;
--        signal wraddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
--        signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
--        signal rdclken : IN STD_LOGIC
--      );
--  end component lpm_ram_dp;
--                signal internal_q :  STD_LOGIC_VECTOR (7 DOWNTO 0);
--                TYPE mem_array is ARRAY( 16777215 DOWNTO 0) of STD_LOGIC_VECTOR(7 DOWNTO 0);
--                signal memory_has_been_read :  STD_LOGIC;
--                signal read_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
--
--begin
--
--  process (rdaddress)
--  begin
--      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
--        read_address <= rdaddress;
--      end if;
--
--  end process;
--
--  lpm_ram_dp_component : lpm_ram_dp
--    generic map(
--      lpm_file => "flash.mif",
--      lpm_hint => "USE_EAB=ON",
--      lpm_indata => "REGISTERED",
--      lpm_outdata => "UNREGISTERED",
--      lpm_rdaddress_control => "UNREGISTERED",
--      lpm_width => 8,
--      lpm_widthad => 24,
--      lpm_wraddress_control => "REGISTERED",
--      suppress_memory_conversion_warnings => "ON"
--    )
--    port map(
--            data => data,
--            q => internal_q,
--            rdaddress => read_address,
--            rdclken => rdclken,
--            wraddress => wraddress,
--            wrclock => wrclock,
--            wren => wren
--    );
--
--  
--  q <= internal_q;
--end europa;
--
--synthesis read_comments_as_HDL off


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity flash is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity flash;


architecture europa of flash is
--synthesis translate_off
component flash_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component flash_lane0_module;

--synthesis translate_on
                signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal logic_vector_gasket :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal module_input4 :  STD_LOGIC;
                signal module_input5 :  STD_LOGIC;
                signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

  --s1, which is an e_ptf_slave
--synthesis translate_off
    logic_vector_gasket <= data;
    data_0 <= logic_vector_gasket(7 DOWNTO 0);
    --flash_lane0, which is an e_ram
    flash_lane0 : flash_lane0_module
      port map(
        q => q_0,
        data => data_0,
        rdaddress => address,
        rdclken => module_input4,
        wraddress => address,
        wrclock => write_n,
        wren => module_input5
      );

    module_input4 <= std_logic'('1');
    module_input5 <= NOT select_n;

    data <= A_WE_StdLogicVector((std_logic'(((NOT select_n AND NOT read_n))) = '1'), q_0, A_REP(std_logic'('Z'), 8));
--synthesis translate_on

end europa;


--synthesis translate_off

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your libraries here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>

entity test_bench is 
end entity test_bench;


architecture europa of test_bench is
component nios2_sys is 
           port (
                 -- 1) global signals:
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- the_DM9000A
                    signal CMD_from_the_DM9000A : OUT STD_LOGIC;
                    signal CS_n_from_the_DM9000A : OUT STD_LOGIC;
                    signal INT_to_the_DM9000A : IN STD_LOGIC;
                    signal IORD_n_from_the_DM9000A : OUT STD_LOGIC;
                    signal IOWR_n_to_and_from_the_DM9000A : INOUT STD_LOGIC;
                    signal RST_n_from_the_DM9000A : OUT STD_LOGIC;
                    signal data_to_and_from_the_DM9000A : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- the_leds
                    signal out_port_from_the_leds : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);

                 -- the_pio_0
                    signal out_port_from_the_pio_0 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- the_pio_1
                    signal out_port_from_the_pio_1 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- the_pio_2
                    signal out_port_from_the_pio_2 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- the_pio_3
                    signal out_port_from_the_pio_3 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- the_pio_4
                    signal out_port_from_the_pio_4 : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- the_pio_5
                    signal out_port_from_the_pio_5 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);

                 -- the_sdram
                    signal zs_addr_from_the_sdram : OUT STD_LOGIC_VECTOR (12 DOWNTO 0);
                    signal zs_ba_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_cke_from_the_sdram : OUT STD_LOGIC;
                    signal zs_cs_n_from_the_sdram : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_dq_to_and_from_the_sdram : INOUT STD_LOGIC_VECTOR (63 DOWNTO 0);
                    signal zs_dqm_from_the_sdram : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal zs_ras_n_from_the_sdram : OUT STD_LOGIC;
                    signal zs_we_n_from_the_sdram : OUT STD_LOGIC;

                 -- the_tri_state_bridge_avalon_slave
                    signal select_n_to_the_flash : OUT STD_LOGIC;
                    signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal tri_state_bridge_readn : OUT STD_LOGIC;
                    signal write_n_to_the_flash : OUT STD_LOGIC
                 );
end component nios2_sys;

component flash is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component flash;

component sdram_test_component is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal zs_addr : IN STD_LOGIC_VECTOR (12 DOWNTO 0);
                    signal zs_ba : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_cas_n : IN STD_LOGIC;
                    signal zs_cke : IN STD_LOGIC;
                    signal zs_cs_n : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal zs_dqm : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal zs_ras_n : IN STD_LOGIC;
                    signal zs_we_n : IN STD_LOGIC;

                 -- outputs:
                    signal zs_dq : INOUT STD_LOGIC_VECTOR (63 DOWNTO 0)
                 );
end component sdram_test_component;

                signal CMD_from_the_DM9000A :  STD_LOGIC;
                signal CS_n_from_the_DM9000A :  STD_LOGIC;
                signal INT_to_the_DM9000A :  STD_LOGIC;
                signal IORD_n_from_the_DM9000A :  STD_LOGIC;
                signal IOWR_n_to_and_from_the_DM9000A :  STD_LOGIC;
                signal RST_n_from_the_DM9000A :  STD_LOGIC;
                signal clk :  STD_LOGIC;
                signal data_to_and_from_the_DM9000A :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal jtag_uart_avalon_jtag_slave_dataavailable_from_sa :  STD_LOGIC;
                signal jtag_uart_avalon_jtag_slave_readyfordata_from_sa :  STD_LOGIC;
                signal out_port_from_the_leds :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal out_port_from_the_pio_0 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal out_port_from_the_pio_1 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal out_port_from_the_pio_2 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal out_port_from_the_pio_3 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal out_port_from_the_pio_4 :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal out_port_from_the_pio_5 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal reset_n :  STD_LOGIC;
                signal select_n_to_the_flash :  STD_LOGIC;
                signal tri_state_bridge_address :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal tri_state_bridge_data :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal tri_state_bridge_readn :  STD_LOGIC;
                signal write_n_to_the_flash :  STD_LOGIC;
                signal zs_addr_from_the_sdram :  STD_LOGIC_VECTOR (12 DOWNTO 0);
                signal zs_ba_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal zs_cas_n_from_the_sdram :  STD_LOGIC;
                signal zs_cke_from_the_sdram :  STD_LOGIC;
                signal zs_cs_n_from_the_sdram :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal zs_dq_to_and_from_the_sdram :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal zs_dqm_from_the_sdram :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal zs_ras_n_from_the_sdram :  STD_LOGIC;
                signal zs_we_n_from_the_sdram :  STD_LOGIC;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your component and signal declaration here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


begin

  --Set us up the Dut
  DUT : nios2_sys
    port map(
      CMD_from_the_DM9000A => CMD_from_the_DM9000A,
      CS_n_from_the_DM9000A => CS_n_from_the_DM9000A,
      IORD_n_from_the_DM9000A => IORD_n_from_the_DM9000A,
      IOWR_n_to_and_from_the_DM9000A => IOWR_n_to_and_from_the_DM9000A,
      RST_n_from_the_DM9000A => RST_n_from_the_DM9000A,
      data_to_and_from_the_DM9000A => data_to_and_from_the_DM9000A,
      out_port_from_the_leds => out_port_from_the_leds,
      out_port_from_the_pio_0 => out_port_from_the_pio_0,
      out_port_from_the_pio_1 => out_port_from_the_pio_1,
      out_port_from_the_pio_2 => out_port_from_the_pio_2,
      out_port_from_the_pio_3 => out_port_from_the_pio_3,
      out_port_from_the_pio_4 => out_port_from_the_pio_4,
      out_port_from_the_pio_5 => out_port_from_the_pio_5,
      select_n_to_the_flash => select_n_to_the_flash,
      tri_state_bridge_address => tri_state_bridge_address,
      tri_state_bridge_data => tri_state_bridge_data,
      tri_state_bridge_readn => tri_state_bridge_readn,
      write_n_to_the_flash => write_n_to_the_flash,
      zs_addr_from_the_sdram => zs_addr_from_the_sdram,
      zs_ba_from_the_sdram => zs_ba_from_the_sdram,
      zs_cas_n_from_the_sdram => zs_cas_n_from_the_sdram,
      zs_cke_from_the_sdram => zs_cke_from_the_sdram,
      zs_cs_n_from_the_sdram => zs_cs_n_from_the_sdram,
      zs_dq_to_and_from_the_sdram => zs_dq_to_and_from_the_sdram,
      zs_dqm_from_the_sdram => zs_dqm_from_the_sdram,
      zs_ras_n_from_the_sdram => zs_ras_n_from_the_sdram,
      zs_we_n_from_the_sdram => zs_we_n_from_the_sdram,
      INT_to_the_DM9000A => INT_to_the_DM9000A,
      clk => clk,
      reset_n => reset_n
    );


  --the_flash, which is an e_ptf_instance
  the_flash : flash
    port map(
      data => tri_state_bridge_data,
      address => tri_state_bridge_address,
      read_n => tri_state_bridge_readn,
      select_n => select_n_to_the_flash,
      write_n => write_n_to_the_flash
    );


  --the_sdram_test_component, which is an e_instance
  the_sdram_test_component : sdram_test_component
    port map(
      zs_dq => zs_dq_to_and_from_the_sdram,
      clk => clk,
      zs_addr => zs_addr_from_the_sdram,
      zs_ba => zs_ba_from_the_sdram,
      zs_cas_n => zs_cas_n_from_the_sdram,
      zs_cke => zs_cke_from_the_sdram,
      zs_cs_n => zs_cs_n_from_the_sdram,
      zs_dqm => zs_dqm_from_the_sdram,
      zs_ras_n => zs_ras_n_from_the_sdram,
      zs_we_n => zs_we_n_from_the_sdram
    );


  process
  begin
    clk <= '0';
    loop
       wait for 5 ns;
       clk <= not clk;
    end loop;
  end process;
  PROCESS
    BEGIN
       reset_n <= '0';
       wait for 100 ns;
       reset_n <= '1'; 
    WAIT;
  END PROCESS;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add additional architecture here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


end europa;



--synthesis translate_on
